﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualBasic.PowerPacks;
using ConocoPhillips.PHA.BLL;
using ConocoPhillips.PHA.Utils;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;
using ConocoPhillips.PHA.UI.CustomControls;
using System.Windows.Forms.DataVisualization.Charting;

namespace ConocoPhillips.PHA.UI
{
    public partial class frmScenarioDetails : PHAMaster
    {
        private Dictionary<Control, bool> dctScenarioDetailChanges = new Dictionary<Control, bool>();
        private Dictionary<int, Dictionary<int, Panel>> dctEnvGridPanels = new Dictionary<int, Dictionary<int, Panel>>();
        public Model.PHA ActivePHA { get; set; }
        private TextBox tbMirIndicatorNeedleRiskTab = null;//text control is used as a vertical needle in the control
        private TextBox tbMirIndicatorNeedleHdr = null;//text control is used as a vertical needle in the control
        private TextBox tbFINIndicatorNeedle = null;//text control is used as a vertical needle on the financial risks bar control
        private TableLayoutPanel tpFINChart = null; //keep handle to refresh this chart per Scenario
        private UltraDropDown uddEventType = new UltraDropDown();
        UltraDropDown uddLocations = new UltraDropDown();
        UltraDropDown uddDependencyTypes = new UltraDropDown();
        //  private DataSet dsLookupTables = null;
        private DataSet dsScenarioDetails = null;
       // private DataTable dtAssociatedScenarios = null;
        private DataSet dsScenarioFindings = null;
        private Guid activeScenarioID = Guid.Empty;
        private int ComputedRiskRank = 0;
        private double fldSocRiskVal = 0.0;//hold computed frequency for Societal risks
        private double fldMieRiskVal = 0.0;//hold computed frequency for MIE risks
        private double fldEnvRiskVal = 0.0;//hold computed frequency for Env risks
        private double fldFinRiskVal = 0.0;//hold computed frequency for Fin risks
        private List<Guid> AllScenarioUIDs = null;
        private BindingSource bsProtections = new BindingSource();
        private BindingSource scenarioPageBindingSource = new BindingSource();
        private BindingSource scenarioRecordBindingSource = new BindingSource();
        private BindingSource LocationBindingSource = new BindingSource();
        private UltraDropDown uddProtTypes = new UltraDropDown();
        private UltraDropDown uddProtUOM = new UltraDropDown();
        private UltraDropDown uddDependencyUOM = new UltraDropDown();
        private ImageList imageList = new ImageList();
        private UltraGrid ugProtectionUomDropDown = new UltraGrid();
        private UltraTextEditor uteProtectionSetpointUOM = new UltraTextEditor();
        private UltraGrid ugDependencyUomDropDown = new UltraGrid();
        private UltraTextEditor uteDependencySetpointUOM = new UltraTextEditor();
        private bool bCreatingNewScenario = false;
        private Guid CreateNewScenarioForNodeID;
        private DataTable dtScenarioNumbers = null;
        public frmScenarioDetails()
        {
            InitializeComponent();
        }
        public frmScenarioDetails(Guid p_scenarioUID, List<Guid> p_AllScenarioUIDs, bool p_AllowEdit, bool p_AllowApproval)
        {
        //add event handlers to track down unintended data changes 
         //   scenarioRecordBindingSource.CurrentChanged += new EventHandler(scenarioRecordBindingSource_CurrentChanged);
                    //add event handlers to track down unintended data changes 
         //   scenarioRecordBindingSource.CurrentItemChanged += new EventHandler(scenarioRecordBindingSource_CurrentItemChanged);


            imageList.Images.Add("Search", global::ConocoPhillips.PHA.UI.Properties.Resources.Search);

            AllowApproval = p_AllowApproval;
            AllowEdit = p_AllowEdit;
            activeScenarioID = p_scenarioUID;
            AllScenarioUIDs = p_AllScenarioUIDs;
            InitializeComponent();
            //force allow edit
            //this.AllowEdit = true;
            ugSetpointUomDropDownLists_Load();//initialize events and content for UOM drop down
        }
        public frmScenarioDetails(Guid p_NodeID, bool p_AllowEdit, bool p_AllowApproval)
        {
            //add event handlers to track down unintended data changes 
            //   scenarioRecordBindingSource.CurrentChanged += new EventHandler(scenarioRecordBindingSource_CurrentChanged);
            //add event handlers to track down unintended data changes 
            //   scenarioRecordBindingSource.CurrentItemChanged += new EventHandler(scenarioRecordBindingSource_CurrentItemChanged);

            bCreatingNewScenario = true;


            CreateNewScenarioForNodeID = p_NodeID;
            imageList.Images.Add("Search", global::ConocoPhillips.PHA.UI.Properties.Resources.Search);

            AllowApproval = p_AllowApproval;
            AllowEdit = p_AllowEdit;
            activeScenarioID = Guid.NewGuid();
            AllScenarioUIDs = new List<Guid>();
            InitializeComponent();
            //force allow edit
            //this.AllowEdit = true;
            ugSetpointUomDropDownLists_Load();//initialize events and content for UOM drop down
        }

        void scenarioRecordBindingSource_CurrentItemChanged(object sender, EventArgs e)
        {
            //what changed?
        }

        void scenarioRecordBindingSource_CurrentChanged(object sender, EventArgs e)
        {
            //what changed
            int i = 0;
        }
        private void initializeLookupLists()
        {
            //foreach(DataRow dr in ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtectionTypes").Rows)
            //{
            //    ProtTypes.ValueListItems.Add(dr["fldProtectionTypeCode"].ToString());
            //}
        }
        private void frmScenarioDetails_Load(object sender, EventArgs e)
        {

            
            initializeLookupLists();
            CreateRiskGraphics();
            //SetMirChartNeedle((float) 8.2);
            // uddEventType.Click += new EventHandler(uddEventType_Click); 
            scenarioPageBindingSource.DataSource = AllScenarioUIDs;
            int SelectedIndex = AllScenarioUIDs.IndexOf(activeScenarioID);
            bndNavScenarios.BindingSource = scenarioPageBindingSource;
            scenarioPageBindingSource.Position = SelectedIndex;
            if (bCreatingNewScenario)
            {
                MoveToNewScenario(false);
            }
            else
            {
                MovetoSelectedRecord();
            }
            //  LoadforScenario(activeScenarioID);// (273687);
            if (! this.Modal)
            {
                InitFormState(this);
            }
        }
        private void MoveToNewScenario(bool AddToSearchSet)
        {
            Guid gNewScenarioUID = Guid.NewGuid();
            //// GotoScenario(gNewScenarioUID);
            //dsScenarioDetails.Tables["tblIssues"].Rows[0]["fldNodeID"] = CreateNewScenarioForNodeID;
            if (CreateNewScenarioForNodeID == Guid.Empty)
            {
                //get node ID from previous scenario
                CreateNewScenarioForNodeID = (Guid)dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeID"];
            }
            dsScenarioDetails = GetScenarioDetailsForNewScenario(gNewScenarioUID, ActivePHA.PhaID, CreateNewScenarioForNodeID);
            DataRow drNewScenario = dsScenarioDetails.Tables["tblScenarios"].NewRow();
            drNewScenario["fldScenarioUID"] = gNewScenarioUID;
            drNewScenario["fldNodeID"] = CreateNewScenarioForNodeID;
            drNewScenario["fldModifiedDate"] = DateTime.Now;
            drNewScenario["fldScenarioNumber"] = dsScenarioDetails.Tables["tblNodes"].Rows[0]["NextScenarioNumber"];
            dsScenarioDetails.Tables["tblScenarios"].Rows.Add(drNewScenario);
            //dtAssociatedScenarios = GetAssociatedScenarios(gNewScenarioUID);
            dsScenarioFindings = GetScenarioFindings(gNewScenarioUID);
            AllScenarioUIDs.Add(gNewScenarioUID);
            scenarioPageBindingSource.DataSource = AllScenarioUIDs;
            int SelIndex = AllScenarioUIDs.IndexOf(activeScenarioID);
            bndNavScenarios.BindingSource = scenarioPageBindingSource;
            scenarioPageBindingSource.Position = SelIndex;
            //                scenarioPageBindingSource.MoveFirst();
            scenarioRecordBindingSource.MoveFirst();
            //disable some controls for create new scenario
            foreach (TabPage tp in tabScenarioDetals.TabPages)
            {
                if (tp == tpRelatedScenarios || tp == tpFindings)
                {
                    tp.Hide();
                }
            }
            if (AddToSearchSet)
            {

            }
            else
            {
                btnAddScenario.Visible = false;
                btnDeleteScenario.Visible = false;
                btnPrintScenario.Visible = false;
                btnCopyMoveScenario.Visible = false;
                bndNavScenarios.Hide();
            }
            bindForm();
        }
        private void beginScenarioRecordEdit()
        {
            //   dsScenarioDetails.Tables["tblScenarios"].Rows[0].BeginEdit();
        }
        private void bindForm()
        {
            dtpScenarioModDate.DataBindings.Clear();
            scenarioRecordBindingSource.DataSource = dsScenarioDetails;
            scenarioRecordBindingSource.DataMember = "tblScenarios";

            ResetRiskChart(pnlMIRContainer);
            ResetRiskChart(pnlMIRContainerHeader);
            ResetRiskChart(pnlFINContainer);
            bindFormHeader();
            bindScenarioLevelControls();//bind all top level controls regardless of tab
            bindConsequencesTab();
            bindProtectionsTab();
            bindDependenciesTab();
            bindCausesTab();

            bindFindingsTab();
            bindRelatedScenariosTab();
            btnAddEnab.Enabled = true;
            TabPage selectedTab = tabScenarioDetals.SelectedTab;
            //iterate and show all tabs so that bound values are realized for use
            //in computations:
            foreach (TabPage tp in tabScenarioDetals.TabPages)
            {
                if (!tp.Created)
                {
                    tp.Show();
                }
            }
            //System.Diagnostics.Debug.Print(txtFreqDev.Text);//testing if value has been bound
            selectedTab.Show();
            selectedTab.BringToFront();
            ClearScenarioDetailsControlChanges();
            bindRiskTab();//no actual binding, creates graph contents
            doPostBindingTasks();
        }
        private void doPostBindingTasks()//tasks that need all binding complete before execution
        {
            CalculateOverallProtectionsPFD();
            CalculateOverallProbability();
            CalculateOverallProtectionsMTBF();
        }
        private void bindScenarioLevelControls()
        {

            //xtxtScenMIERiskRank.DataBindings.Clear();
            //xtxtScenMIERiskRank.DataBindings.Add("Text", scenarioRecordBindingSource, "fldMIERiskRank");
            //xtxtScenSocRiskRank.DataBindings.Clear();
            //xtxtScenSocRiskRank.DataBindings.Add("Text", scenarioRecordBindingSource, "fldSocRiskRank");
            //xtxtScenEnvRiskRank.DataBindings.Clear();
            //xtxtScenEnvRiskRank.DataBindings.Add("Text", scenarioRecordBindingSource, "fldEnvRiskRank");
            //xtxtScenFinRiskRank.DataBindings.Clear();
            //xtxtScenFinRiskRank.DataBindings.Add("Text", scenarioRecordBindingSource, "fldFinRiskRank");
            //txtScenarioRiskRank.DataBindings.Clear();
            //txtScenarioRiskRank.DataBindings.Add("Text", scenarioRecordBindingSource, "fldRiskRank");

            txtOverallMTBF.DataBindings.Clear();
            txtOverallMTBF.DataBindings.Add("Text", scenarioRecordBindingSource, "fldScenarioFreq");
            txtMaxPipeDiam.Text = dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeDiameter"].ToString();//read only value, no need to bind
            txtNodeMDL.Text = dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldMinMDL"].ToString();//read only value, no need to bind
            txtMaxScenarioPSI.DataBindings.Clear();
            txtMaxScenarioPSI.DataBindings.Add("Text", scenarioRecordBindingSource, "fldMaxScenarioPRS");
            txtLOCProb.DataBindings.Clear();
            txtLOCProb.DataBindings.Add("Text", scenarioRecordBindingSource, "fldLocProb");
//            txtFreqDev.DataBindings.Clear();
//            txtFreqDev.DataBindings.Add("Text", scenarioRecordBindingSource, "fldFailureFreq");
            if (txtOverallProb.Text != txtLOCProb.Text)
            {
                txtOverallProb.Text = txtLOCProb.Text;
            }
            txtLeakDiam.DataBindings.Clear();
            txtLeakDiam.DataBindings.Add("Text", scenarioRecordBindingSource, "fldLeakDiam");
            txtReleaseRate.DataBindings.Clear();
            txtReleaseRate.DataBindings.Add("Text", scenarioRecordBindingSource, "fldReleaseRate");
            txtReleaseVol.DataBindings.Clear();
            txtReleaseVol.DataBindings.Add("Text", scenarioRecordBindingSource, "fldReleaseVol");
            txtNoLossOfContainment.DataBindings.Clear();
            txtNoLossOfContainment.DataBindings.Add("Text", scenarioRecordBindingSource, "fldNoLOC_FinLoss");
            cmbServiceCode.DataBindings.Clear();
            cmbServiceCode.DataSource = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcServices");
            cmbServiceCode.DisplayMember = "fldServiceDescription";
            cmbServiceCode.ValueMember = "fldServiceCode";
            cmbServiceCode.DataBindings.Add("SelectedValue", scenarioRecordBindingSource, "fldServiceCode");

        }
        private DataTable GetTableForKeyword(int? CurrentScenarioNumber,int KeywordNumber,DataTable dtAllKeywords)
        {
            DataTable dtReturn = new DataTable("ScenarioNumbers");
            foreach (DataColumn dc in dtAllKeywords.Columns)
            {
                DataColumn dc2 = new DataColumn(dc.ColumnName, dc.DataType);
                dtReturn.Columns.Add(dc2);
            }
            if (CurrentScenarioNumber != null)
            {
                DataRow drOldNum = dtReturn.NewRow();
                drOldNum["fldKeywordNumber"] = KeywordNumber;
                drOldNum["fldScenarioNumber"] = CurrentScenarioNumber;
                dtReturn.Rows.Add(drOldNum);
            }
            DataRow[] dra = dtAllKeywords.Select(" fldKeywordNumber = " + KeywordNumber.ToString());
            foreach(DataRow dr in dra)
            {
                DataRow dr2 = dtReturn.NewRow();
                foreach (DataColumn dc in dtAllKeywords.Columns)
                {
                    dr2[dc.ColumnName] = dr[dc.ColumnName];
                }
                dtReturn.Rows.Add(dr2);
            }
            dtReturn.DefaultView.Sort ="fldScenarioNumber";
            return dtReturn;
        }
        private void bindFormHeader()
        {

            dtpScenarioModDate.DataBindings.Clear();
            dtpScenarioModDate.DataBindings.Add("value", scenarioRecordBindingSource, "fldModifiedDate");


            txtAnalysis.DataBindings.Clear();
            txtAnalysis.DataBindings.Add("Text", scenarioRecordBindingSource, "fldScenarioAnalysis");
           // txtAnalysis.DataBindings.Add("Enabled", this, "AllowEdit");
            txtAnalysis.ReadOnly = (! SecurityManager.IsColumnUpdateable("tblScenarios","fldScenarioAnalysis"));

            txtDescription.DataBindings.Clear();
            txtDescription.DataBindings.Add("Text", scenarioRecordBindingSource, "fldScenarioDescription");
            txtDescription.ReadOnly = (!SecurityManager.IsColumnUpdateable("tblScenarios", "fldScenarioDescription"));

            //bind keyword dropdown !! before scenario number dropdown
            ucmbKeyword.DataBindings.Clear();
            ucmbKeyword.DataSource = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcKeywords");
            ucmbKeyword.ValueMember = "fldKeywordNumber";
            ucmbKeyword.DisplayMember = "fldKeywordNumber";
            ucmbKeyword.DataBindings.Add("Value", dsScenarioDetails, "tblScenarios.fldKeywordNumber");

            //mcbKeyword.DataBindings.Clear();
            ////mcbKeyword.DataSource = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcKeywords");
            //mcbKeyword.Table = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcKeywords");
            //mcbKeyword.ValueMember = "fldKeywordNumber";
            //mcbKeyword.DisplayMember = "fldKeywordNumber";
            //mcbKeyword.ColumnsToDisplay = new string[] { "fldKeywordNumber", "fldKeyword" };
            //mcbKeyword.DataBindings.Add("Text", dsScenarioDetails, "tblScenarios.fldKeywordNumber");
            //bind scenario number dropdown
            object oTest = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldKeywordNumber"];
            if (!(oTest == DBNull.Value))
            {
                int iKeywordNum = (int)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldKeywordNumber"];
                int iScenarioNum = (int)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioNumber"];
                cmbScenarioNumber.DataSource = GetTableForKeyword(iScenarioNum, iKeywordNum, dsScenarioDetails.Tables["AvailableScenarioNumbers"]);
            }
            cmbScenarioNumber.ValueMember = "fldScenarioNumber";//[0].Table.Columns[1].ColumnName;// "fldScenarioNumber";
            cmbScenarioNumber.DisplayMember = "fldScenarioNumber";
            cmbScenarioNumber.DataBindings.Clear();
            cmbScenarioNumber.DataBindings.Add("SelectedValue", scenarioRecordBindingSource, "fldScenarioNumber");
            //txtScenarioNumber.DataBindings.Clear();
            //txtScenarioNumber.DataBindings.Add("Text", scenarioRecordBindingSource, "fldScenarioNumber");

            this.Text = "Scenario for Node: " + dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeDescription"].ToString();
            //lblNodeDescription.DataBindings.Clear();
            //lblNodeDescription.DataBindings.Add("Text", dsScenarioDetails.Tables["tblNodes"], "fldNodeDescription");
            txtNodeNumber.DataBindings.Clear();
            txtNodeNumber.DataBindings.Add("Text", dsScenarioDetails.Tables["tblNodes"], "fldNodeNumber");

            //cmbScenarioType.DataBindings.Clear();
            //if (cmbScenarioType.DataSource == null)
            //{
            //    cmbScenarioType.DataSource = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcKeywords");
            //    cmbScenarioType.ValueMember = "fldKeywordNumber";
            //    cmbScenarioType.DisplayMember = "fldKeyword";
            //}
            //cmbScenarioType.DataBindings.Add("SelectedValue", dsScenarioDetails, "tblScenarios.fldKeywordNumber");

            //bind mod By drop down
            cmbModBy.DataBindings.Clear();
            if (cmbModBy.DataSource == null)
            {
                cmbModBy.DataSource = dsScenarioDetails.Tables["tblPeople"];
                cmbModBy.ValueMember = "fldPersonNumber";
                cmbModBy.DisplayMember = "LastFirst";
            }
            cmbModBy.DataBindings.Add("SelectedValue", dsScenarioDetails, "tblScenarios.fldModifiedBy");
            //txtMaxSocRiskFreq.DataBindings.Clear();
            //txtMaxSocRiskFreq.DataBindings.Add("Text", dsScenarioDetails, "tblScenarios.fldSocRiskVal");
            //txtMaxEnvRiskFreq.DataBindings.Clear();
            //txtMaxEnvRiskFreq.DataBindings.Add("Text", dsScenarioDetails, "tblScenarios.fldEnvRiskVal");
            //txtMaxFinRiskFreq.DataBindings.Clear();
            //txtMaxFinRiskFreq.DataBindings.Add("Text", dsScenarioDetails, "tblScenarios.fldFinRiskVal");
            //txtMaxMieRiskFreq.DataBindings.Clear();
            //txtMaxMieRiskFreq.DataBindings.Add("Text", dsScenarioDetails, "tblScenarios.fldMieRiskVal");

            
        }


        private int WriteChanges()
        {
            Guid NewScenarioIdentity = Guid.Empty;
            if (dsScenarioDetails.HasChanges(DataRowState.Modified))
            {
                DataSet dsUpdates = dsScenarioDetails.GetChanges(DataRowState.Modified);
                foreach (DataTable dtUpdated in dsUpdates.Tables)
                {
                    if (dtUpdated.Rows.Count > 0)
                    {
                        System.Diagnostics.Debug.Print("Table Changed: " + dtUpdated.TableName);
                        foreach (DataRow dr in dtUpdated.Rows)
                        {
                            ScenarioManager sm = new ScenarioManager();
                            int iRows = sm.SaveRowChanges(dr, UserManager.UserProfile.ActiveGeoRegion);
                        }
                    }
                }
            }
            if (dsScenarioDetails.GetChanges(DataRowState.Deleted) != null)
            {
                foreach (DataTable dtDeletes in dsScenarioDetails.GetChanges(DataRowState.Deleted).Tables)
                {
                    if (dtDeletes.Rows.Count > 0)
                    {
                        foreach (DataRow dr in dtDeletes.Rows)
                        {
                            ScenarioManager sm = new ScenarioManager();
                            int iRows = sm.DeleteRow(dr);
                        }
                    }
                }
            }
            if (dsScenarioDetails.GetChanges(DataRowState.Added) != null)
            {//need to make sure tblScenarios is processed first if it is in this group
                List<string> lTableNames = new List<string>();
                foreach (DataTable dtInserts in dsScenarioDetails.GetChanges(DataRowState.Added).Tables)
                {
                    if (dtInserts.TableName == "tblScenarios")
                    {
                        lTableNames.Insert(0, dtInserts.TableName);
                    }
                    else
                    {
                        lTableNames.Add(dtInserts.TableName);
                    }
                }
                foreach(string tableName in lTableNames)
               // foreach (DataTable dtInserts in dsScenarioDetails.GetChanges(DataRowState.Added).Tables)
                {
                    DataTable dtInserts = dsScenarioDetails.GetChanges(DataRowState.Added).Tables[tableName];
                    if (dtInserts.Rows.Count > 0)
                    {
                        foreach (DataRow dr in dtInserts.Rows)
                        {
                            if (dtInserts.TableName != "tblScenarios")
                            {
                                {
                                    if (dr.Table.Columns.Contains("fldScenarioUID"))
                                    {
                                        if (NewScenarioIdentity != Guid.Empty)//if we have a scenarioID from a new scenario record
                                        {
                                            dr["fldScenarioUID"] = NewScenarioIdentity;//put the id in the new child record
                                        }
                                    }
                                }
                            }
                            ScenarioManager sm = new ScenarioManager();
                            int iReturnValue = sm.InsertRow(dr);
                            if (dtInserts.TableName == "tblScenarios")
                            {
                                NewScenarioIdentity = (Guid)dr["fldScenarioUID"];// iReturnValue;
                            }
                        }
                    }
                }
            }
            dsScenarioDetails.AcceptChanges();
         //   return NewScenarioIdentity;
            return 0;
        }
        //private DataTable GetAssociatedScenarios(Guid fldScenarioUID)
        //{
        //    ScenarioManager sm = new ScenarioManager();
        //    return sm.GetAssocScenariosForScenario(fldScenarioUID);
        //}
        //private int RemoveAssociatedScenario(Guid fldScenarioUID, Guid AssocScenarioID)
        //{
        //    ScenarioManager sm = new ScenarioManager();
        //    return sm.RemoveRelatedScenario(fldScenarioUID, AssocScenarioID);
        //}
        private DataSet GetScenarioFindings(Guid fldScenarioUID)
        {
            ScenarioManager sm = new ScenarioManager();
            return sm.GetFindingsForScenario(fldScenarioUID);
        }
        private DataSet GetScenarioDetailsForNewScenario(Guid fldScenarioUID,Guid fldPhaID, Guid fldNodeID)
        {
            DataSet dsReturn = null;
            ScenarioManager sm = new ScenarioManager();
            dsReturn = sm.GetDetailsForNewScenario(fldScenarioUID,fldPhaID,fldNodeID, UserManager.UserProfile.ActiveGeoRegion);// (273687);
            
            return dsReturn;
        }
        private DataSet GetScenarioDetails(Guid fldScenarioUID)
        {
            DataSet dsReturn = null;
            ScenarioManager sm = new ScenarioManager();
            dsReturn = sm.GetDetailsForScenario(fldScenarioUID, UserManager.UserProfile.ActiveGeoRegion);// (273687);
            //get lock if needed:
            if (this.AllowEdit)
            {
                if (dsReturn.Tables["tblScenarios"].Rows.Count > 0)
                {
                    currentOpenedRecordRowId = (System.Guid)dsReturn.Tables["tblScenarios"].Rows[0]["fldRowID"];// ActiveNode.LockedRecordId;
                    Model.ModelBase modelBase = UnlockAndAccuireLock(LockTimerEventProcessor, ActiveGeoRegionId);

                    if (modelBase.LockId <= 0)
                    {
                        PHAStandard.DisplayWarning("This Scenario is opened by " + modelBase.LockedBy + " for editing" +
                            Environment.NewLine + "Could not open a locked Scenario at this time for edit");
                        return null;
                    }
                }
            }
            return dsReturn;
        }
        private void GotoScenario(Guid fldScenarioUID)
        {
            ScenarioManager sm = new ScenarioManager();
            sm.UnlockRecord(currentOpenedRecordRowId, this.AppWinHwnd);
            dsScenarioDetails = GetScenarioDetails(fldScenarioUID);
            //dtAssociatedScenarios = GetAssociatedScenarios(fldScenarioUID);
            dsScenarioFindings = GetScenarioFindings(fldScenarioUID);
            bindForm();
        }
        private void LoadforScenario(Guid fldScenarioUID)
        {
            System.Windows.Forms.Cursor crsCurrent = this.Cursor;
            this.Cursor = Cursors.WaitCursor;
            bool LockCurrent = true;
            ScenarioManager sm = new ScenarioManager();
            if (dsScenarioDetails != null)
            {
                if (!EndEditAndValidate())
                {
                    this.Cursor = crsCurrent;
                    return;
                }
                if (dsScenarioDetails.HasChanges())
                {
                    //do we have/still have lock on this scenario?
                    if (!sm.CanSave(currentOpenedRecordRowId, this.AppWinHwnd))
                    {
                        PHAStandard.DisplayError("This record is not available to you for update. " +
                            "Please try to refresh and re-open the record and then try saving");
                        LockCurrent = false;
                        //return;
                    }
                    if (LockCurrent)
                    {
                        DialogResult Choice = PHAStandard.DisplayConfirmYN("Save Scenario Changes?");
                        if (Choice == DialogResult.Yes)
                        {
                            //handle any changes from previous record
                            WriteChanges();
                            dsScenarioDetails = GetScenarioDetails(fldScenarioUID);
                            //dtAssociatedScenarios = GetAssociatedScenarios(fldScenarioUID);
                            dsScenarioFindings = GetScenarioFindings(fldScenarioUID);
                            bindForm();

                        }
                        //NOTE JF: //there is no good way to cancel navigation when the bindingnavigator is used
                        // if users require, investigate this further, a way to reset the binding navigator to the 
                        // correct value would be required
                        // it may be possible to use signaling between the control and 
                        //this function 
                        //else if (Choice == DialogResult.Cancel) 
                        //{
                        //    string sExistingScenarioID = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"].ToString();
                        //    dsScenarioDetails = GetScenarioDetails(sExistingScenarioID);
                        //    bindForm();
                        //    return; //do not navigate to the new scenario
                        //}
                            //it may be possible to do this by using the "+" button of the navigator as is done in the findings details form
                        else if (Choice == DialogResult.No) //skip changes and move to new record
                        {
                            dsScenarioDetails = GetScenarioDetails(fldScenarioUID);
                            //dtAssociatedScenarios = GetAssociatedScenarios(fldScenarioUID);
                            dsScenarioFindings = GetScenarioFindings(fldScenarioUID);
                            bindForm();
                        }
                    }
                    else// Lock has timed out just go to the selected record
                    {
                        sm.UnlockRecord(currentOpenedRecordRowId, this.AppWinHwnd);
                        dsScenarioDetails = GetScenarioDetails(fldScenarioUID);
                        //dtAssociatedScenarios = GetAssociatedScenarios(fldScenarioUID);
                        dsScenarioFindings = GetScenarioFindings(fldScenarioUID);
                        bindForm();
                    }
                }
                else //just go to the selected record
                {
                    sm.UnlockRecord(currentOpenedRecordRowId, this.AppWinHwnd);
                    dsScenarioDetails = GetScenarioDetails(fldScenarioUID);
                    //dtAssociatedScenarios = GetAssociatedScenarios(fldScenarioUID);
                    dsScenarioFindings = GetScenarioFindings(fldScenarioUID);
                    bindForm();
                }
            }
            else //no current record
            {
                dsScenarioDetails = GetScenarioDetails(fldScenarioUID);
                //dtAssociatedScenarios = GetAssociatedScenarios(fldScenarioUID);
                dsScenarioFindings = GetScenarioFindings(fldScenarioUID);
                bindForm();

            }
            this.Cursor = crsCurrent;
        }
        private bool EndEditAndValidate()
        {
            bool isValid = true;
            List<string> InvalidConditions = new List<string>();
            
            ugLocations.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.ExitEditMode);
            ugLocations.UpdateData();
            if (!ValidateLocations(ref InvalidConditions))
            {
                isValid = false;
            }
            ugInitEvents.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.ExitEditMode);
            ugInitEvents.UpdateData();
            if (!ValidateEvents(ref InvalidConditions))
            {
                isValid = false;
                //string AllInvalid = "";
                //PHAStandard.DisplayError(InvalidConditions, "Errors in Event Data");
                //foreach (string sError in InvalidEvents)
                //{
                //    AllInvalid += sError + "\r\n";
                //}
                //MessageBox.Show(AllInvalid, "Errors in Eventn data");
            }
            ugEnabCond.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.ExitEditMode);
            ugEnabCond.UpdateData();

            ugLocations.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.ExitEditMode);
            ugLocations.UpdateData();

            ugProt2.PerformAction(UltraGridAction.ExitEditMode);
            ugProt2.UpdateData();

            ugDependencies.PerformAction(UltraGridAction.ExitEditMode);
            ugDependencies.UpdateData();

            //if (mcbKeyword.Text.Trim() == "")
            //{
            //    InvalidConditions.Add("Must select Scenario Type (keyword)");
            //    isValid = false;
            //}
            if (ucmbKeyword.Text.Trim() == "")
            {
                InvalidConditions.Add("Must select Scenario Type (keyword)");
                isValid = false;
            }
            if (!ValidateProtections(ref InvalidConditions))
            {
                isValid = false;
                //PHAStandard.DisplayError(InvalidProtections, "Errors in Protection Data");
                //string AllInvalid = "";
                //foreach (string sError in InvalidProtections)
                //{
                //    AllInvalid += sError + "\r\n";
                //}
                //MessageBox.Show(AllInvalid, "Errors in Protection data");
            }
            scenarioRecordBindingSource.EndEdit();
            if (!isValid)
            {
                PHAStandard.DisplayError(InvalidConditions, "Errors in Scenario Data");
            }
            return isValid;
        }
        private Dictionary<string, string> GetColumnCaptions(UltraGrid ug)//,int LayoutNum=0,int BandNum=0)
        {
            Dictionary<string, string> dCaptions = new Dictionary<string, string>();
            //UltraGridColumn col = ug.Layouts[LayoutNum].Bands[BandNum].Columns[ColumnKey];
            //if (col != null)
            //{
            //    sCaption = col.Header.Caption;
            //}
            if (ug.Rows.Count > 0)
            {
                foreach (UltraGridColumn col in ug.Rows[0].Band.Columns)
                {
                    string sCaption = col.Key;
                    if (col.Header.Caption != "")
                    {
                        dCaptions.Add(col.Key, col.Header.Caption);
                    }
                    else
                    {
                        dCaptions.Add(col.Key, col.Key);
                    }
                }
            }
            return dCaptions;
        }
        private bool CheckDataChanges()
        {
            return (dsScenarioDetails != null && dsScenarioDetails.HasChanges());
        }
        private bool CanSave()
        {
            //do we have/still have lock on this scenario?
            ScenarioManager sm = new ScenarioManager();
            return (sm.CanSave(currentOpenedRecordRowId, this.AppWinHwnd));
        }
        private void HandleChanges()//used by delete method
        {
            if (!EndEditAndValidate())
            {
                return;
            }
            if (dsScenarioDetails != null && dsScenarioDetails.HasChanges())
            {
                //do we have/still have lock on this scenario?
                ScenarioManager sm = new ScenarioManager();
                if (!sm.CanSave(currentOpenedRecordRowId, this.AppWinHwnd))
                {
                    PHAStandard.DisplayError("This record is not available to you for update. " +
                        "Please try to refresh and re-open the record and then try saving");
                    return;
                }
                WriteChanges();
                //reload current record
                Guid gCurrentScenarioID = (Guid)bndNavScenarios.BindingSource.Current;
                dsScenarioDetails = GetScenarioDetails(gCurrentScenarioID);
                //dtAssociatedScenarios = GetAssociatedScenarios(gCurrentScenarioID);
                dsScenarioFindings = GetScenarioFindings(gCurrentScenarioID);
                bindForm();

            }
            else
            {
                PHAStandard.DisplayWarning("No changes detected");// --DisplayConfirm("Save Scenario Changes?", "Data Changed");
            }
        }
        private void frmScenarioDetails_FormClosing(object sender, FormClosingEventArgs e)
        {
            //is there something that needs saving?
            bool bChanged = CheckControlChanges();
            if (bChanged)
            {
                DialogResult dr = drAskReallyQuit();
                switch (dr)
                {
                    case System.Windows.Forms.DialogResult.Yes:
                        {
                            e.Cancel = false;
                            break;
                        }
                    case System.Windows.Forms.DialogResult.No:
                        {
                            e.Cancel = true; //don't close
                            break;
                        }

                }
            }

            //if (currentOpenedRecordRowId != null)
            //{
            //    ScenarioManager sm = new ScenarioManager();
            //    sm.UnlockRecord(currentOpenedRecordRowId, this.AppWinHwnd);
            //}
            //SaveFormState(this);
        }

        private void btnExpandAnalysisText_Click(object sender, EventArgs e)
        {
            frmBigTextEdit EditAnalysisText = new frmBigTextEdit();
            EditAnalysisText.Top = this.Top;// +btnExpandAnalysisText.Top;
            EditAnalysisText.Left = this.Left;// +btnExpandAnalysisText.Left;
            EditAnalysisText.Height = (int)(this.Height * 0.8);
            EditAnalysisText.Width = (int)(this.Width * 0.8);
            EditAnalysisText.txtEditText.Text = txtAnalysis.Text;
            EditAnalysisText.Text += " Scenario Analysis and Conclusions";
            EditAnalysisText.txtEditText.ReadOnly = txtAnalysis.ReadOnly;
            DialogResult dr = EditAnalysisText.ShowDialog(this);
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                txtAnalysis.Text = EditAnalysisText.txtEditText.Text;
            }
        }

        private void btnExpandDescription_click(object sender, EventArgs e)
        {
            frmBigTextEdit EditDescriptionText = new frmBigTextEdit();
            EditDescriptionText.Top = this.Top;// +btnExpandAnalysisText.Top;
            EditDescriptionText.Left = this.Left;// +btnExpandAnalysisText.Left;
            EditDescriptionText.Height = (int)(this.Height * 0.8);
            EditDescriptionText.Width = (int)(this.Width * 0.8); EditDescriptionText.txtEditText.Text = txtDescription.Text;
            EditDescriptionText.Text += " Scenario Description";
            EditDescriptionText.txtEditText.ReadOnly = txtDescription.ReadOnly;
            DialogResult dr = EditDescriptionText.ShowDialog(this);
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                txtDescription.Text = EditDescriptionText.txtEditText.Text;
            }
        }

        /// <summary>
        /// Next,Previous,Last,First
        /// </summary>
        /// <param name="MoveWhere"></param>
        private void bndNavScenariosMove(string MoveWhere)
        {
            bool bMoveCancelled = false;
            bool bChanged = CheckControlChanges();
            if (bChanged)
            {
                DialogResult dr = MessageBox.Show("Save Changes?", "Current controls have changed, do you want to save?", MessageBoxButtons.YesNoCancel);
                switch (dr)
                {
                    case System.Windows.Forms.DialogResult.Yes:
                        {
                            //save record changes
                            if (!SaveCurrentRecord())
                            {
                                MessageBox.Show("Save record failure");
                            }
                            else //record was saved
                            {
                                GotoScenario((Guid)bndNavScenarios.BindingSource.Current);
                            }
                            break;
                        }
                    case System.Windows.Forms.DialogResult.No:

                //DialogResult dr = MessageBox.Show("Current controls have changed, \r\nOK to discard, Cancel to return to Record", "Discard Changes?", MessageBoxButtons.OKCancel);
                //switch (dr)
                //{
                //    //case System.Windows.Forms.DialogResult.Yes:
                //    //    {
                //    //        //save record changes
                //    //        if (!SaveCurrentRecord())
                //    //        {
                //    //            MessageBox.Show("Save record failure");
                //    //        }
                //    //        else //record was saved
                //    //        {
                //    //            GotoScenario((Guid)bndNavScenarios.BindingSource.Current);
                //    //        }
                //    //        break;
                //    //    }
                //    case System.Windows.Forms.DialogResult.OK:
                        {
                            //don't save record changes
                            break;
                        }
                    case System.Windows.Forms.DialogResult.Cancel:
                        {
                            bMoveCancelled = true;
                            //stay here
                            break;
                        }


                }
                if (!bMoveCancelled)
                {
                    NavigateRecord(MoveWhere);
                }
            }
            else
            {
                NavigateRecord(MoveWhere);
            }
            if (!bMoveCancelled)
            {
                this.lblScenarioID.Text = bndNavScenarios.BindingSource.Current.ToString();
                GotoScenario((Guid)bndNavScenarios.BindingSource.Current);
            }
        }
        private void NavigateRecord(string MoveWhere)
        {
            switch (MoveWhere)
            {
                case "First":
                    {
                        scenarioRecordBindingSource.MoveFirst();
                        scenarioPageBindingSource.MoveFirst();
                        break;
                    }
                case "Previous":
                    {
                        scenarioRecordBindingSource.MovePrevious();
                        scenarioPageBindingSource.MovePrevious();
                        break;
                    }
                case "Next":
                    {
                        scenarioRecordBindingSource.MoveNext();
                        scenarioPageBindingSource.MoveNext();
                        break;
                    }
                case "Last":
                    {
                        scenarioRecordBindingSource.MoveLast();
                        scenarioPageBindingSource.MoveLast();
                        break;
                    }
                default:
                    {
                        MessageBox.Show("Invalid move instruction received in 'NavigateRecord(MoveWhere)'");
                        break;
                    }
            }

        }


        private void bndNavScenariosMoveNextItem_Click(object sender, EventArgs e)
        {
            bndNavScenariosMove("Next");
            return;
            //bool bMoveCancelled = false;
            //bool bChanged = CheckControlChanges();
            //if (bChanged)
            //{
            //    DialogResult dr = MessageBox.Show("Save Changes?", "Current controls have changed, do you want to save?", MessageBoxButtons.YesNoCancel);
            //    switch (dr)
            //    {
            //        case System.Windows.Forms.DialogResult.Yes:
            //            {
            //                break;
            //            }
            //        case System.Windows.Forms.DialogResult.No:
            //            {
            //                break;
            //            }
            //        case System.Windows.Forms.DialogResult.Cancel:
            //            {
            //                break;
            //            }
            //    }

            //}
            //MovetoSelectedRecord();
        }
        private bool SaveCurrentRecord()
        {
            bool Saved = false;
            if (EndEditAndValidate())
            {
                if (CheckDataChanges())//if we have actual changes
                {
                    if (bCreatingNewScenario || CanSave())//if we still have a lock
                    {
                        WriteChanges();
                        //int NewScenarioID = WriteChanges();
                        //if (NewScenarioID > 1)
                        //{
                        //    AllScenarioIDs.Add(NewScenarioID.ToString());
                        //    bndNavScenarios.BindingSource.ResetBindings(true);
                        //    LoadforScenario(NewScenarioID.ToString());
                        //    bCreatingNewScenario = false;
                        //}
                        bCreatingNewScenario = false;
                        Saved = true;
                    }
                    else
                    {
                        PHAStandard.DisplayError("This record is not available to you for update. " +
                            "Please try to refresh and re-open the record and then try saving");
                    }
                }
                else
                {
                    PHAStandard.DisplayWarning("Detected no underlying changes");
                }
            }
            return Saved;
        }
        private void bndNavScenariosMovePreviousItem_Click(object sender, EventArgs e)
        {
            bndNavScenariosMove("Previous");
            return;
           // MovetoSelectedRecord();
        }

        private void bndNavScenariosMoveLastItem_Click(object sender, EventArgs e)
        {
            bndNavScenariosMove("Last");
            return;
           // MovetoSelectedRecord();
        }

        private void bndNavScenariosMoveFirstItem_Click(object sender, EventArgs e)
        {
            bndNavScenariosMove("First");
            return;
            //MovetoSelectedRecord();
        }
        private void MovetoSelectedRecord()
        {
            this.lblScenarioID.Text = bndNavScenarios.BindingSource.Current.ToString();
            LoadforScenario((Guid)bndNavScenarios.BindingSource.Current);
        }
        private void btnRev_Click(object sender, EventArgs e)
        {
           // DisplayRisks();
        }



        private void lblNodeName_TextChanged(object sender, EventArgs e)
        {

        }






        private void cmbScenarioType_SelectedValueChanged(object sender, EventArgs e)
        {
            beginScenarioRecordEdit();
        }
        private bool bRowHasChanges(DataRow dr)
        {
            bool bHasChanges = false;
            for (int i = 0; i < dr.ItemArray.Length; i++)
            {
                try
                {
                    object p = dr[i, DataRowVersion.Proposed];
                    object o = dr[i, DataRowVersion.Original];
                    object x = dr[i].GetType();
                    string sName = ((Type)x).Name;
                    //check if one but not both values are null
                    if (
                        o == DBNull.Value && p != DBNull.Value
                        ||
                        o != DBNull.Value && p == DBNull.Value
                        )
                    {
                        bHasChanges = true;
                        break;
                    }
                    else //testc the values themselves
                    {
                        switch (sName)
                        {
                            case "Decimal":
                                {
                                    bHasChanges = (Decimal)p != (Decimal)o;
                                    break;
                                }
                            case "String":
                                {
                                    bHasChanges = p.ToString() != o.ToString();
                                    break;
                                }
                            case "Int32":
                                {
                                    bHasChanges = (Int32)p != (Int32)o;
                                    break;
                                }
                            case "Single":
                                {
                                    bHasChanges = (Single)p != (Single)o;
                                    break;
                                }
                            case "DateTime":
                                {
                                    bHasChanges = ((DateTime)p).CompareTo(((DateTime)o)) != 0;
                                    break;
                                }
                            case "DBNull":
                                {
                                    bHasChanges = p.GetType().Name != "DBNull" || o.GetType().Name != "DBNull";
                                    break;
                                }
                            case "Byte[]":
                                {
                                    bHasChanges = (Byte[])p != (Byte[])o;
                                    break;
                                }
                        }
                    }
                    if (bHasChanges)
                    {
                        break;
                    }
                }
                catch
                {

                }
            }
            return bHasChanges;
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (SaveCurrentRecord())
            {
                Guid gCurrentScenarioID = Guid.Empty;
                //reload current record
                if (bndNavScenarios.BindingSource.Position < 0 && bndNavScenarios.BindingSource.List.Count > 0)
                {
                    gCurrentScenarioID = (Guid)bndNavScenarios.BindingSource.List[0];
                }
                else
                {
                    gCurrentScenarioID = (Guid)bndNavScenarios.BindingSource.Current;
                }
                dsScenarioDetails = GetScenarioDetails(gCurrentScenarioID);
                //dtAssociatedScenarios = GetAssociatedScenarios(gCurrentScenarioID);
                dsScenarioFindings = GetScenarioFindings(gCurrentScenarioID);
                bindForm();
            }
            //HandleChanges();
        }

        private new void LockTimerEventProcessor(Object obj, EventArgs eventArgs)
        {
            base.LockTimerEventProcessor(obj, eventArgs);
            if (PHAStandard.DisplayConfirm(string.Format(lockMessage, "Scenario")) == System.Windows.Forms.DialogResult.Yes)
            {
                Model.ModelBase modelBase = UnlockAndAccuireLock(LockTimerEventProcessor, ActiveGeoRegionId);
                if (modelBase.LockId <= 0)
                {
                    PHAStandard.DisplayWarning("This scenario is opened by " + modelBase.LockedBy + " for editing" +
                        Environment.NewLine + "Could not open a scenario node at this time for edit");
                    return;
                }
            }

        }



        #region CausesTab
        private void bindCausesTab()
        {
            //bind events table
            ugInitEvents.DataSource = dsScenarioDetails;
            ugInitEvents.DataMember = "tblEvents";
            ugInitEvents.DataBind();
            //bind enabling conditions
            ugEnabCond.DataSource = dsScenarioDetails;
            ugEnabCond.DataMember = "tblEnabConditions";
            ugEnabCond.DataBind();
            //CalculateOverallProbability();//moved to doPostBindingTasks()
            //CalculateOverallProtectionsMTBF();//moved to doPostBindingTasks()
        }
        private bool ValidateLocations(ref List<string> invalid)//call after ugLocations.updatedata
        {
            bool isValid = true;
            if (dsScenarioDetails.Tables["tblScenarioLocations"].GetChanges() != null)
            {
                bool HasLocations = false;
                //all fldLcnLocFreq values must total 1.0
                double dFractionSum = 0.0;
                foreach(DataRow locn in dsScenarioDetails.Tables["tblScenarioLocations"].Rows)
                {
                    if (locn.RowState != DataRowState.Deleted)
                    {
                        HasLocations = true;
                        double RowFraction = 0.0;
                        if (double.TryParse(locn["fldLcnLocFraction"].ToString(), out RowFraction))
                        {
                            if (RowFraction <= 0 || RowFraction > 1.0)
                            {
                                invalid.Add("Fraction value: " + locn["fldLcnLocFraction"].ToString() + " out of range (> 0 and <= 1)");
                                isValid = false;
                            }
                            dFractionSum += RowFraction;
                        }
                        else
                        {
                            invalid.Add("Fraction value empty or not a number");
                            isValid = false;
                        }
                    }
                }
                if (HasLocations && (dFractionSum < 0.999 || dFractionSum > 1.0001))
                {
                    invalid.Add("Fractions must total 1.0, Current sum is " + dFractionSum.ToString() + ".");
                    isValid = false;
                }
            }
            return isValid;
        }
        private bool ValidateEvents(ref List<string> invalid) //call after ugInitEvents.updatedata
        {
            bool isValid = true;
            if (dsScenarioDetails.Tables["tblEvents"].GetChanges() != null)
            {
                Dictionary<string, string> dCaptions = GetColumnCaptions(ugInitEvents);
                //List<string> invalid = new List<string>();
                Dictionary<int, int> Level_Item = new Dictionary<int, int>();
                ScenarioManager sm = new ScenarioManager();
                foreach (DataRow dr in dsScenarioDetails.Tables["tblEvents"].GetChanges().Rows)//check fields in changed rows
                {
                    List<string> RowErrors = sm.ValidateRowForCommand(dr, dCaptions);
                    invalid.AddRange(RowErrors);//check for null or blank fields or bad value types
                    if (invalid.Count > 0)
                    {
                        isValid = false;
                    }
                }

            }
            return isValid;
        }
        private void ugInitEvents_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;
            uddEventType.SetDataBinding(ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcEventTypes"), null);
            uddEventType.ValueMember = "fldEventTypeCode";
            foreach (UltraGridColumn ddc in uddEventType.DisplayLayout.Bands[0].Columns)
            {
                switch (ddc.Key)
                {
                    case "fldEventTypeCode":
                        {
                            ddc.Header.Caption = "Type Code";
                            break;
                        }
                    case "fldEventDescription":
                        {
                            ddc.Header.Caption = "Type Descr";
                            ddc.Width = 300;
                            break;
                        }
                    default:
                        {
                            ddc.Hidden = true;
                            break;
                        }
                }
            }
            // uddEventType.DisplayMember = "fldEventDescription";

            foreach (UltraGridColumn c in e.Layout.Bands[0].Columns)
            {
                if (AllowEdit)
                {
                    c.CellActivation = Activation.AllowEdit;
                }
                else
                {
                    //   c.CellActivation = Activation.ActivateOnly;
                }
                // c.Hidden = true;
                switch (c.Key)
                {

                    case "fldEventNumber":
                        {
                            c.Header.Caption = "Num";
                            c.CellActivation = Activation.NoEdit;
                            break;
                        }
                    case "fldEventTypeCode":
                        {
                            c.Header.Caption = "Type";
                            c.ValueList = uddEventType;
                            break;
                        }
                    case "fldEventDescription":
                        {
                            c.Header.Caption = "Description";
                            c.Width = 300;
                            break;
                        }
                    case "fldOpsPerYear":
                        {
                            c.Header.Caption = "Ops/Yr";
                            break;
                        }
                    case "fldOpPFD":
                        {
                            c.Header.Caption = "PFD";
                            c.Format = "#.0E+00";


                            break;
                        }
                    case "fldEventMTBF":
                        {
                            c.Header.Caption = "mtbf (years)";
                            c.Format = "#.0E+00";
                            break;
                        }
                    case "fldScenarioUID":
                        {
                            c.Hidden = true;
                            break;
                        }
                    default:
                        {
                            c.Hidden = true;
                            break;
                        }
                }
            }
        }

        private void btnAddEvent_Click(object sender, EventArgs e)
        {
            DataTable dtEvents = ((DataSet)ugInitEvents.DataSource).Tables["tblEvents"];
            //find max event number
            int iMaxEvNum = -1;
            foreach (DataRow dr in dtEvents.Rows)
            {
                if ((int)dr["fldEventNumber"] > iMaxEvNum)
                {
                    iMaxEvNum = (int)dr["fldEventNumber"];
                }
            }
            iMaxEvNum += 1;
            DataRow drAdd = dtEvents.NewRow();
            drAdd["fldEventNumber"] = iMaxEvNum;
            //get key info from Scenario Row:
           // drAdd["fldPhaDocNum"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldPhaDocNum"];
            //drAdd["fldNodeID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldNodeID"];
            //drAdd["fldKeywordNumber"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldKeywordNumber"];
            //drAdd["fldScenarioNumber"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioNumber"];
            drAdd["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
            dtEvents.Rows.Add(drAdd);
            ugInitEvents.DataBind();
        }

        private void ugInitEvents_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.IsAddRow)
            {
                foreach (UltraGridCell cell in e.Row.Cells)
                {
                    cell.Activation = Activation.AllowEdit;
                }
            }
            //e.Row.Cells["fldEventNumber"].Activation = Activation.NoEdit;
        }

        private void ugInitEvents_AfterRowUpdate(object sender, RowEventArgs e)
        {
            //is this firing?
        }

        private void ugEnabCond_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;

            foreach (UltraGridColumn c in e.Layout.Bands[0].Columns)
            {
                if (AllowEdit)
                {
                    c.CellActivation = Activation.AllowEdit;
                }
                else
                {
                    //   c.CellActivation = Activation.ActivateOnly;
                }
                // c.Hidden = true;
                switch (c.Key)
                {

                    case "fldEnabCondDescription":
                        {
                            c.Header.Caption = "Enabling condition or Operating Mode";
                            c.Width = Convert.ToInt32(((UltraGrid)sender).Width * 0.85);
                            break;
                        }
                    case "fldEnabCondProb":
                        {
                            //c.DataType = typeof(float);
                            c.MaxValue = 1.0F;
                            c.MinValue = 0.0F;
                            c.Header.Caption = "Probability";
                            c.Width = Convert.ToInt32(((UltraGrid)sender).Width * 0.15);
                            c.Format = "#.0E+00";
                            break;
                        }
                    default:
                        {
                            c.Hidden = true;
                            break;
                        }
                }

            }


        }
        private void btnDelEvent_Click(object sender, EventArgs e)
        {
            string sDescr = ugInitEvents.ActiveRow.Cells["fldEventDescription"].Text;
            DialogResult dr = PHAStandard.DisplayConfirm(sDescr, "Confirm you want to delete this record");
            switch (dr)
            {
                case System.Windows.Forms.DialogResult.Yes:
                    {
                        ugInitEvents.ActiveRow.Delete();
                        CalculateOverallProtectionsMTBF();
                        break;
                    }
                case System.Windows.Forms.DialogResult.No:
                    {
                        break;
                    }
                case System.Windows.Forms.DialogResult.Cancel:
                    {
                        break;
                    }
            }
        }

        private void btnAddEnab_Click(object sender, EventArgs e)
        {
            DataTable dtEnabCond = ((DataSet)ugEnabCond.DataSource).Tables["tblEnabConditions"];
            DataRow drAdd = dtEnabCond.NewRow();
            //get key info from Scenario Row:
            drAdd["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
            dtEnabCond.Rows.Add(drAdd);
            ugEnabCond.DataBind();
        }

        private void btnDeleteEnab_Click(object sender, EventArgs e)
        {
            string sDescr = ugEnabCond.ActiveRow.Cells["fldEnabCondDescription"].Text;
            DialogResult dr = PHAStandard.DisplayConfirm(sDescr, "Confirm you want to delete this record");
            switch (dr)
            {
                case System.Windows.Forms.DialogResult.Yes:
                    {
                        ugEnabCond.ActiveRow.Delete();
                        break;
                    }
                case System.Windows.Forms.DialogResult.No:
                    {
                        break;
                    }
                case System.Windows.Forms.DialogResult.Cancel:
                    {
                        break;
                    }
            }

        }

        private void CalculateOverallProbability()
        {
            double dProb = 1.0;
            if (ugEnabCond.Rows.Count > 0)
            {
                //calculate the product of all the probabilities in the enabling conditions grid
                foreach (UltraGridRow r in ugEnabCond.Rows)
                {
                    double rProb = 0;
                    double.TryParse(r.Cells["fldEnabCondProb"].Value.ToString(), out rProb);
                    dProb *= rProb;
                }
                txtOverallProb.Text = dProb.ToString("0.####E+00");// string.Format("{0:E000}", dProb);
            }
            else
            {
                txtOverallProb.Text = "";
            }
        }


        private void ugEnabCond_CellChange(object sender, CellEventArgs e)
        {
        }

        private void ugInitEvents_CellChange(object sender, CellEventArgs e)
        {
        }

        private void ugEnabCond_AfterCellUpdate(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {
                case "fldEnabCondProb":
                    {
                        CalculateOverallProbability();
                        CalculateOverallProtectionsMTBF();
                        break;
                    }
            }

        }
        private bool NowUpdatingEventValues = false;
        private void ugInitEvents_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (!NowUpdatingEventValues)
            {
                NowUpdatingEventValues = true; //prevent re-entry when we change row values
                switch (e.Cell.Column.Key)
                {
                    case "fldEventTypeCode"://user has selected or changed event type
                        {
                            string evType = e.Cell.Value.ToString();
                            DataRow[] dra = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcEventTypes").Select("fldEventTypeCode = '" + evType + "'");
                            if (dra.Length > 0)// if there is such a row
                            {
                                object oMTBF = dra[0]["fldDefEventMTBF"];
                                object oPFD = dra[0]["fldDefOpPFD"];
                                if (oMTBF != DBNull.Value)//is there a value for MTBF?
                                {
                                    e.Cell.Row.Cells["fldEventMTBF"].Value = oMTBF.ToString();
                                    e.Cell.Row.Cells["fldOpsPerYear"].Value = DBNull.Value;
                                    e.Cell.Row.Cells["fldOpPFD"].Value = DBNull.Value;
                                }
                                else if (oPFD != DBNull.Value)//is there a value for PFD?
                                {
                                    e.Cell.Row.Cells["fldOpPFD"].Value = oPFD.ToString();
                                    e.Cell.Row.Cells["fldOpsPerYear"].Value = DBNull.Value;
                                    e.Cell.Row.Cells["fldEventMTBF"].Value = DBNull.Value;
                                }
                            }
                            else //no data found (should never happen)
                            {
                                e.Cell.Row.Cells["fldOpPFD"].Value = DBNull.Value;
                                e.Cell.Row.Cells["fldOpsPerYear"].Value = DBNull.Value;
                                e.Cell.Row.Cells["fldEventMTBF"].Value = DBNull.Value;
                            }
                            break;
                        }
                    case "fldEventMTBF"://if user enters this, we want to clear fldOpsPerYear and fldOpPFD
                        {
                            if (e.Cell.Value != DBNull.Value)
                            {
                                e.Cell.Row.Cells["fldOpsPerYear"].Value = DBNull.Value;
                                e.Cell.Row.Cells["fldOpPFD"].Value = DBNull.Value;
                            }
                            CalculateOverallProtectionsMTBF();
                            break;
                        }
                    case "fldOpsPerYear": //if user changes this, we want to compute fldEventMTBF as 1/(fldOpsPerYear * fldOpPfd) (if both not null) if not computable, change fldEventMtbv to dbnull.value
                        {
                            ComputeEventMTBF(sender, e);
                            CalculateOverallProtectionsMTBF();
                            break;
                        }
                    case "fldOpPFD": //if user changes this, we want to compute fldEventMTBF as 1/(fldOpsPerYear * fldOpPfd) (if both not null) if not computable, change fldEventMtbv to dbnull.value
                        {
                            ComputeEventMTBF(sender,e);
                            CalculateOverallProtectionsMTBF();
                            break;
                        }
                }
                NowUpdatingEventValues = false;
            }

        }
        private void ComputeEventMTBF(object sender, CellEventArgs e)
        {
            double OpsPerYear = 0.0;
            double OpPFD = 0.0;
            double EventMTBF = 0.0;
            if (double.TryParse(e.Cell.Row.Cells["fldOpsPerYear"].Value.ToString(), out OpsPerYear))
            {
                if (double.TryParse(e.Cell.Row.Cells["fldOpPFD"].Value.ToString(), out OpPFD))
                {
                    EventMTBF = 1.0 / (OpsPerYear * OpPFD);
                }
                e.Cell.Row.Cells["fldEventMTBF"].Value = EventMTBF;
            }
            else
            {
                e.Cell.Row.Cells["fldEventMTBF"].Value = DBNull.Value;
            }
        }
        #endregion
        #region ConsequencesTab
        private void ugLocations_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //uddLocations.SetDataBinding(ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tblLocations"), null);//.DataSource = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcLocations");
            e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;

            uddLocations.SetDataBinding(dsScenarioDetails.Tables["ScenarioAssociatedLocations"],null);
            uddLocations.ValueMember = "fldLocationID";
            uddLocations.DisplayMember = "fldLocationDescription";
            foreach (UltraGridColumn ddc in uddLocations.DisplayLayout.Bands[0].Columns)
            {
                switch (ddc.Key)
                {
                    case "fldFacilityCode":
                        {
                            ddc.Header.Caption = "Facility";
                            break;
                        }
                    case "fldLocationDescription":
                        {
                            ddc.Header.Caption = "Description";
                            ddc.Width = 200;
                            break;
                        }
                        //set display format for frequency cells:



                    //case "fldLocationSequence":
                    //    {
                    //        ddc.Header.Caption = "Sequence";
                    //        break;
                    //    }
                    //case "fldDefPLLExp":
                    //    {
                    //        ddc.Header.Caption = "Expl PLL";
                    //        break;
                    //    }
                    //case "fldDefPLLFire":
                    //    {
                    //        ddc.Header.Caption = "Fire PLL";
                    //        break;
                    //    }
                    //case "fldDefPLLNoIgn":
                    //    {
                    //        ddc.Header.Caption = "No Ign PLL";
                    //        break;
                    //    }
                    //case "fldDefMIEExp":
                    //    {
                    //        ddc.Header.Caption = "Expl MIE";
                    //        break;
                    //    }
                    //case "fldDefMIEFire":
                    //    {
                    //        ddc.Header.Caption = "Fire MIE";
                    //        break;
                    //    }
                    //case "fldDefMIENoIgn":
                    //    {
                    //        ddc.Header.Caption = "No Ign MIE";
                    //        break;
                    //    }

                    //case "fldTimeStamp":
                    //    {
                    //        ddc.Hidden = true;
                    //        break;
                    //    }
                    default:
                        {
                            ddc.Hidden = true;
                            break;
                        }


                }
            }
            UltraGrid ug = (UltraGrid)sender;
            ug.DisplayLayout.Bands[0].Override.MinRowHeight = 20; // minimized row height
            foreach (UltraGridColumn c in e.Layout.Bands[0].Columns)
            {
                //if (AllowEdit)
                //{
                //    c.CellActivation = Activation.AllowEdit;
                //}
                //else
                //{
                //    //   c.CellActivation = Activation.ActivateOnly;
                //}
                // c.Hidden = true;
                c.SortIndicator = SortIndicator.Disabled;
                switch (c.Key)
                {
                    case "fldLocationID":
                        {
                            c.Header.Caption = "Location";
                            c.ValueList = uddLocations;
                            c.Hidden = false;
                            break;
                        }
                    case "fldExpProb":
                        {
                            c.Header.Caption = "Explosion";
                            break;
                        }
                    case "fldFireProb":
                        {
                            c.Header.Caption = "Fire";
                            //                            c.Format = "#.0E+00";
                            break;
                        }
                    case "cfNoIgnProb":
                        {
                            c.Header.Caption = "No Ignition";
                            c.CellActivation = Activation.NoEdit;
                            //                            c.Format = "#.0E+00";
                            break;
                        }
                        //read only cells
                    case "cfLOCatLoc":
                    case "cfFireFreq":
                    case "cfExpFreq":
                    case "cfNoIgnFreq":
                        {
                            c.CellActivation = Activation.NoEdit;
                            break;
                        }

                    case "fldTimeStamp":
                        {
                            c.Hidden = true;
                            break;
                        }
                    //case "fldLocProb"://top row fields show always
                    //case "cfLOCatLoc":
                    //case "fldEconNoLoc":
                    //    {
                    //        c.Hidden = false;
                    //        break;
                    //    }
                    //default:
                    //    {
                    //        c.Hidden = true;
                    //        break;
                    //    }
                }
                if (c.Key.StartsWith("cf")) //if a computed field
                {
                  //  c.CellAppearance.BackColor = Color.Red;
                }
            }

        }

        private void ugLocations_AfterRowActivate(object sender, EventArgs e)
        {
            //UltraGrid ug = (UltraGrid)sender;
            //ug.ActiveRow.Height = 82;  //select full display height
            //UpdateComputedLocationValues(ug.ActiveRow);
            //foreach (UltraGridRow r in ug.Rows)
            //{
            //    if (r.IsActiveRow == false)
            //    {//UltraGrid1.DisplayLayout.Bands(0).Override.MinRowHeight 
            //        r.Height = ug.DisplayLayout.Bands[0].Override.MinRowHeight;
            //    }
            //}

        }
        private bool CellObjsEqual(object o0, object o1)
        {
            return (o0 != DBNull.Value && o1 != DBNull.Value && o0.ToString() == o1.ToString());
        }
        private void ugLocations_CellChange(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {
                case "fldLocationID":
                    {//get table values and fill in defaults

                        ugLocations.PerformAction(UltraGridAction.ExitEditMode);
                        string s = e.Cell.Value.ToString();
                        DataTable dtLocTypes = dsScenarioDetails.Tables["ScenarioAssociatedLocations"];// ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tblLocations");
                        DataRow[] drSelectedLocation = dtLocTypes.Select(" fldLocationID = " + s + " ");
                        if (drSelectedLocation.Length > 0)
                        {
                            //use field name map to drive placement of location risk values
                            Dictionary<string, string> riskMap = new Dictionary<string, string>();
                            riskMap.Add("fldPllExp", "fldDefPllExp");
                            riskMap.Add("fldPLLFire", "fldDefPLLFire");
                            riskMap.Add("fldPLLNoIgn", "fldDefPLLNoIgn");
                            riskMap.Add("fldMIEExp", "fldDefMIEExp");
                            riskMap.Add("fldMIEFire", "fldDefMIEFire");
                            riskMap.Add("fldMIENoIgn", "fldDefMIENoIgn");
                            foreach (KeyValuePair<string, string> riskPair in riskMap)
                            {
                                string UserKey = riskPair.Key;
                                string ComputedKey = "c" + UserKey;
                                string SourceKey = riskPair.Value;
                                if(CellObjsEqual(e.Cell.Row.Cells[UserKey].Value,e.Cell.Row.Cells[ComputedKey].Value ))//if the old user value not null, old computed value not null, and they are equal
                                {
                                    e.Cell.Row.Cells[UserKey].Value = drSelectedLocation[0][SourceKey];//write new value to user cell
                                }
                                e.Cell.Row.Cells[ComputedKey].Value = drSelectedLocation[0][SourceKey];//in any case, write new value to computed cell
                            }
                        }
                        break;
                    }
            }
        }
        private void UpdateComputedLocationValues(UltraGridRow row)
        {
            Single NoIgnProb = 1;
            //[cfNoIgnProb]
            //[cfExpFreq]
            //[cfFireFreq]
            //[cfNoIgnFreq]
            //[cfLOCatLoc]
            try
            {
                foreach (UltraGridColumn uc in row.Band.Columns)
                    if (row.Cells[uc.Key] != null && row.Cells[uc.Key].Value != null)
                    {
                        switch (uc.Key)
                        {
                            //does this cell afect a computed column?
                            case "fldExpProb":
                                {
                                    NoIgnProb -= (Single)row.Cells[uc.Key].Value;
                                    break;
                                }
                            case "fldFireProb":
                                {
                                    NoIgnProb -= (Single)row.Cells[uc.Key].Value;
                                    break;
                                }
                        }
                        if (NoIgnProb < 0)
                        {
                            ConocoPhillips.PHA.Utils.PHAStandard.DisplayError("Explosion + Fire Probabilities must total <= 1.0");
                            return;
                        }
                    }
                //find target column
                int iNoIgnProbIndex = row.Band.Columns.IndexOf("cfNoIgnProb");
                UltraGridCell cellNoIgnProb = row.Cells[iNoIgnProbIndex];
                Single OldNoIgnProbValue = (Single)cellNoIgnProb.Value;
                if (OldNoIgnProbValue != NoIgnProb)
                {
                    cellNoIgnProb.Value = NoIgnProb;
                }
            }
            catch (Exception ex)
            {
            }
        }
        private void ugLocations_AfterCellUpdate(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {
                //does this cell afect a computed column?
                case "fldExpProb":
                    {
                        UpdateComputedLocationValues(e.Cell.Row);
                        break;
                    }
                case "fldFireProb":
                    {
                        UpdateComputedLocationValues(e.Cell.Row);
                        break;
                    }
                case "fldLocationCode":
                    {
                        break;
                    }
            }
        }



        private void btnCalcLOCProb_Click(object sender, EventArgs e)
        {
            double? dLOCProb = null;
            dLOCProb = FailureProb();
            if (dLOCProb == null)
            {
                string sErr = "LOC Probability cannot be calculated from available data.  Please manually estimate the LOC probability";
                ConocoPhillips.PHA.Utils.PHAStandard.DisplayError(sErr);
                return;
            }
            txtLOCProb.Text = ((double)dLOCProb).ToString("0.##E+00");
            return;
        }
        /// <summary>
        /// calculates failure probability from values in text controls on the page
        /// </summary>
        /// <returns>double? failure probability, null if calc fails or params are not available</returns>
        private double? FailureProb()
        {
            if (dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLocProb"] != DBNull.Value)
            {
                double dMinMDL = 0.0;
                double dMaxScenarioPressure = 0.0;
                double dFailureProb = 0.0;
                DataTable dtParameters = Model.LookupTables.GetLookupTable("tbcParameters");
                double LocA = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'LocA'")[0]["fldParameterValue"]);
                double LocB = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'LocB'")[0]["fldParameterValue"]);
                double HoleA = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'HoleA'")[0]["fldParameterValue"]);
                double HoleB = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'HoleB'")[0]["fldParameterValue"]);

                if (double.TryParse(txtNodeMDL.Text, out dMinMDL) && double.TryParse(txtMaxScenarioPSI.Text,out dMaxScenarioPressure))
                {
                    dFailureProb = CalculationHelper.LossOfContainmentProb(dMaxScenarioPressure, dMinMDL, LocA, LocB);
                }
                return dFailureProb;
                //return Convert.ToDouble(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLocProb"].ToString());
            }
            else
            {
                return null;
            }
            ////double? dProb = null;
            ////double dMaxPress = 0;
            ////double dMinMdl = 0;
            ////string sMaxScenarioPressure = txtMaxScenarioPSI.Text;
            ////string sMinMDL = txtNodeMDL.Text;
            ////double.TryParse(sMaxScenarioPressure, out dMaxPress);
            ////double dMaxPressBaseUnits = Utils.CalculationHelper.GeoRegionUnitsToBaseUnits(dMaxPress, "pressure",UserManager.UserProfile.ActiveGeoRegion);
            ////double.TryParse(sMinMDL, out dMinMdl);
            ////if (!((dMaxPress == 0) || (dMinMdl == 0) || (dMaxPress < dMinMdl)))//if we have parameters
            ////{
            ////    //calculate it
            ////    try
            ////    {
            ////        double f0 = ((dMaxPress - dMinMdl) / dMinMdl) / 2.5;
            ////        double f1 = Math.Pow(f0, 3.5);
            ////        double f2 = -1.0 * f1;
            ////        double f3 = Math.Exp(f2);
            ////        double f4 = 1.0 - f3;
            ////        dProb = (double)f4;
            ////    }
            ////    catch { }
            ////}
            ////return dProb;
        }
        private void ComputeCalcFields()
        {
            string strGeoRegionID = UserManager.UserProfile.ActiveGeoRegion;
            double NodeDiam = Convert.ToDouble(dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeDiameter"]);
            double MinMDL = Convert.ToDouble(dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldMinMDL"]);
            double MaxPrs =Convert.ToDouble( dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldMaxScenarioPRS"]);
            DataTable dtParameters = Model.LookupTables.GetLookupTable("tbcParameters");
            double LocA = Convert.ToDouble( dtParameters.Select(" fldParameterCode = 'LocA'")[0]["fldParameterValue"]);
            double LocB = Convert.ToDouble( dtParameters.Select(" fldParameterCode = 'LocB'")[0]["fldParameterValue"]);
            double HoleA = Convert.ToDouble( dtParameters.Select(" fldParameterCode = 'HoleA'")[0]["fldParameterValue"]);
            double HoleB = Convert.ToDouble( dtParameters.Select(" fldParameterCode = 'HoleB'")[0]["fldParameterValue"]);

            //compute loc prob and store in record
            double LossOfContainmentProb = Utils.CalculationHelper.LossOfContainmentProb(MaxPrs, MinMDL, LocA, LocB);
            double oldLossOfConatinmentProb = 0.0;
            if (CalculationHelper.isSQLNumber(LossOfContainmentProb))
            {
                if (double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLocProb"].ToString(), out oldLossOfConatinmentProb))//if there was an old value
                {
                    if (!Utils.CalculationHelper.bRealNumbersEqual(LossOfContainmentProb, oldLossOfConatinmentProb))//and the new value differs
                    {
                        dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLocProb"] = LossOfContainmentProb;//update it
                    }
                }
                else //there was no old value
                {
                    dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLocProb"] = LossOfContainmentProb;
                }
            }
            //compute leak diam and store in record
            double LeakDiam = Utils.CalculationHelper.LeakDiam(MaxPrs, MinMDL, NodeDiam, HoleA, HoleB);//we can calc this in any unit, comes back same units as node diam
            double oldLeakDiam = 0.0;
            double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLeakDiam"].ToString(), out oldLeakDiam);
            if (!Utils.CalculationHelper.bRealNumbersEqual(LeakDiam, oldLeakDiam))
            {
                if(CalculationHelper.isSQLNumber(LeakDiam))
                    dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLeakDiam"] = LeakDiam;//update the value if different
            }
            //
            if (LeakDiam > 0.0)
            {
                string ScenarioServiceCode = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldServiceCode"].ToString();
                double ReleaseRate = CalcReleaseRate(ScenarioServiceCode,MaxPrs,LeakDiam);
                double oldReleaseRate = 0.0;
                double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldReleaseRate"].ToString(), out oldReleaseRate);
                if (!Utils.CalculationHelper.bRealNumbersEqual(ReleaseRate, oldReleaseRate))
                {
                    dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldReleaseRate"] = ReleaseRate;
                }
            }
        }
        private void bindConsequencesTab()
        {
            //see if we can calculate values
            if (dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeDiameter"] != DBNull.Value 
                && dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldMinMDL"] != DBNull.Value
                && dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldMaxScenarioPRS"] != DBNull.Value)
            {
                ComputeCalcFields();
            }
            //bind Consequences tab
            //moved these bindings to bind top level method bindScenarioLevelControls()
            //txtMaxPipeDiam.Text = dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeDiameter"].ToString();//read only value, no need to bind
            //txtNodeMDL.Text = dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldMinMDL"].ToString();//read only value, no need to bind
            //txtMaxScenarioPSI.DataBindings.Clear();
            //txtMaxScenarioPSI.DataBindings.Add("Text", scenarioRecordBindingSource, "fldMaxScenarioPRS");
            //txtLOCProb.DataBindings.Clear();
            //txtLOCProb.DataBindings.Add("Text", scenarioRecordBindingSource, "fldLocProb");
            //txtFreqDev.DataBindings.Clear();
            //txtFreqDev.DataBindings.Add("Text", scenarioRecordBindingSource, "fldFailureFreq");
            //if (txtOverallProb.Text != txtLOCProb.Text)
            //{
            //    txtOverallProb.Text = txtLOCProb.Text;
            //}
            //txtLeakDiam.DataBindings.Clear();
            //txtLeakDiam.DataBindings.Add("Text", scenarioRecordBindingSource, "fldLeakDiam");
            //txtReleaseRate.DataBindings.Clear();
            //txtReleaseRate.DataBindings.Add("Text", scenarioRecordBindingSource, "fldReleaseRate");
            //txtReleaseVol.DataBindings.Clear();
            //txtReleaseVol.DataBindings.Add("Text", scenarioRecordBindingSource, "fldReleaseVol");
            //txtNoLossOfContainment.DataBindings.Clear();
            //txtNoLossOfContainment.DataBindings.Add("Text", scenarioRecordBindingSource, "fldNoLOC_FinLoss");
            //cmbServiceCode.DataBindings.Clear();
            //cmbServiceCode.DataSource = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcServices");
            //cmbServiceCode.DisplayMember = "fldServiceDescription";
            //cmbServiceCode.ValueMember = "fldServiceCode";
            //cmbServiceCode.DataBindings.Add("SelectedValue", scenarioRecordBindingSource, "fldServiceCode");
            ConfigureScenarioComputableFields();//copy values, change font colors, enable buttons per requirements
            ugLocations.DataSource = dsScenarioDetails.Tables["tblScenarioLocations"];
            //TODO: ConfigureLocationComputableFields()
        }
        private void ConfigureCalculableField(DataRowView dv,TextBox txtControl,Button btnCalc,string BaseFieldName)
        {
            try
            {
                string CalcFieldName = "c" + BaseFieldName;
                Color Red = Color.Red;
                Color Black = Color.Black;
                Color Blue = Color.Blue;
                //condition:
                //base null and calc null
                if (dv[BaseFieldName] == DBNull.Value && dv[CalcFieldName] == DBNull.Value)
                {
                    btnCalc.Enabled = false;
                    txtControl.ForeColor = Blue;
                }
                //base null and calc value
                else if (dv[BaseFieldName] == DBNull.Value && dv[CalcFieldName] != DBNull.Value)
                {
                    btnCalc.Enabled = true;
                    txtControl.ForeColor = Red;
                }
                //base value and calc null
                else if (dv[BaseFieldName] != DBNull.Value && dv[CalcFieldName] == DBNull.Value)
                {
                    btnCalc.Enabled = false;
                    txtControl.ForeColor = Blue;
                }
                else //neither null
                {
                    double dCalc = Convert.ToDouble(dv[CalcFieldName]);
                    double dBase = Convert.ToDouble(dv[BaseFieldName]);
                    //base value (=) calc value (neither null)
                    if (Utils.CalculationHelper.bRealNumbersEqual(dCalc, dBase))
                    {
                        btnCalc.Enabled = false;
                        txtControl.ForeColor = Black;
                    }
                    //base value (!=) calc value (neither null)
                    else
                    {
                        btnCalc.Enabled = true;
                        txtControl.ForeColor = Red;
                    }
                }
            }
            catch { }

        }
        private void ConfigureScenarioComputableFields()
        {
            DataRowView dvScenario = (DataRowView)scenarioRecordBindingSource.Current;
            //loc prob
            ConfigureCalculableField(dvScenario, txtLOCProb, btnCalcLOCProb, "fldLocProb");
            //Leak Diameter
            ConfigureCalculableField(dvScenario, txtLeakDiam, btnCalcLeakDiam, "fldLeakDiam");
            //release rate
            ConfigureCalculableField(dvScenario, txtReleaseRate, btnCalcReleaseRate, "fldReleaseRate");
        }
        double? LeakDiam()
        {
            double dMinMDL = 0.0;
            double dMaxScenarioPressure = 0.0;
            double dPipeDiam = 0.0;
            double dLeakDiam = 0.0;
            DataTable dtParameters = Model.LookupTables.GetLookupTable("tbcParameters");
            double LocA = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'LocA'")[0]["fldParameterValue"]);
            double LocB = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'LocB'")[0]["fldParameterValue"]);
            double HoleA = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'HoleA'")[0]["fldParameterValue"]);
            double HoleB = Convert.ToDouble(dtParameters.Select(" fldParameterCode = 'HoleB'")[0]["fldParameterValue"]);

            if (double.TryParse(txtNodeMDL.Text, out dMinMDL) 
                && double.TryParse(txtMaxScenarioPSI.Text, out dMaxScenarioPressure)
                && double.TryParse(txtMaxPipeDiam.Text,out dPipeDiam)
                )
            {
                dLeakDiam = CalculationHelper.LeakDiam(dMaxScenarioPressure, dMinMDL, dPipeDiam, HoleA, HoleB);
                return dLeakDiam;
            }
            return null;
            //return Convert.ToDouble(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLocProb"].ToString());

            //if (dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLeakDiam"] != DBNull.Value)
            //{
            //    return Convert.ToDouble(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldLeakDiam"].ToString());
            //}
            //else
            //{
            //    return null;
            //}
        }
        private void btnCalcLeakDiam_Click(object sender, EventArgs e)
        {
            double? dLeakDiam = LeakDiam();
            if (dLeakDiam == null)
            {
                string sErr = "Leak diameter cannot be calculated from available data.  Please manually estimate the Leak Diameter";
                ConocoPhillips.PHA.Utils.PHAStandard.DisplayError(sErr);
                return;
            }
            txtLeakDiam.Text = ((double)dLeakDiam).ToString("0.##E+00");
            return;

        }

        private void btnAddLocation_Click(object sender, EventArgs e)
        {
            DataTable dtLocations = (DataTable)ugLocations.DataSource;
            DataRow drAdd = dtLocations.NewRow();
            drAdd["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
            dtLocations.Rows.Add(drAdd);
            ugLocations.DataBind();
        }
        private void cmbServiceCode_SelectedIndexChanged(object sender, EventArgs e)
        {
        }
        private double CalcReleaseRate(string sSelectedServiceCode, double MaxScenarioPressure, double LeakDiam)//should be in KG/sec assuming pressures in pascals and leak diam in meters
        {
            double dReleaseRate = 0.0;
            DataTable dtServices = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcServices");
            DataRow[] drService = dtServices.Select("fldServiceCode = '" + sSelectedServiceCode + "'");
            if (drService.Length > 0)
            {
                double LeakArea = Math.Pow(LeakDiam / 2.0, 2.0) * Math.PI;
                string sFluidPhase = drService[0]["fldFluidPhase"].ToString();

                switch (sFluidPhase)
                {
                    case "Liq":
                        {
                            double dfldRateCoefficient = Convert.ToDouble(drService[0]["fldRateCoefficient"]); 
                            dReleaseRate = dfldRateCoefficient * LeakArea * Math.Sqrt(MaxScenarioPressure);
                            //RateCoefficient*LeakDiameter*sqrt(MaxScenarioPressure)

                            break;
                        }
                    case "Gas":
                        {//RateCoefficient*LeakDiameter*MaxScenarioPressure,NULL)
                            double dfldRateCoefficient = Convert.ToDouble(drService[0]["fldRateCoefficient"]); 
                            dReleaseRate = dfldRateCoefficient * LeakArea * MaxScenarioPressure;
                            break;
                        }

                }
                return dReleaseRate;

            }
            return 0.0;
        }
        private double CalcReleaseRate(string sSelectedServiceCode)//should be in KG/sec assuming pressures in pascals and leak diam in meters
        {

            DataTable dtServices = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcServices");
            DataRow[] drService = dtServices.Select("fldServiceCode = '" + sSelectedServiceCode + "'");
            if (drService.Length > 0)
            {
                double MaxScenarioPressure = 0;
                double.TryParse(txtMaxScenarioPSI.Text, out MaxScenarioPressure);
                double LeakDiam = 0;
                double.TryParse(txtLeakDiam.Text, out LeakDiam);
                return CalcReleaseRate(sSelectedServiceCode, MaxScenarioPressure, LeakDiam);
            }
            return 0.0;
        }
        private void cmbServiceCode_SelectedValueChanged(object sender, EventArgs e)
        {
            object o = ((ComboBox)sender).SelectedValue;
            if (o != null && o.GetType().Name == "String")//if something is actually selected
            {
                //recalculate expected release rate
               double dReleaseRate = CalcReleaseRate(o.ToString());
               if (dReleaseRate != 0)
               {
                   txtReleaseRate.Text = dReleaseRate.ToString("0.##E+00");
               }

            }

        }
        private void txtReleaseVol_Leave(object sender, EventArgs e)//range check, keep focus if out of range
        {
            TextBox t = (TextBox)sender;
            bool bKeepFocus = false;
            string s = t.Text;

            double d = double.MinValue;
            try
            {
                d = double.Parse(s);
            }
            catch { };
            if (d == double.MinValue)
            {
                Console.Beep(880, 100);
                bKeepFocus = true;
            }
            if (d < 0.0 || d > 999999)
            {
                Console.Beep(220, 100);
                bKeepFocus = true;
            }
            if (bKeepFocus)
            {
                ConocoPhillips.PHA.Utils.PHAStandard.DisplayWarning(toolTip1.GetToolTip(t));
                t.Focus();
            }
        }
        #endregion
        #region ProtectionsTab
        private void bindProtectionsTab()
        {
            ugProt2.DataSource = dsScenarioDetails.Tables["tblProtections"];
            ugProt2.DataBind();
            //CalculateOverallProtectionsPFD(); //moved to doPostBindingTasks()
        }
        private bool ValidateProtections(ref List<string> invalid) //call after ugProt2 has exited edit mode and updated data
        {
            bool isValid = true;
            if (dsScenarioDetails.Tables["tblProtections"].GetChanges() != null)
            {
                //check that uom is in the list:
                foreach (DataRow dr in dsScenarioDetails.Tables["tblProtections"].GetChanges().Rows)
                {
                    if (dr.RowState != DataRowState.Deleted)
                    {
                        string sTestUOM = dr["fldProtSetPointUOM"].ToString();
                        if (sTestUOM != "")
                        {
                            DataRow[] dra = dsUOM_hier.Tables["tbcUomSetUOMs"].Select(" fldUomID = '" + sTestUOM + "'");
                            if (dra.Length != 1)
                            {
                                invalid.Add(sTestUOM + " is not a valid UOM");
                                isValid = false;
                            }
                        }
                    }
                }
                //List<string> invalid = new List<string>();
                HashSet<string> Level_Item = new HashSet<string>();
                // Dictionary<int, int> Level_Item = new Dictionary<int, int>();
                Dictionary<string, string> dCaptions = GetColumnCaptions(ugProt2);
                ScenarioManager sm = new ScenarioManager();
                foreach (DataRow dr in dsScenarioDetails.Tables["tblProtections"].GetChanges().Rows)//check fields in changed rows
                {
                    List<string> RowErrors = sm.ValidateRowForCommand(dr, dCaptions);
                    invalid.AddRange(RowErrors);//check for null or blank fields or bad value types
                    if (invalid.Count > 0)
                    {
                        isValid = false;
                    }

                }
                //check all rows for duplicate level/item records
                foreach (DataRow dr in dsScenarioDetails.Tables["tblProtections"].Rows)
                {
                    if (dr.RowState != DataRowState.Deleted)
                    {
                        int iLevel = 0;
                        int iItem = 0;
                        int i = 0;
                        if (int.TryParse(dr["fldProtectionGroup"].ToString(), out i))
                        {
                            iLevel = i;
                        }
                        else
                        {
                            isValid = false;
                        }
                        if (int.TryParse(dr["fldProtectionSequence"].ToString(), out i))
                        {
                            iItem = i;
                        }
                        else
                        {
                            isValid = false;
                        }
                        string sLevelItem = iLevel.ToString() + "-" + iItem.ToString();
                        if (Level_Item.Contains(sLevelItem))
                        {
                            isValid = false;
                            invalid.Add("Level may not have duplicate Item numbers ");
                        }
                        else
                        {
                            Level_Item.Add(sLevelItem);
                        }
                    }

                }

            }
            return isValid;
        }
        private void txtProtDescription_Layout(object sender, LayoutEventArgs e)
        {
            int i = 0;
        }
        private void initProtectionsDropDowns()
        {
            //uddProtUOM.SetDataBinding(ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtSetPointUomTypes"), null);
            //uddProtUOM.ValueMember = "fldProtSetPointUom";
            //foreach (UltraGridColumn ddcUOM in uddProtUOM.DisplayLayout.Bands[0].Columns)
            //{
            //    switch (ddcUOM.Key)
            //    {
            //        case "fldProtSetPointUom":
            //            {
            //                ddcUOM.Header.Caption = "UOM Code";
            //                break;
            //            }
            //        case "fldProtSetPointUomDescr":
            //            {
            //                ddcUOM.Header.Caption = "UOM Descr";
            //                ddcUOM.Width = 200;
            //                break;
            //            }
            //        default:
            //            {
            //                ddcUOM.Hidden = true;
            //                break;
            //            }
            //    }
            //}

            uddProtTypes.SetDataBinding(ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtectionTypes"), null);
            uddProtTypes.ValueMember = "fldProtectionTypeCode";
            foreach (UltraGridColumn ddc in uddProtTypes.DisplayLayout.Bands[0].Columns)
            {
                switch (ddc.Key)
                {
                    case "fldProtectionTypeCode":
                        {
                            ddc.Header.Caption = "Type Code";
                            break;
                        }
                    case "fldProtectionTypeDescription":
                        {
                            ddc.Header.Caption = "Type Descr";
                            ddc.Width = 250;
                            break;
                        }
                    case "fldDefProtMTBF":
                        {
                            ddc.Header.Caption = "Default MTBF";
                            ddc.Width = 75;
                            break;
                        }
                    case "fldDefProtTestInterval":
                        {
                            ddc.Header.Caption = "Test Interval";
                            ddc.Width = 75;
                            break;
                        }
                    case "fldDefProtPFD":
                        {
                            ddc.Header.Caption = "Default PDF";
                            ddc.Width = 75;
                            break;
                        }
                    default:
                        {
                            ddc.Hidden = true;
                            break;
                        }
                }
            }
        }
        private void ugProt2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;

            initProtectionsDropDowns();
            e.Layout.Override.RowSizing = RowSizing.AutoFree;
            e.Layout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            if (e.Layout.Bands[0].Columns.UnboundColumnsCount == 0)
            {
                e.Layout.Bands[0].Columns.Add("Search", "");
                e.Layout.Bands[0].Columns.Add("btnCopyPFD", "<");
                e.Layout.Bands[0].Columns.Add("txtActualPFD", "Actual PFD");
            }
            foreach (UltraGridColumn c in e.Layout.Bands[0].Columns)
            {
                switch (c.Key)
                {
                    case "fldProtectionGroup":
                        {
                            // c.Header.VisiblePosition = 1;
                            c.Header.Caption = "Level";
                            c.Width = 40;
                            break;
                        }
                    case "fldProtectionSequence":
                        {
                            //   c.Header.VisiblePosition = 2;
                            c.Header.Caption = "Item";
                            c.Width = 35;
                            break;
                        }
                    case "fldSafetyCritical":
                        {
                            //    c.Header.VisiblePosition = 3;
                            c.Header.Caption = "Crit";
                            c.Width = 32;
                            break;
                        }
                    case "fldProtectionTypeCode":
                        {
                            //   c.Header.VisiblePosition = 4;
                            c.Header.Caption = "Type";
                            c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownValidate;
                            c.ValueList = uddProtTypes;
                            c.Width = 55;
                            break;
                        }
                    case "fldProtectionDescription":
                        {
                            //    c.Header.VisiblePosition = 5;
                            c.Header.Caption = "Description";
                            c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Edit;
                            c.CellMultiLine = Infragistics.Win.DefaultableBoolean.True;
                            c.Width = 200;
                            break;
                        }
                    case "fldPrimaryTag":
                        {
                            //   c.Header.VisiblePosition = 6;
                            c.Header.Caption = "Reference";// "SIF or Tag";
                            c.Width = 100;
                            break;
                        }
                    case "Search":
                        {
                            c.Header.VisiblePosition = 6;
                            c.Width = 22;
                            c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
                            c.ButtonDisplayStyle = ButtonDisplayStyle.Always;
                            c.CellButtonAppearance.Image = this.imageList.Images["Search"];
                            break;
                        }
                    case "fldProtSetPoint":
                        {
                            //  c.Header.VisiblePosition = 8;
                            c.Header.Caption = "Set Point";
                            c.Width = 70;
                            break;
                        }
                    case "fldProtSetPointUOM":
                        {
                            //  c.Header.VisiblePosition = 9;
                            c.Header.Caption = "UOM";
                            c.Width = 70;
                            c.EditorComponent = uteProtectionSetpointUOM;
                            //uteSetpointUOM
                            //c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownValidate;
                            //c.ValueList = uddProtUOM;
                            break;
                        }
                    case "fldSetPointRising":
                        {
                            //    c.Header.VisiblePosition = 10;
                            c.Header.Caption = "Rising";
                            c.Width = 44;
                            break;
                        }
                    case "fldProtPFD":
                        {
                            //   c.Header.VisiblePosition = 11;
                            c.Header.Caption = "Assumed PFD";
                            c.Width = 60;
                            c.Format = "#.0E+00";
                            break;
                        }
                    case "btnCopyPFD":
                        {
                            c.Width = 30;
                            c.Header.VisiblePosition = 11;
                            c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
                            c.ButtonDisplayStyle = ButtonDisplayStyle.Always;
                            break;
                        }
                    case "txtActualPFD": //should be able to find this in Meridium view MIV_COP_PHA_DATA.COP_PHA_DATA_PROT_PFD_NBR if we can figure out how to relate it to 
                        {
                            //  c.Header.VisiblePosition = 13;
                            c.Width = 55;
                            c.Format = "#.0E+00";
                            break;
                        }
                    case "fldTimeStamp":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldProtectionID":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldScenarioUID":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldPhaDocNum":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldProtOpDocumentPath":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldProtectionNumber":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldSifFacility":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldSifNumber":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldProtMTBF":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldProtTestInterval":
                        {
                            c.Hidden = true;
                            break;
                        }
                    default:
                        {
                            c.Hidden = true;
                            break;
                        }

                }
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            foreach (UltraGridCell c in ugProt2.Rows[0].Cells)
            {
                UltraGridColumn col = c.Column;
                if (true)
                {
                    System.Diagnostics.Debug.Print(c.Width.ToString() + "-" + c.Column.Header.Caption + "-" + c.Column.Header.VisiblePosition.ToString());
                }
            }

        }

        private void ugProt2_ClickCellButton(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {
                case "btnCopyPFD":
                    {
                        if (e.Cell.Row.Cells["txtActualPFD"].Text != "")
                        {
                            e.Cell.Row.Cells["fldProtPFD"].Value = e.Cell.Row.Cells["txtActualPFD"].Value;
                        }
                        break;//copy actual value if any to assumed pfd value
                    }
                case "Search":
                    {
                        //get facility for this scenario:
                        string sExistingTag = e.Cell.Row.Cells["fldPrimaryTag"].Value.ToString();
                        string sFacilityCode = dsScenarioDetails.Tables["tblPHAs"].Rows[0]["fldFacilityCode"].ToString();
                        string ScenarioID = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"].ToString();
                        string PHA = dsScenarioDetails.Tables["tblPHAs"].Rows[0]["fldPhaDocNum"].ToString();
                        string TagType = e.Cell.Row.Cells["fldProtectionTypeCode"].Text;
                        //DataTable dtProtectionTypes = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtectionTypes");
                        //DataRow[] dra = dtProtectionTypes.Select(" fldProtectionTypeCode = '" + TagType + "' ");
                        string ProtectionValidateType = GetProtectionType(TagType);
                        //if (dra.Length > 0)
                        //{
                        //    ProtectionValidateType = dra[0]["fldValidationSourceCode"].ToString();
                        //}
                        switch (ProtectionValidateType)
                        {
                            case "OP":
                                {
                                    using (frmSkillsNowTree f = new frmSkillsNowTree(e.Cell.Row.Cells["fldPrimaryTag"].Value.ToString(),e.Cell.Row.Cells["fldProtectionDescription"].Value.ToString()))
                                    {
                                        //f.SelectedDocumentTitle = e.Cell.Row.Cells["fldPrimaryTag"].Value.ToString();
                                        //f.SkillsNowAreaPath = e.Cell.Row.Cells["fldProtectionDescription"].Value.ToString();
                                        DialogResult dr = f.ShowDialog();
                                        if (dr == System.Windows.Forms.DialogResult.OK) //if a document was selected
                                        {
                                            if (f.SelectedDocumentTitle != "" && f.SelectedDocumentPath != "")
                                            {
                                                //do something with them TODO:
                                                System.IO.FileInfo fi = new System.IO.FileInfo(f.SelectedDocumentPath);
                                                //System.IO.DirectoryInfo di = new System.IO.DirectoryInfo(f.SelectedDocumentPath);
                                                string FileNamePart = fi.Name;
                                                e.Cell.Row.Cells["fldPrimaryTag"].Value = FileNamePart;// f.SelectedDocumentTitle;
                                                if (e.Cell.Row.Cells["fldProtectionDescription"].Value.ToString() == "")
                                                {
                                                    e.Cell.Row.Cells["fldProtectionDescription"].Value = f.SelectedDocumentTitle; //
                                                }
                                                e.Cell.Row.Cells["fldProtOpDocumentPath"].Value = f.SelectedDocumentPath;
                                                //MessageBox.Show("Ok, what to do with these:" + "\r\n" + f.SkillsNowAreaPath + "\r\n" + f.SelectedDocumentPath + "\r\n" + f.SelectedDocumentTitle);
                                            }
                                        }

                                    }
                                    break;//use SkillsNow search form
                                }
                            default:
                                {
                                    if (TagType.Trim() != "")
                                    {
                                        frmSearchProtectionSIF_or_TAG f = new frmSearchProtectionSIF_or_TAG(ScenarioID, PHA, TagType, true, sFacilityCode, sExistingTag);
                                        try
                                        {
                                            DialogResult dr = f.ShowDialog(this);
                                            if (dr == System.Windows.Forms.DialogResult.OK)
                                            {
                                                e.Cell.Row.Cells["fldPrimaryTag"].Value = f.SIForTAGResult;
                                            }
                                        }
                                        catch { } //user was presented error message
                                    }
                                    break;
                                }
                        }
                        break;
                    }
            }
        }

        private void ugProt2_CellChange(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {
                case "fldSafetyCritical":
                    {
                        ugProt2.PerformAction(UltraGridAction.ExitEditMode);
                        //CalculateOveralProtectionsPFD();
                        break;
                    }
            }
        }
        private void CalculateOverallProtectionsMTBF()
        {
            double dProb = 0;
            double.TryParse(txtOverallProb.Text, out dProb);
            double dScenarioOccursFreq = 0.0;
            double dScenarioOccursAndProtectionsFailFreq = 0.0;
            if (ugInitEvents.Rows.Count > 0)
            {
                foreach (UltraGridRow r in ugInitEvents.Rows)
                {
                    double rMTBF = 0;
                    if (double.TryParse(r.Cells["fldEventMTBF"].Value.ToString(), out rMTBF))
                    {
                        dScenarioOccursFreq += (1.0 / rMTBF);
                    }
                }
                dScenarioOccursFreq = 1.0 / (dScenarioOccursFreq * dProb);
                if (!(double.IsNaN(dScenarioOccursFreq) || double.IsNegativeInfinity(dScenarioOccursFreq) || double.IsPositiveInfinity(dScenarioOccursFreq)))//if this is a number
                {
                        string sOutput = dScenarioOccursFreq.ToString("0.##E+00");
                        double dNewVal = 0.0;
                        double.TryParse(sOutput, out dNewVal);
                        double dOldVal = 0.0;
                        double.TryParse(txtOverallMTBF.Text, out dOldVal);
                        //change Scenario Freq only if the value is different
                        //if (dNewVal != dOldVal)
                        //{
                        //    txtOverallMTBF.Text = sOutput;//on causes tab
                        //   // txtFreqDev.Text = txtOverallMTBF.Text; //on consequences tab
                        //}
                    //factor in protections and write to txtFreqDev
                        double dOverallPFDofProtections = 0.0;
                        if (double.TryParse(txtOverallPFD.Text, out dOverallPFDofProtections))
                        {
                            dScenarioOccursAndProtectionsFailFreq = dScenarioOccursFreq / dOverallPFDofProtections;  //divide by the failure rate of the protections 
                            sOutput = dScenarioOccursAndProtectionsFailFreq.ToString("0.##E+00");
                            double.TryParse(sOutput, out dNewVal);
                            double.TryParse(txtFreqDev.Text, out dOldVal);
                            if (dNewVal != dOldVal)
                            {
                                txtOverallMTBF.Text = sOutput;
                            }
                        }
                   
                }
            }
            else
            {
                if (txtOverallMTBF.Text != "")
                {
                    txtOverallMTBF.Text = "";
                }
                if (txtFreqDev.Text != "")
                {
                    txtFreqDev.Text = "";
                }
            }
        }
        private string GetProtectionType(string TagType)
        {
            DataTable dtProtectionTypes = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtectionTypes");
            DataRow[] dra = dtProtectionTypes.Select(" fldProtectionTypeCode = '" + TagType + "' ");
            string ProtectionValidateType = "";
            if (dra.Length > 0)
            {
                ProtectionValidateType = dra[0]["fldValidationSourceCode"].ToString();
            }
            return ProtectionValidateType;
        }
        private void ugProt2_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Cells["Search"].ButtonAppearance.TextHAlign = Infragistics.Win.HAlign.Center;
            e.Row.Cells["btnCopyPFD"].ButtonAppearance.TextHAlign = Infragistics.Win.HAlign.Center;
            e.Row.Cells["btnCopyPFD"].Value = "<";
        }
        private void CalculateOverallProtectionsPFD()
        {
            if (ugProt2.Rows.Count > 0)
            {
                DataTable dtCalcPFD = new DataTable("dtCalcPfd");
                DataColumn dcLevel = new DataColumn("Level", typeof(int));
                dtCalcPFD.Columns.Add(dcLevel);
                DataColumn dcItem = new DataColumn("Item", typeof(int));
                dtCalcPFD.Columns.Add(dcItem);
                DataColumn dcPFD = new DataColumn("PFD", typeof(float));
                dtCalcPFD.Columns.Add(dcPFD);

                foreach (UltraGridRow row in ugProt2.Rows)
                {
                    int iCrit = 0;
                    try
                    {
                        iCrit = Convert.ToInt32(row.Cells["fldSafetyCritical"].Value);
                    }
                    catch { }
                    if (iCrit > 0) //is this safety Critical?
                    {
                        float PFD = 0.0F;
                        if (float.TryParse(row.Cells["fldProtPFD"].Value.ToString(), out PFD))
                        {
                            int Level = Convert.ToInt32(row.Cells["fldProtectionGroup"].Value);
                            int Item = Convert.ToInt32(row.Cells["fldProtectionSequence"].Value);
                            DataRow dr = dtCalcPFD.NewRow();
                            dr["Level"] = Level;
                            dr["Item"] = Item;
                            dr["PFD"] = PFD;
                            dtCalcPFD.Rows.Add(dr);
                        }
                    }
                }
                /* method in official spec
                //get sum of item PFDs for each level
                float OveralPFD = 1;
                DataView dv = new DataView(dtCalcPFD);
                DataTable dtLevels = dv.ToTable(true, "Level");
                foreach (DataRow drLevel in dtLevels.Rows)
                {
                    float LevelPFD = 0;
                    DataRow[] drItems = dtCalcPFD.Select(" Level = " + drLevel["Level"].ToString() + " ");
                    foreach (DataRow drItem in drItems)
                    {
                        LevelPFD += Convert.ToSingle(drItem["PFD"]);
                    }
                    OveralPFD *= LevelPFD;

                }
                 */
                /* Emily's method (see e-mail 11 Jul 2012) */
                float OveralPFD = 1F;
                float LevelPFD = 0F;
               // float o2 = 1F;
                DataView dv = new DataView(dtCalcPFD);
                DataTable dtLevels = dv.ToTable(true, "Level");
                foreach (DataRow drLevel in dtLevels.Rows)
                {

                    LevelPFD = 0F;
                    DataRow[] drItems = dtCalcPFD.Select(" Level = " + drLevel["Level"].ToString() + " ");
                    foreach (DataRow drItem in drItems)
                    {
                        float itemPFD = 0F;
                        if (float.TryParse(drItem["PFD"].ToString(), out itemPFD))
                        {
                            LevelPFD = LevelPFD + itemPFD - (LevelPFD * itemPFD);//"rigorous method" subtracts overlap per Lou N.  16 Jul 2012
                        }
                        
                    }
                    OveralPFD *= LevelPFD;
                    //OveralPFD *= (1F - levelProduct);

                }
                /* Emily's method (11 Jul 2012 & Nicholes changes 16 Jul 2012 & Lou's rigorus method 17 Jil 2012 */
                string sPFD = OveralPFD.ToString("0.#####E+00");

                txtOverallPFD.Text = sPFD;
                dtCalcPFD.Dispose();
            }
            else
            {
                txtOverallPFD.Text = "";
            }
            //The Overall PFD of Critical Protections is calculated as follows
            //PFD = 1
            //Foreach Level
            //Item sum = 0
            //Foreach Item in this level
            //If ( critical item is checked ) 
            //Item sum += PFD
            //Next item
            //PFD = PFD * item Sum for the level
            //Next level
            //Overall PFD = PFD from calculation
        }
        private void ugProt2_AfterCellUpdate(object sender, CellEventArgs e)
        {

            switch (e.Cell.Column.Key)
            {
                case "fldProtectionTypeCode"://look up value for PFD colum
                    {
                        //int index = -1;

                        //object oNewValue = e.Cell.ValueListResolved.GetValue(e.Cell.Text, ref index);


                        UltraGridCell cell_fldProtPFD = e.Cell.Row.Cells["fldProtPFD"];
                        //string ProtectionType = oNewValue.ToString();//
                        string ProtectionType = e.Cell.Value.ToString();
                        //find assumed PFD in protection type table
                        foreach (DataRow dr in ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtectionTypes").Rows)
                        {
                            if (dr["fldProtectionTypeCode"].ToString() == ProtectionType)
                            {
                                if (dr["fldDefProtPFD"] != DBNull.Value)
                                {
                                    Single sng = Single.Parse(dr["fldDefProtPFD"].ToString());
                                    cell_fldProtPFD.Value = sng;
                                }
                                break;
                            }
                        }
                        break;
                    }
                case "fldProtectionGroup": //level
                    {

                        //The user can change this value.  
                        //When they do so, the item number needs to be updated                         
                        //to the highest item number in this level + 1
                        int iUserLevel = 0;
                        try
                        {
                            iUserLevel = Convert.ToInt32(e.Cell.Value);
                        }
                        catch
                        {
                            return;
                        }
                        int iRowLevel = 0;
                        int iItem = 0;
                        foreach (DataRow r in dsScenarioDetails.Tables["tblProtections"].Rows)
                        {
                            if (r.RowState != DataRowState.Deleted)
                            {
                                if (r["fldProtectionGroup"] != DBNull.Value)
                                {
                                    iRowLevel = Convert.ToInt32(r["fldProtectionGroup"]);
                                }
                                if (iRowLevel == iUserLevel)
                                {
                                    if (r["fldProtectionSequence"] != DBNull.Value)
                                    {
                                        int iRowItem = Convert.ToInt32(r["fldProtectionSequence"]);
                                        if (iRowItem > iItem)
                                        {
                                            iItem = iRowItem;
                                        }
                                    }
                                }
                            }

                        }
                        e.Cell.Row.Cells["fldProtectionSequence"].Value = iItem + 1;
                        break;
                    }
                case "fldProtectionSequence": //item
                    {
                        /*
                        The user can change this value.  
                        When they do so, the program should 
                        check that we don’t have any non-unique 
                        level / item records and warn the user, 
                        but allow the change to continue
                        validiation will prevent saving if this condition is not corrected
                         */
                        break;
                    }
                case "fldProtPFD":
                case "fldSafetyCritical":
                    {
                        CalculateOverallProtectionsPFD();
                        break;
                    }

            }

        }

        private void btnAddProt2_Click(object sender, EventArgs e)
        {
            //find highest level, add 1
            int iLevel = 0;
            foreach (DataRow r in dsScenarioDetails.Tables["tblProtections"].Rows)
            {
                if (r.RowState != DataRowState.Deleted)
                {
                    int rowLevel = Convert.ToInt32(r["fldProtectionGroup"]);
                    if (rowLevel > iLevel)
                    {
                        iLevel = rowLevel;
                    }
                }
            }
            //add an empty row to the underlying table
            DataRow dr = dsScenarioDetails.Tables["tblProtections"].NewRow();
            dr["fldSafetyCritical"] = 0; //set to non critical to begin with
            dr["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
            dr["fldProtectionGroup"] = iLevel + 1;
            dr["fldProtectionSequence"] = 1;
            dsScenarioDetails.Tables["tblProtections"].Rows.Add(dr);
            ugProt2.DataBind();
        }

        private void ugProt2_BeforeExitEditMode(object sender, BeforeExitEditModeEventArgs e)
        {
            //validate the datagrid
        }

        #endregion
        #region DependenciesTab
        private void bindDependenciesTab()
        {
            ugDependencies.DataSource = dsScenarioDetails.Tables["tblDependencies"];
        }
        private void ugDependencies_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;
            uddDependencyUOM.SetDataBinding(ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcProtSetPointUomTypes"), null);
            uddDependencyUOM.ValueMember = "fldProtSetPointUom";
            foreach (UltraGridColumn ddcUOM in uddDependencyUOM.DisplayLayout.Bands[0].Columns)
            {
                switch (ddcUOM.Key)
                {
                    case "fldProtSetPointUom":
                        {
                            ddcUOM.Header.Caption = "UOM Code";
                            break;
                        }
                    case "fldProtSetPointUomDescr":
                        {
                            ddcUOM.Header.Caption = "UOM Descr";
                            ddcUOM.Width = 200;
                            break;
                        }
                    default:
                        {
                            ddcUOM.Hidden = true;
                            break;
                        }
                }
            }
            uddDependencyTypes.SetDataBinding(ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("tbcDependencyTypes"), null);
            uddDependencyTypes.ValueMember = "fldDependencyTypeCode";
            foreach (UltraGridColumn ddc in uddDependencyTypes.DisplayLayout.Bands[0].Columns)
            {
                switch (ddc.Key)
                {
                    case "fldDependencyTypeCode":
                        {
                            ddc.Header.Caption = "Type Code";
                            break;
                        }
                    case "fldDependencyTypeDescription":
                        {
                            ddc.Header.Caption = "Type Descr";
                            ddc.Width = 300;
                            break;
                        }
                    case "DependencyTypeSequence":
                        {
                            ddc.Header.Caption = "Type Seq";
                            // ddc.Width = 300;
                            break;
                        }
                    case "fldReferenceType":
                        {
                            ddc.Header.Caption = "Ref Type";
                            // ddc.Width = 300;
                            break;
                        }
                    case "fldDefaultPmInterval":
                        {
                            ddc.Header.Caption = "PM int";
                            //  ddc.Width = 300;
                            break;
                        }

                    default:
                        {
                            ddc.Hidden = true;
                            break;
                        }
                }
            }
            uddDependencyTypes.DisplayMember = "fldDependencyTypeCode";

            foreach (UltraGridColumn c in e.Layout.Bands[0].Columns)
            {
                if (AllowEdit)
                {
                    c.CellActivation = Activation.AllowEdit;
                }
                else
                {
                    //   c.CellActivation = Activation.ActivateOnly;
                }
                // c.Hidden = true;
                switch (c.Key)
                {
                    case "fldDependencyID":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "fldScenarioUID":
                        {
                            break;
                        }
                    case "fldDependencySequence":
                        {
                            c.Header.Caption = "Sort";
                            c.Hidden = true;//per Lou in review session
                            break;
                        }
                    case "fldDependencyTypeCode":
                        {
                            c.ValueList = uddDependencyTypes;
                            break;
                        }
                    case "fldDependencyReference":
                        {
                            break;
                        }
                    case "fldDependencyDescription":
                        {
                            break;
                        }
                    case "fldSetPoint":
                        {
                            break;
                        }
                    case "fldSetPointUOM":
                        {
                            //  c.Header.VisiblePosition = 9;
                            c.Header.Caption = "UOM";
                            c.Width = 70;
                            c.EditorComponent = uteDependencySetpointUOM;
//                            c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownValidate;
//                            c.ValueList = uddProtUOM;
                            break;
                        }
                    case "fldSetPointIsNOL":
                        {
                            break;
                        }
                    case "fldRequiredPmInterval":
                        {
                            break;
                        }
                    case "fldTimeStamp":
                        {
                            c.Hidden = true;
                            break;
                        }
                    case "btnSearchForRef":
                        {
                            c.Width = 22;
                            c.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
                            c.ButtonDisplayStyle = ButtonDisplayStyle.Always;
                            c.CellButtonAppearance.Image = this.imageList.Images["Search"];
                            break;
                        }
                    default:
                        {
                            c.Hidden = true;
                            break;
                        }
                }
            }

        }

        private void btnAddDependency_Click(object sender, EventArgs e)
        {
            DataTable dtDependencies = ((DataTable)ugDependencies.DataSource);//reference to tblDependencies for this scenario 
            DataRow drNewDependency = dtDependencies.NewRow();
            drNewDependency["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
            //drNewDependency["fldDependencyDescription"] = "gibberish";
            dtDependencies.Rows.Add(drNewDependency);
            ugDependencies.DataBind();

        }

        private void ugDependencies_AfterCellUpdate(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {

                case "fldDependencyTypeCode":
                    {
                        DataRow[] drDependencyType = ((DataTable)uddDependencyTypes.DataSource).Select("fldDependencyTypeCode = '" + e.Cell.Value.ToString() + "' ");
                        if (drDependencyType.Length > 0)
                        {
                            //[fldDependencyTypeDescription]
                            //      ,[fldDependencySequence]
                            //      ,[fldReferenceType]
                            //      ,[fldDefaultPmInterval]

                            //,[fldDependencySequence]
                            //,[fldDependencyTypeCode]
                            //,[fldDependencyReference]
                            //,[fldDependencyDescription]
                            //,[fldSetPoint]
                            //,[fldSetPointUOM]
                            //,[fldSetPointIsNOL]
                            //,[fldRequiredPmInterval]

                            e.Cell.Row.Cells["fldDependencySequence"].Value = drDependencyType[0]["DependencyTypeSequence"];
                            e.Cell.Row.Cells["fldRequiredPmInterval"].Value = drDependencyType[0]["fldDefaultPmInterval"];
                            string sRefType = drDependencyType[0]["fldReferenceType"].ToString();
                            if (sRefType != "FL" && sRefType != "IF")
                            {
                                //disable setpoints
                                e.Cell.Row.Cells["fldSetPoint"].Value = "";
                                e.Cell.Row.Cells["fldSetPoint"].Activation = Activation.Disabled;
                                e.Cell.Row.Cells["fldSetPointUOM"].Value = "";
                                e.Cell.Row.Cells["fldSetPointUOM"].Activation = Activation.Disabled;
                            }
                            else
                            {
                                //enable setpoints
                                e.Cell.Row.Cells["fldSetPoint"].Activation = Activation.AllowEdit;
                                e.Cell.Row.Cells["fldSetPointUOM"].Activation = Activation.AllowEdit;
                            }
                        }
                        break;
                    }
            }
        }

        private void ugDependencies_ClickCellButton(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key == "btnSearchForRef")
            {
                string sTypeCode = "";
                DataRow[] drDependencyType = ((DataTable)uddDependencyTypes.DataSource).Select("fldDependencyTypeCode = '" + e.Cell.Row.Cells["fldDependencyTypeCode"].Value.ToString() + "' ");
                if (drDependencyType.Length > 0)
                {
                    sTypeCode = drDependencyType[0]["fldReferenceType"].ToString();

                    //launch a dialog to search for a functional location
                    //get facility for this scenario:
                    string sExistingTag = e.Cell.Row.Cells["fldDependencyReference"].Value.ToString();
                    string sFacilityCode = dsScenarioDetails.Tables["tblPHAs"].Rows[0]["fldFacilityCode"].ToString();
                    string ScenarioID = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"].ToString();
                    string PHA = dsScenarioDetails.Tables["tblPHAs"].Rows[0]["fldPhaDocNum"].ToString();
                    string TagType = sTypeCode;// e.Cell.Row.Cells["fldProtectionTypeCode"].Text;
                    frmSearchProtectionSIF_or_TAG f = new frmSearchProtectionSIF_or_TAG(ScenarioID, PHA, TagType, false, sFacilityCode, sExistingTag);
                    DialogResult dr = f.ShowDialog(this);
                    if (dr == System.Windows.Forms.DialogResult.OK)
                    {
                        if (f.SIForTAGResult.Trim() != "")
                        {
                            e.Cell.Row.Cells["fldDependencyReference"].Value = f.SIForTAGResult;
                        }
                    }
                }
            }
        }

        private void ugDependencies_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            //            e.Row.Cells["btnSearchForRef"].Value = "search";
        }

        private void ugDependencies_DoubleClickCell(object sender, DoubleClickCellEventArgs e)
        {
            if (e.Cell.Column.Key == "fldDependencyReference")
            {
                //launch a dialog to search for a functional location
                int i = 0;
            }
        }
        #endregion
        #region RiskTab
        private void CreateRiskGraphics()
        {
            //create dynamic controls:
            CreateEnvironmentalRiskGrid();
           // InitSocietalRiskChart(1e-5);
            CreateMIR_RiskChart(pnlMIRContainer);
            CreateMIR_RiskChart(pnlMIRContainerHeader);
            CreateFIN_RiskChart(pnlFINContainer);
        }

        private Button ArrowButton(bool bPointLeft)
        {
            Button btnArrow = new System.Windows.Forms.Button();
            //this.pnlFinRisk.Controls.Add(btnArrow);
            btnArrow.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
            btnArrow.Enabled = false;
            btnArrow.FlatAppearance.BorderSize = 0;
            btnArrow.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            btnArrow.Location = new System.Drawing.Point(104, 116);
            if (bPointLeft)
            {
                btnArrow.BackgroundImage = global::ConocoPhillips.PHA.UI.Properties.Resources.LeftArrow;
                btnArrow.BackColor = System.Drawing.Color.Green;
                btnArrow.Name = "btnLeftArrow";
            }
            else
            {
                btnArrow.BackgroundImage = global::ConocoPhillips.PHA.UI.Properties.Resources.RightArrow;
                btnArrow.BackColor = System.Drawing.Color.Red;
                btnArrow.Name = "btnRightArrow";
            }
            btnArrow.Size = new System.Drawing.Size(12, 21);
            btnArrow.TabIndex = 6;
            btnArrow.UseVisualStyleBackColor = false;
            return btnArrow;


        }
        private void bindRiskTab()
        {
            //SetMirChartNeedle((float)0.0, pnlMIRContainer, tbMirIndicatorNeedleRiskTab);//demo only.  eventually call this when the log of the risk in years is known for a PHA
            //SetMirChartNeedle((float)0.0, pnlMIRContainerHeader, tbMirIndicatorNeedleHdr);//demo only.  eventually call this when the log of the risk in years is known for a PHA
            //SetMirChartNeedle(5.5, pnlFINContainer, tbFINIndicatorNeedle);
            DisplayRisks();
            //CreateFin_RiskChart(Convert.ToInt32(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"].ToString()));
        }

        private void CreateEnvironmentalRiskGrid()
        {
            ScenarioManager sm = new ScenarioManager();
            DataSet dsMatrixLayout = sm.GetRiskMatrixLayout();
            int iCols = (int)dsMatrixLayout.Tables[0].Rows[0][0];
            int iRows = (int)dsMatrixLayout.Tables[1].Rows[0][0];
            TableLayoutPanel tpMatrix = new TableLayoutPanel();
            tpMatrix.Margin = new Padding(2);
            tpMatrix.Padding = new Padding(2);

            tpMatrix.CellBorderStyle = TableLayoutPanelCellBorderStyle.Single;
            //remove any default rows and columns
            while (tpMatrix.ColumnStyles.Count > 0)
            {
                tpMatrix.ColumnStyles.RemoveAt(0);
            }
            while (tpMatrix.RowStyles.Count > 0)
            {
                tpMatrix.RowStyles.RemoveAt(0);
            }
            //create the number or rows and columns we need
            for (int c = 0; c < iCols; c++)
            {
                System.Windows.Forms.ColumnStyle cs = new System.Windows.Forms.ColumnStyle(SizeType.Percent, 100 / iCols);
                tpMatrix.ColumnStyles.Add(cs);
            }
            for (int r = 0; r < iRows; r++)
            {
                System.Windows.Forms.RowStyle rs = new System.Windows.Forms.RowStyle(SizeType.Percent, 100 / iRows);
                tpMatrix.RowStyles.Add(rs);
            }
            //create a panel at each cell:
            dctEnvGridPanels = new Dictionary<int, Dictionary<int, Panel>>();//reset the dictionary
            for (int r = 0; r < iRows; r++)
            {
                Dictionary<int, Panel> rowDict = new Dictionary<int, Panel>();
                for (int c = 0; c < iCols; c++)
                {
                    Panel p = new Panel();
                    p.Dock = DockStyle.Fill;
                    //p.BackColor = Color.Blue;
                    p.Padding = new System.Windows.Forms.Padding(2);
                    p.Margin = new System.Windows.Forms.Padding(2);
                    tpMatrix.Controls.Add(p);
                    //TextBox ll = new TextBox();
                    //ll.Width = tpMatrix.Width;
                    //ll.Height = tpMatrix.Height;
                    //ll.AutoSize = false;
                    //ll.Multiline = true;
                    //ll.BackColor = Color.Transparent;
                    //ll.BorderStyle = BorderStyle.None;
                    //ll.Text = r.ToString() + c.ToString();//fill in cell address as a placeholder
                    //p.Controls.Add(ll);
                    //rowDict.Add(c, ll);
                    tpMatrix.SetCellPosition(p, new TableLayoutPanelCellPosition(c, r));
                    Dictionary<int, Panel> cellDict = new Dictionary<int, Panel>();
                    rowDict.Add(c, p);
                }
                dctEnvGridPanels.Add(r,rowDict);
            }
            //tpMatrix.Top = 48;
            //tpMatrix.Left = 575;
            //tpMatrix.Height = tp1.Height;
            //tpMatrix.Width = tp1.Width;
            //tpMatrix.BackColor = Color.Pink;
            tpMatrix.Visible = true;
            pnlEnvRiskChart.Controls.Add(tpMatrix);
            tpMatrix.Dock = DockStyle.Fill;
            foreach (DataRow dr in dsMatrixLayout.Tables[2].Rows)
            {
                int col = (int)dr["fldConsequence"];
                int row = (int)dr["fldLikelihood"];
                int tblRow = iRows - row;
                int tblCol = col - 1;
                Control c = tpMatrix.GetControlFromPosition(tblCol, tblRow);
                //Control c = tp1.GetControlFromPosition(tblCol,tblRow);
                Color cl = new Color();
                switch ((int)dr["fldRisk"])
                {
                    case 1:
                        {
                            cl = Color.Green;
                            break;
                        }
                    case 2:
                        {
                            cl = Color.Yellow;
                            break;
                        }
                    case 3:
                        {
                            cl = Color.Orange;
                            break;
                        }
                    case 4:
                        {
                            cl = Color.Red;
                            break;
                        }
                }
                c.BackColor = cl;
            }
            Label riskTitle = new Label();
            riskTitle.Font = new Font(riskTitle.Font, FontStyle.Bold);
            riskTitle.Text = "EnvironmentalRisk";
            riskTitle.TextAlign = ContentAlignment.TopCenter;
            riskTitle.Dock = DockStyle.Fill;
            pnlEnvRiskTitle.Controls.Add(riskTitle);
            pnlEnvRiskTitle.Dock = DockStyle.Fill;
            Label lblFooter = new Label();
            lblFooter.Font = new Font(lblFooter.Font, FontStyle.Bold);
            lblFooter.Text = "Consequence";
            lblFooter.TextAlign = ContentAlignment.TopCenter;
            lblFooter.Dock = DockStyle.Fill;
            pnlEnvRiskFooter.Controls.Add(lblFooter);
            TableLayoutPanel tpXaxis = new TableLayoutPanel();
            for (int i = 0; i < iCols; i++)
            {
                tpXaxis.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.Percent, 100 / iCols));
            }
            tpXaxis.RowStyles.Add(new RowStyle(SizeType.Percent, 100));
            //Label lStuff = new Label();
            //lStuff.Text = "THIS STUFF";
            //pnlEnvRiskXaxis.Controls.Add(lStuff);
            //lStuff.Dock = DockStyle.Fill;
            for (int i = 0; i < iCols; i++)
            {
                Label lbCol = new Label();
                lbCol.Font = new Font(lbCol.Font, FontStyle.Bold);
                lbCol.Text = (i + 1).ToString();
                lbCol.TextAlign = ContentAlignment.MiddleCenter;
                lbCol.Dock = DockStyle.Fill;
                //lbCol.BackColor = Color.Chartreuse;
                tpXaxis.Controls.Add(lbCol);
                tpXaxis.SetCellPosition(lbCol, new TableLayoutPanelCellPosition(i, 0));
            }
            //  tpXaxis.BackColor = Color.BlueViolet;
            pnlEnvRiskXaxis.Controls.Add(tpXaxis);
            tpXaxis.Dock = DockStyle.Fill;
            //create vertical table and add y axis labels in pnlEnvRiskYaxis
            TableLayoutPanel tpYaxis = new TableLayoutPanel();
            tpYaxis.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.Percent, 100));
            for (int i = 0; i < iRows; i++)
            {
                tpYaxis.RowStyles.Add(new RowStyle(SizeType.Percent, 100 / iRows));
            }
            DataRow[] drLabels = dsMatrixLayout.Tables[2].Select(" fldConsequence = 1", " fldLikelihood desc");
            for (int i = 0; i < iRows; i++)
            {
                Label lbRow = new Label();
                int iMTBF = Convert.ToInt32(drLabels[i]["fldScenarioMaxMTBF"].ToString());
                if (i == 0)//special label
                {
                    lbRow.Text = "<" + 10.ToString("0E+00");
                }
                else
                {
                    lbRow.Text = ">" + iMTBF.ToString("0E+00");
                }
                //lbRow.Text = i.ToString() + "xx";
                //lbRow.Font = new Font(lbRow.Font, FontStyle.Bold);
                lbRow.TextAlign = ContentAlignment.MiddleRight;
                lbRow.Dock = DockStyle.Fill;
                //  lbRow.BackColor = Color.AliceBlue;

                tpYaxis.Controls.Add(lbRow);
                tpYaxis.SetCellPosition(lbRow, new TableLayoutPanelCellPosition(0, i));
            }
            pnlEnvRiskYaxis.Controls.Add(tpYaxis);
            tpYaxis.Dock = DockStyle.Fill;
            RotatingLabel rlFreq = new RotatingLabel();
            rlFreq.TextAlign = ContentAlignment.MiddleCenter;
            rlFreq.NewText = "Frequency (years)";
            rlFreq.RotateAngle = -90;
            rlFreq.Font = new Font(rlFreq.Font, FontStyle.Bold);
            rlFreq.Parent = pnlFreqLabel;
            rlFreq.Dock = DockStyle.Fill;
            // pnlFreqLabel.BackColor = Color.DarkGoldenrod;
        }
        private void InitSocietalRiskChart_0()
        {
            //ScenarioManager sm = new ScenarioManager();
            //DataSet dsSRChartLayout = sm.GetSocietalRiskChartLayout();
            //adjust static ranges
            List<System.Windows.Forms.DataVisualization.Charting.Series> Lseries = new List<Series>();
            DataPoint p = null;
            foreach (System.Windows.Forms.DataVisualization.Charting.Series s in chartSocRisk.Series)
            {
                s.Points.Clear();
                switch (s.Name.ToLower())
                {
                    case "green":
                        {
                            p = new DataPoint(0.1, 1000000);
                            p.Color = Color.Green;
                            s.Points.Add(p);
                            p = new DataPoint(100, 1000000);
                            p.Color = Color.Green;
                            s.Points.Add(p);
                            break;
                        }
                    case "yellow":
                        {
                            p = new DataPoint(0.1, 1000);
                            p.Color = Color.Yellow;
                            s.Points.Add(p);
                            p = new DataPoint(100, 1000000);
                            p.Color = Color.Yellow;
                            s.Points.Add(p);
                            break;
                        }
                    case "orange":
                        {
                            p = new DataPoint(0.1, 100);
                            p.Color = Color.Orange;
                            s.Points.Add(p);
                            p = new DataPoint(100, 100000);
                            p.Color = Color.Orange;
                            s.Points.Add(p);
                            break;
                        }
                    case "red":
                        {
                            p = new DataPoint(0.1, 10);
                            p.Color = Color.Red;
                            s.Points.Add(p);
                            p = new DataPoint(100, 10000);
                            p.Color = Color.Red;
                            s.Points.Add(p);
                            break;
                        }

                }
                Lseries.Add(s);
            }
        }

        private void InitSocietalRiskChart(double MinFatalities)
        {
            if (MinFatalities > 1.0F)
            {
                MinFatalities = 1.0F; //start graph at 1 
            }
            chartSocRisk.ChartAreas[0].AxisX.Minimum = MinFatalities;
            chartSocRisk.ChartAreas[0].AxisX2.Minimum = MinFatalities;
            ScenarioManager sm = new ScenarioManager();
            double YellowUnity = 0.0;
            double OrangeUnity = 0.0;
            double RedUnity = 0.0;
            double Yellow100F = 0.0;
            double Orange100F = 0.0;
            double Red100F = 0.0;

            DataTable dtRiskChartLayout = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("SocietalRiskChartLayout");
//            DataSet dsSRChartLayout = sm.GetSocietalRiskChartLayout();
            if (dtRiskChartLayout != null && dtRiskChartLayout.Rows.Count > 0)
            {
                foreach (DataRow dr in dtRiskChartLayout.Rows)
                {
                    string sColor = dr["color"].ToString();
                    double ColorUnity = 0.0;
                    double Color100F = 0.0;
                    double.TryParse(dr["YearsPer1Fatality"].ToString(), out ColorUnity);
                    double.TryParse(dr["YearsPer100Fatality"].ToString(), out Color100F);
                    switch (sColor.ToLower())
                    {
                        case "yellow":
                            {
                                YellowUnity = ColorUnity;
                                Yellow100F = Color100F;
                                break;
                            }
                        case "orange":
                            {
                                OrangeUnity = ColorUnity;
                                Orange100F = Color100F;
                                break;
                            }
                        case "red":
                            {
                                RedUnity = ColorUnity;
                                Red100F = Color100F;
                                break;
                            }

                    }
                }
            }
            List<System.Windows.Forms.DataVisualization.Charting.Series> Lseries = new List<Series>();
            DataPoint p = null;
            double dSlope = 1.0;
            string[] sRanges = { "Green", "Yellow", "Orange", "Red" };
            double.TryParse(dtRiskChartLayout.Rows[0]["slope"].ToString(), out dSlope);
            int ColorAlpha = 225;// 255;
            Color tGreen = Color.FromArgb(ColorAlpha, 0, 128, 0);
            Color tYellow = Color.FromArgb(ColorAlpha, 255, 255, 0);
            Color tOrange = Color.FromArgb(ColorAlpha, 255, 165, 0);
            Color tRed = Color.FromArgb(ColorAlpha, 255, 0, 0);
            double[] yRange = {0.0,0.0};
            foreach (string sSeriesName in sRanges)//(System.Windows.Forms.DataVisualization.Charting.Series s in chartSocRisk.Series)
            {
                System.Windows.Forms.DataVisualization.Charting.Series s = chartSocRisk.Series[sSeriesName];
                s.Points.Clear();
                s.ChartType = SeriesChartType.Range;// Line;//.Area;
                
                switch (s.Name.ToLower())
                {
                    case "green":
                        {
                          //  s.ChartType = SeriesChartType.Range;
                            double[] yRange0 = {1E6,YellowUnity * MinFatalities};
                            p = new DataPoint(MinFatalities, yRange0);
                            p.Color = tGreen;
                            s.Points.Add(p);
                            double[] yRange1 = { 1e6, 1e6 };
                            p = new DataPoint(100, yRange1);
                            p.Color = tGreen;
                            s.Points.Add(p);
                            break;
                        }
                    case "yellow":
                        {
                            double[] yRange0 = { YellowUnity * MinFatalities, OrangeUnity * MinFatalities };
                            double dRangeMin = YellowUnity * MinFatalities;
                            p = new DataPoint(MinFatalities, yRange0);
                            p.Color = tYellow;
                            s.Points.Add(p);
                            double[] yRange1 = { Yellow100F,Orange100F };
                            p = new DataPoint(100, yRange1);
                            p.Color = tYellow;
                            s.Points.Add(p);
                            break;
                        }
                    case "orange":
                        {
                            double[] yRange0 = { OrangeUnity * MinFatalities, RedUnity * MinFatalities };
                            double dRangeMin = OrangeUnity * MinFatalities;
                            p = new DataPoint(MinFatalities, yRange0);
                            p.Color = tOrange;
                            s.Points.Add(p);
                            double[] yRange1 = { Orange100F,Red100F };
                            p = new DataPoint(100, yRange1);
                            p.Color = tOrange;
                            s.Points.Add(p);
                            break;
                        }
                    case "red":
                        {
                            double dRangeMin = RedUnity * MinFatalities;
                            p = new DataPoint(MinFatalities, dRangeMin);
                            p.Color = tRed;
                            s.Points.Add(p);
                            p = new DataPoint(100, 10000);
                            p.Color = tRed;
                            s.Points.Add(p);
                            break;
                        }

                }
                Lseries.Add(s);
            }
        }


        private int FINRiskRank(double dTotalFin)
        {//dTotalFin is financial risk in thousands
            int iRank = 0;
            ScenarioManager sm = new ScenarioManager();
            DataSet dsFinChartLayout = sm.GetFin_RiskChartLayout();
            if (dsFinChartLayout.Tables.Count > 0 && dsFinChartLayout.Tables[0].Rows.Count > 0)
            {
                foreach (DataRow drRank in dsFinChartLayout.Tables[0].Rows)
                {
                    Int32 Start = 0;
                    Int32 End = 0;
                    if (Int32.TryParse(drRank["start"].ToString(), out Start) && Int32.TryParse(drRank["end"].ToString(), out End))
                    {
                        if (dTotalFin >= Start && dTotalFin < End)
                        {
                            if (int.TryParse(drRank["order"].ToString(), out iRank))
                            {
                                iRank += 1;
                            }
                        }
                    }
                }
            }


            return iRank;
        }
        private int MIRRiskRank(double dTotalMir)
        {
            int iRank = 0;
            ScenarioManager sm = new ScenarioManager();
            DataSet dsMIRChartLayout = sm.GetMIR_RiskChartLayout();
            if (dsMIRChartLayout.Tables.Count > 0 && dsMIRChartLayout.Tables[0].Rows.Count > 0)
            {
                foreach (DataRow drRank in dsMIRChartLayout.Tables[0].Rows)
                {
                    double dStart = 0.0;
                    double.TryParse(drRank["start"].ToString(),out dStart);
                    double dEnd  = double.MaxValue;
                    double.TryParse(drRank["end"].ToString(), out dEnd);

                    if(dTotalMir <=dStart && dTotalMir > dEnd)
                    {
                        switch (drRank["color"].ToString().ToLower())
                        {
                            case "green":
                                {
                                    iRank = 1;
                                    break;
                                }
                            case "yellow":
                                {
                                    iRank = 2;
                                    break;
                                }
                            case "orange":
                                {
                                    iRank = 3;
                                    break;
                                }
                            case "red":
                                {
                                    iRank = 4;
                                    break;
                                }


                        }
                        break;
                    }
                }
            }
            return iRank;
        }
        private void CreateMIR_RiskChart(Panel pnlContainer)
        {
            pnlContainer.Controls.Clear();
            ScenarioManager sm = new ScenarioManager();
            DataSet dsMIRChartLayout = sm.GetMIR_RiskChartLayout();
            TableLayoutPanel tpMIRChart = new TableLayoutPanel();
            foreach (DataRow dr in dsMIRChartLayout.Tables[0].Rows)
            {
                int Start = (int)dr["LogStart"];
                int End = (int)dr["LogEnd"];
                //int Range = (int)dr["Range"];
                float Pct = (float)Convert.ToDouble(dr["PCT"]);// ((float)Start - (float)End) / (float)Range;
                tpMIRChart.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.Percent, Pct));
            }
            pnlContainer.Tag = (int)dsMIRChartLayout.Tables[0].Rows[0]["LogStart"]; // use this to compute position when adding needle marker
            for (int c = 0; c < tpMIRChart.ColumnStyles.Count; c++)
            {
                string color = (string)dsMIRChartLayout.Tables[0].Rows[c]["color"];
                Panel p = new Panel();
                p.Margin = new System.Windows.Forms.Padding(0);
                Color clr = new Color();
                switch (color.ToLower())
                {
                    case "green":
                        {
                            clr = Color.Green;
                            break;
                        }
                    case "yellow":
                        {
                            clr = Color.Yellow;
                            break;
                        }
                    case "orange":
                        {
                            clr = Color.Orange;
                            break;
                        }
                    case "red":
                        {
                            clr = Color.Red;
                            break;
                        }
                }
                p.BackColor = clr;
                tpMIRChart.Controls.Add(p);
                tpMIRChart.SetCellPosition(p, new TableLayoutPanelCellPosition(c, 0));
            }
            pnlContainer.Controls.Add(tpMIRChart);
            tpMIRChart.Dock = DockStyle.Fill;

        }
        private void CreateFIN_RiskChart(Panel pnlContainer)
        {
            //    CreateMIR_RiskChart(pnlContainer);
            //    return;
            pnlFINContainer.Controls.Clear();
            ScenarioManager sm = new ScenarioManager();
            DataSet dsFINChartLayout = sm.GetFin_RiskChartLayout();
            TableLayoutPanel tpFINChart = new TableLayoutPanel();
            foreach (DataRow dr in dsFINChartLayout.Tables[0].Rows)
            {
                int Start = (int)dr["LogStart"];
                int End = (int)dr["LogEnd"];
                //int Range = (int)dr["Range"];
                float Pct = (float)Convert.ToDouble(dr["PCT"]);// ((float)Start - (float)End) / (float)Range;
                tpFINChart.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.Percent, Pct));
            }
            int iLastRow = dsFINChartLayout.Tables[0].Rows.Count - 1;
            pnlFINContainer.Tag = (int)dsFINChartLayout.Tables[0].Rows[iLastRow]["LogEnd"]; // use this to compute position when adding needle marker
            for (int c = 0; c < tpFINChart.ColumnStyles.Count; c++)
            {
                string color = (string)dsFINChartLayout.Tables[0].Rows[c]["color"];
                Panel p = new Panel();
                p.Margin = new System.Windows.Forms.Padding(0);
                Color clr = new Color();
                switch (color.ToLower())
                {
                    case "green":
                        {
                            clr = Color.Green;
                            break;
                        }
                    case "yellow":
                        {
                            clr = Color.Yellow;
                            break;
                        }
                    case "orange":
                        {
                            clr = Color.Orange;
                            break;
                        }
                    case "red":
                        {
                            clr = Color.Red;
                            break;
                        }
                }
                p.BackColor = clr;
                tpFINChart.Controls.Add(p);
                tpFINChart.SetCellPosition(p, new TableLayoutPanelCellPosition(c, 0));
            }
            pnlFINContainer.Controls.Add(tpFINChart);
            tpFINChart.Dock = DockStyle.Fill;

        }

        public void ResetRiskChart(Panel pnlContainer)
        {
            foreach (Control c in pnlContainer.Controls)//remove old indicators if any
            {
                if ((c.GetType().Name == "TextBox") || (c.GetType().Name == "Button") || (c.GetType().Name == "Label"))
                {
                    pnlContainer.Controls.Remove(c);
                }
            }
            Label lNone = new Label();
            pnlContainer.Controls.Add(lNone);
            int iFontSize = 0;
            switch (pnlContainer.Height)
            {
                case 12:
                    {
                        iFontSize = 6;
                        break;
                    }
                default:
                    {
                        iFontSize = 8;
                        break;
                    }

            }
            Font f = new System.Drawing.Font(lNone.Font.FontFamily, iFontSize);
            lNone.Text = "NONE";
            lNone.BackColor = Color.White;
            lNone.ForeColor = Color.Black;
            lNone.Font = f;
            lNone.AutoSize = true;
            lNone.Left = ((pnlContainer.Width) / 2) - lNone.Width;
            // lNone.Height = pnlContainer.Height;
            lNone.Top = pnlContainer.Height / 6;// (pnlContainer.Height - lNone.Height) / 2;
            lNone.BringToFront();
        }
        private void RemoveNoneLabel(Panel pnlContainer)
        {
            foreach (Control c in pnlContainer.Controls)//remove old indicators if any
            {
                if ((c.GetType().Name == "Label"))
                {
                    pnlContainer.Controls.Remove(c);
                }
            }
        }
        private void SetMirRiskBarChartNeedle(double LogValue, Panel pnlContainer, TextBox tbNeedle)
        {
            float LogRange = (float)Convert.ToDouble(pnlContainer.Tag);
            float width = pnlContainer.Width;
            float left = pnlContainer.Left;
            //reverse the sense:
            LogValue = LogRange - LogValue;//we are charting years per failure, more is better
            float NeedleX = ((width / LogRange) * (float)LogValue);
            if (NeedleX == 0)
            {
                // "NONE" text should show
            }
            else if (NeedleX < 0)
            {
                RemoveNoneLabel(pnlContainer);
                //code to show left arrow:
                Button btnLeft = ArrowButton(true);
                pnlContainer.Controls.Add(btnLeft);
                btnLeft.Left = 0;
                btnLeft.Top = 0;
                btnLeft.Width = pnlContainer.Height;
                btnLeft.Height = pnlContainer.Height;
                btnLeft.BringToFront();
            }
            else if (NeedleX > width)
            {
                RemoveNoneLabel(pnlContainer);
                //show direction arrow right
                Button btnRight = ArrowButton(false);
                // NeedleX = width;
                pnlContainer.Controls.Add(btnRight);
                btnRight.Top = 0;
                btnRight.Width = pnlContainer.Height;
                btnRight.Left = pnlContainer.Width - btnRight.Width;
                btnRight.Height = pnlContainer.Height;
                btnRight.BringToFront();
            }
            else
            {
                RemoveNoneLabel(pnlContainer);
                float NeedleBtm = pnlContainer.Top - pnlContainer.Height;
                float NeedleTop = NeedleBtm + ((float)pnlContainer.Height * (float)0.75);
                //pnlContainer.Controls.Remove(tbNeedle);
                tbNeedle = new TextBox();
                tbNeedle.Multiline = true; //allows setting of height
                tbNeedle.Top = (int)(pnlContainer.Height * 0.25);
                tbNeedle.Height = (int)(pnlContainer.Height * 0.75);
                tbNeedle.Left = (int)NeedleX;
                tbNeedle.Width = 2;
                tbNeedle.Left -= 1;
                tbNeedle.BorderStyle = BorderStyle.FixedSingle;
                tbNeedle.BackColor = Color.Black;
                pnlContainer.Controls.Add(tbNeedle);
                tbNeedle.BringToFront();
            }
        }
        private void SetFinRiskBarChartNeedle(double LogValue, Panel pnlContainer, TextBox tbNeedle)
        {
            float LogRange = (float)Convert.ToDouble(pnlContainer.Tag);
            float width = pnlContainer.Width;
            float left = pnlContainer.Left;
            float NeedleX = ((width / LogRange) * (float)LogValue);
            if (NeedleX == 0)
            {
                // "NONE" text should show
            }
            else if (NeedleX < 0)
            {
                RemoveNoneLabel(pnlContainer);
                //code to show left arrow:
                Button btnLeft = ArrowButton(true);
                pnlContainer.Controls.Add(btnLeft);
                btnLeft.Left = 0;
                btnLeft.Top = 0;
                btnLeft.Width = pnlContainer.Height;
                btnLeft.Height = pnlContainer.Height;
                btnLeft.BringToFront();
            }
            else if (NeedleX > width)
            {
                RemoveNoneLabel(pnlContainer);
                //show direction arrow right
                Button btnRight = ArrowButton(false);
                // NeedleX = width;
                pnlContainer.Controls.Add(btnRight);
                btnRight.Top = 0;
                btnRight.Width = pnlContainer.Height;
                btnRight.Left = pnlContainer.Width - btnRight.Width;
                btnRight.Height = pnlContainer.Height;
                btnRight.BringToFront();
            }
            else
            {
                RemoveNoneLabel(pnlContainer);
                float NeedleBtm = pnlContainer.Top - pnlContainer.Height;
                float NeedleTop = NeedleBtm + ((float)pnlContainer.Height * (float)0.75);
                //pnlContainer.Controls.Remove(tbNeedle);
                tbNeedle = new TextBox();
                tbNeedle.Multiline = true; //allows setting of height
                tbNeedle.Top = (int)(pnlContainer.Height * 0.25);
                tbNeedle.Height = (int)(pnlContainer.Height * 0.75);
                tbNeedle.Left = (int)NeedleX;
                tbNeedle.Width = 2;
                tbNeedle.Left -= 1;
                tbNeedle.BorderStyle = BorderStyle.FixedSingle;
                tbNeedle.BackColor = Color.Black;
                pnlContainer.Controls.Add(tbNeedle);
                tbNeedle.BringToFront();
            }
        }
        private void DisplayRisks()
        {
//test the riskCalc class which duplicates much of the code here
//riskCalc is for computing risks outside this form (such as for reports)
//TODO: consider using riskCalc here instead of duplicate code JF
//            Guid CurrentScenarioUID =  (Guid)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
//            RiskCalc rc = new RiskCalc(CurrentScenarioUID, UserManager.UserProfile.ActiveGeoRegion);
//            rc.ComputeRisks();
            txtIndRiskRank.Text = "";
            txtFinRiskRank.Text = "";
            ClearEnvGridText();//clear the grid first
            double dTotalMIR = 0.0;
            double dTotalFin = 0.0;
            double dFinancialLossNoLOC = 0.0;
            double dYrsPerDeviation = 0.0;
            double dLOCProb = 0.0;
            //get values from current scenario pages:
            double.TryParse(txtNoLossOfContainment.Text, out dFinancialLossNoLOC);
            double.TryParse(txtFreqDev.Text, out dYrsPerDeviation);
            double.TryParse(txtLOCProb.Text, out dLOCProb);
            double noLOCProb = 1.0 - dLOCProb;
            double dDeviationsPerYear = 1.0 / dYrsPerDeviation;
            if (dDeviationsPerYear != 0.0)//in years per occurrence
            {
                ScenarioManager sm = new ScenarioManager();
                DataSet dsGetRiskMatrixLayout = sm.GetRiskMatrixLayout();

                //locations/outcomes
                DataTable dtLocations = dsScenarioDetails.Tables["tblScenarioLocations"];
                foreach (DataRow drLoc in dtLocations.Rows)
                {
                    double dFireFreq = 0.0;
                    double.TryParse(drLoc["cfFireFreq"].ToString(), out dFireFreq);//years per
                    double dExplFreq = 0.0;
                    double.TryParse(drLoc["cfExpFreq"].ToString(), out dExplFreq);//years per
                    double dNoIgnFreq = 0.0;
                    double.TryParse(drLoc["cfNoIgnFreq"].ToString(), out dNoIgnFreq);//years per
                    double dFinLossFire = 0.0;
                    double.TryParse(drLoc["fldEconFire"].ToString(), out dFinLossFire);
                    double dFinLossExpl = 0.0;
                    double.TryParse(drLoc["fldEconExp"].ToString(), out dFinLossExpl);
                    double dFinLossNoIgn = 0.0;
                    double.TryParse(drLoc["fldEconNoIgn"].ToString(), out dFinLossNoIgn);
                    double dMIEFire = 0.0;
                    double.TryParse(drLoc["fldMIEFire"].ToString(), out dMIEFire);
                    double dMIEExpl = 0.0;
                    double.TryParse(drLoc["fldMIEExp"].ToString(), out dMIEExpl);
                    double dMIENoIgn = 0.0;
                    double.TryParse(drLoc["fldMIENoIgn"].ToString(), out dMIENoIgn);

                    double dLocnFraction = 0.0;
                    double.TryParse(drLoc["fldLcnLocFraction"].ToString(), out dLocnFraction);

                    double dFireProb = 0.0;
                    double.TryParse(drLoc["fldFireProb"].ToString(), out dFireProb);

                    double dExpProb = 0.0;
                    double.TryParse(drLoc["fldExpProb"].ToString(), out dExpProb);

                    double dNoIgnProb = 1.0 - dFireProb - dExpProb;
                  // double.TryParse(drLoc["fldFireProb"].ToString(), out dNoIgnProb);
                    double dLocYrsPerOcc = dLOCProb * dDeviationsPerYear * dLocnFraction;
                    if (dFireFreq != 0.0)
                    {
                        double z = dLOCProb * dDeviationsPerYear * dLocnFraction * dFireProb;
                        double LocnFireLoss = dFinLossFire * z;
                        //Fire Freq (yrs) = Scenario LOC prob * ScenarioFreq (years) * loc frac * loc fire prob
                        dTotalFin += LocnFireLoss;// (dFinLossFire / dFireFreq);
                        dTotalMIR += (dMIEFire / dFireFreq);
                    }
                    if (dExplFreq != 0.0)
                    {
                        double z = dLOCProb * dDeviationsPerYear * dLocnFraction * dExpProb;
                        double LocnExpLoss = dFinLossExpl * z;
                        dTotalFin += LocnExpLoss;// (dFinLossExpl / dExplFreq);
                        dTotalMIR += (dMIEExpl / dExplFreq);
                    }
                    if (dNoIgnFreq != 0.0)
                    {
                        double z = dLOCProb * dDeviationsPerYear * dLocnFraction * dNoIgnProb;
                        double LocnNoIgnLoss = dFinLossNoIgn * z;
                        dTotalFin += LocnNoIgnLoss;// (dFinLossNoIgn / dNoIgnFreq);
                        dTotalMIR += (dMIENoIgn / dNoIgnFreq);
                    }
                    //dTotalMIR += (dMIEFire * dFireFreq);
                    //dTotalMIR += (dMIEExpl * dExplFreq);
                    //dTotalMIR += (dMIENoIgn * dNoIgnFreq);
                }
                //No loss of Containment:
                double dLossNoLOC = dDeviationsPerYear * (1.0 - dLOCProb) * dFinancialLossNoLOC;
                dTotalFin += dLossNoLOC;// ((1.0 - dLOCProb) * (dFinancialLoss / dFreqDeviation));
                // dTotalFin *= 1000; //units are thousands
                //invert
                dTotalMIR = 1.0 / dTotalMIR;
                int iMIRRiskRank = MIRRiskRank(dTotalMIR);
                UpdateComputedRiskRank(iMIRRiskRank);
                UpdateMIERiskRank(iMIRRiskRank);

                txtIndRiskRank.Text = dTotalMIR.ToString("0.#E+00") + " yrs/fatality Risk rank " + iMIRRiskRank.ToString() ;
                //update db?
                double dRecordMieRisk = 0.0;
                double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldMieRiskVal"].ToString(), out dRecordMieRisk);
                if (CalculationHelper.isSQLNumber(dTotalMIR))
                {
                    if (!CalculationHelper.bRealNumbersEqual(dTotalMIR, dRecordMieRisk))
                    {
                        dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldMieRiskVal"] = dTotalMIR;
                        LogScenarioDetailControlChange(this);
                    }
                }
                double dLogMir = Math.Log10(dTotalMIR);
                double dLogFin = Math.Log10(dTotalFin);
                //SetMirChartNeedle( dLogMir, pnlMIRContainer, tbMirIndicatorNeedleRiskTab);
                //SetMirChartNeedle(dLogMir, pnlMIRContainerHeader, tbMirIndicatorNeedleHdr);
                SetMirRiskBarChartNeedle(dLogMir, pnlMIRContainer, tbMirIndicatorNeedleRiskTab);
                SetMirRiskBarChartNeedle(dLogMir, pnlMIRContainerHeader, tbMirIndicatorNeedleHdr);
                // SetMirChartNeedle(dLogMir, panel1, tbFINIndicatorNeedle);
                if (!(dLogFin == 0.0 || double.IsNaN(dLogFin) || double.IsPositiveInfinity(dLogFin) || double.IsNegativeInfinity(dLogFin)))
                {
                    int iFINRiskRank = 0;
                    iFINRiskRank = FINRiskRank(dTotalFin);
                    txtFinRiskRank.Text = dTotalFin.ToString("0.####E+00") + " Risk Rank " + iFINRiskRank.ToString();
                    //update db?
                    double dRecordFinRisk = 0.0;
                    double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldFinRiskVal"].ToString(), out dRecordFinRisk);
                    if (CalculationHelper.isSQLNumber(dTotalFin))
                    {
                        if (!CalculationHelper.bRealNumbersEqual(dTotalFin, dRecordFinRisk))
                        {
                            dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldFinRiskVal"] = dTotalFin;
                            LogScenarioDetailControlChange(this);
                        }
                    }
                    SetFinRiskBarChartNeedle(dLogFin, pnlFINContainer, tbFINIndicatorNeedle);
                    //is this the highest risk so far?
                    UpdateComputedRiskRank(iFINRiskRank);
                    UpdateFinRiskRank(iFINRiskRank);
                }
                //recount locations grid, draw "x"s in environmentalRisk grid accordingly
                double dReleaseVolume = 0.0;
                if (!double.TryParse(txtReleaseVol.Text, out dReleaseVolume)) //do we have release volume in the text box?
                {
                    double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldReleaseVol"].ToString(), out dReleaseVolume);//in the database record?
                }
                //compute frequencies
                double fldDeviationFreq = 0.0;
                double FireFreq = 0.0;
                double ExplosionFreq = 0.0;
                double NoIgnFreq = 0.0;
                if (double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldFailureFreq"].ToString(), out fldDeviationFreq))
                {
                    double fldLcnLocFraction = 0.0;
                    if (dsScenarioDetails.Tables["tblScenarioLocations"].Rows.Count > 0 && double.TryParse(dsScenarioDetails.Tables["tblScenarioLocations"].Rows[0]["fldLcnLocFraction"].ToString(), out fldLcnLocFraction))
                    {
                        double FireProb = 0.0;
                        double ExplosionProb = 0.0;
                        double NoIgnProb = 0.0;
                        double.TryParse(dsScenarioDetails.Tables["tblScenarioLocations"].Rows[0]["fldFireProb"].ToString(), out FireProb);
                        double.TryParse(dsScenarioDetails.Tables["tblScenarioLocations"].Rows[0]["fldExpProb"].ToString(), out ExplosionProb);
                        NoIgnProb = 1.0 - FireProb - ExplosionProb;
                       // double.TryParse(dsScenarioDetails.Tables["tblScenarioLocations"].Rows[0]["fldNoIgnProb"].ToString(),out NoIgnProb);
                        // calculate frequencies for location
                        FireFreq = 1.0 / (fldLcnLocFraction * FireProb * (1.0 / fldDeviationFreq));
                        ExplosionFreq = 1.0 / (fldLcnLocFraction * ExplosionProb * (1.0 / fldDeviationFreq));
                        NoIgnFreq = 1.0 / (fldLcnLocFraction * NoIgnProb * (1.0 / fldDeviationFreq));
                    }
                }
                if (dReleaseVolume > 0.0)
                {
                    int MaxEnvRisk = 0;
                    double MinEnvRiskYrs = double.MaxValue;
                    foreach (DataRow drLocn in dsScenarioDetails.Tables["tblScenarioLocations"].Rows)
                    {
                        //need service type and location type codes:
                        string ScenarioServiceCode = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldServiceCode"].ToString();
                        int fldLocationID = 0;
                        if (int.TryParse(drLocn["fldLocationID"].ToString(), out fldLocationID))
                        {
                            string LocationTypeCode = "";
                                DataRow[] drLoc = dsScenarioDetails.Tables["ScenarioAssociatedLocations"].Select(" fldLocationID = " + fldLocationID.ToString() + " ");
                                if (drLoc.Length > 0)
                                {
                                    LocationTypeCode = drLoc[0]["fldLocationTypeCode"].ToString();
                                }

                                    Single defFire = 0.0F;
                                    Single defExp = 00.0F;
                                    Single defNoIgn = 0.0F;
                                    if (Single.TryParse(drLocn["fldEnvFire"].ToString(), out defFire))
                                    {
                                    }
                                    if (Single.TryParse(drLocn["fldEnvExp"].ToString(), out defExp))
                                    {
                                    }
                                    if (Single.TryParse(drLocn["fldEnvNoIgn"].ToString(), out defNoIgn))
                                    {
                                    }
                                    //we should be able to plot the graph for this location
                                    //frequencies:
                                    //FireFreq
                                    //ExplosionFreq 
                                    //NoIgnFreq
                                    //consequence levels:
                                    //defFire 
                                    //defExp =
                                    //defNoIgn
                                    int EnvFireRiskRank = Plot_X_for_Env_Risk('X',FireFreq, defFire, dsGetRiskMatrixLayout.Tables[3]);//pass the range table
                                    int EnvExplRiskRank = Plot_X_for_Env_Risk('X', ExplosionFreq, defExp, dsGetRiskMatrixLayout.Tables[3]);//pass the range table
                                    int EnvNoIgnRiskRank = Plot_X_for_Env_Risk('X', NoIgnFreq, defNoIgn, dsGetRiskMatrixLayout.Tables[3]);//pass the range table
                                    if (EnvFireRiskRank > MaxEnvRisk)
                                        MaxEnvRisk = EnvFireRiskRank;
                                    if (EnvExplRiskRank > MaxEnvRisk)
                                        MaxEnvRisk = EnvExplRiskRank;
                                    if (EnvNoIgnRiskRank > MaxEnvRisk)
                                        MaxEnvRisk = EnvNoIgnRiskRank;
                            //find the smallest year freq value
                                    if (0.0 < FireFreq && FireFreq  < MinEnvRiskYrs)
                                        MinEnvRiskYrs = FireFreq;
                                    if (0.0 < ExplosionFreq && ExplosionFreq < MinEnvRiskYrs)
                                        MinEnvRiskYrs = ExplosionFreq;
                                    if (0.0 < NoIgnFreq  && NoIgnFreq < MinEnvRiskYrs)
                                        MinEnvRiskYrs = NoIgnFreq;


                        }
                    }//for each location
                    double recordMinEnvRiskYears = 0.0;
                    double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldEnvRiskVal"].ToString(), out recordMinEnvRiskYears);
                    if (CalculationHelper.isSQLNumber(MinEnvRiskYrs))
                    {
                        if (!CalculationHelper.bRealNumbersEqual(MinEnvRiskYrs, recordMinEnvRiskYears))
                        {
                            dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldEnvRiskVal"] = MinEnvRiskYrs;
                            LogScenarioDetailControlChange(this);
                        }
                    }
                    UpdateComputedRiskRank(MaxEnvRisk);
                    UpdateEnvRiskRank(MaxEnvRisk);


                }
            }
            ComputeSocietalRisks();
            UpdateScenarioRisk();//if we have a change in risk, post it
            
        }
        private void UpdateMIERiskRank(int MIERiskRank)
        {
            int iOldRank = 0;
            int.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldMieRiskRank"].ToString(), out iOldRank);
            if (MIERiskRank != iOldRank)
            {
                dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldMieRiskRank"] = MIERiskRank.ToString();
                LogScenarioDetailControlChange(this);
            }
        }
        private void UpdateSocRiskRank(int SocRiskRank)
        {
            int iOldRank = 0;
            int.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldSocRiskRank"].ToString(), out iOldRank);
            if (SocRiskRank != iOldRank)
            {
                dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldSocRiskRank"] = SocRiskRank.ToString();
                LogScenarioDetailControlChange(this);
            }
        }
        private void UpdateFinRiskRank(int FinRiskRank)
        {
            int iOldRank = 0;
            int.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldFinRiskRank"].ToString(), out iOldRank);
            if (FinRiskRank != iOldRank)
            {
                dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldFinRiskRank"] = FinRiskRank.ToString();
                LogScenarioDetailControlChange(this);
            }
        }
        private void UpdateEnvRiskRank(int EnvRiskRank)
        {
            int iOldRank = 0;
            int.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldEnvRiskRank"].ToString(), out iOldRank);
            if (EnvRiskRank != iOldRank)
            {
                dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldEnvRiskRank"] = EnvRiskRank.ToString();
                LogScenarioDetailControlChange(this);
            }
        }
        private void UpdateComputedRiskRank(int iCategoryRisk)
        {
            if (iCategoryRisk > ComputedRiskRank)
            {
                ComputedRiskRank = iCategoryRisk;
            }
        }
        private void UpdateScenarioRisk()
        {
            int iScenarioRisk = 0;
            int.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldRiskRank"].ToString(), out iScenarioRisk);
            if (ComputedRiskRank < 1)
            {
                ComputedRiskRank = 1;//minumum to meet constraints
            }
            if (ComputedRiskRank != iScenarioRisk)
            {
                dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldRiskRank"] = ComputedRiskRank.ToString();
                LogScenarioDetailControlChange(this);
            }
            txtScenarioRiskRank.Text = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldRiskRank"].ToString();
        }
        private int Plot_X_for_Env_Risk(char symbol,double FreqYrs, Single Consequence,DataTable dtRanges)
        {
            int iCellRiskRank = 0;
            if (!double.IsInfinity(FreqYrs) && !double.IsNaN(FreqYrs))
            {
                double logFreq = 0;
                int iLogFreq = 0;
                try
                {
                    logFreq = Math.Log10(FreqYrs);
                }
                catch { }
                iLogFreq = (int)Math.Floor(logFreq);
                int iGraphRow = dtRanges.Rows.Count - 1;
                for (int i = 0; i < dtRanges.Rows.Count; i++)
                {
                    int iRangeMax = Convert.ToInt32(dtRanges.Rows[i]["range"]);
                    if (iLogFreq <= iRangeMax)
                    {
                        iGraphRow = i;
                        break;
                    }
                }
                int iCol = (int)Math.Floor(Convert.ToDouble(Consequence));
                string sChar = symbol.ToString();
                //add "X" to text box at that location
                if (iCol >= 1)
                {
                    iCellRiskRank = SetEnvGridCellText(iGraphRow, iCol - 1, sChar, false);
                }
            }
            return iCellRiskRank;
        }
        private void ClearEnvGridText()//deletes any control elements within the panels of the grid
        {
            for (int row = 0; row < dctEnvGridPanels.Count;row++)
            {
                for (int col = 0;col < dctEnvGridPanels[row].Count;col++)
                {
                    Panel p1 = dctEnvGridPanels[row][col];
                    p1.Controls.Clear();
                }
            }
        }
        private int SetEnvGridCellText(int row, int col, string text, bool ClearContent)
        {
            if(row >= 0 && row < dctEnvGridPanels.Count && col < dctEnvGridPanels[row].Count)//if we are in bounds
            {
                Dictionary<int, Panel> dictCol = (Dictionary<int, Panel>)dctEnvGridPanels[row];
                Panel p1 = dictCol[col];
                Label lblX = null;
                if (ClearContent)
                {
                    p1.Controls.Clear();
                    lblX = new Label();
                    p1.Controls.Add(lblX);
                }
                else if (p1.Controls.Count > 0)
                {
                    if (p1.Controls[0].GetType().Name == "Label")
                    {
                        lblX = (Label)p1.Controls[0];
                    }
                }
                else
                {
                    lblX = new Label();
                    p1.Controls.Add(lblX);
                }
                lblX.AutoSize = false;
                //t1.BackColor = p1.BackColor;
                lblX.BorderStyle = BorderStyle.None;
                lblX.TextAlign = ContentAlignment.MiddleCenter;
                //t1.Multiline = true;
                lblX.Dock = DockStyle.Fill;
                lblX.Text += text;//add to whatever might already be there
                lblX.Font = new Font(lblX.Font, FontStyle.Bold);
                return RiskColorToInt(p1.BackColor);

            }
            return 0;
        }
        private int RiskColorToInt(Color riskColor)
        {
            int iRisk = 0;
            switch (riskColor.Name.ToString().ToLower())
            {
                case "green":
                    {
                        iRisk = 1;
                        break;
                    }
                case "yellow":
                    {
                        iRisk = 2;
                        break;
                    }
                case "orange":
                    {
                        iRisk = 3;
                        break;
                    }
                case "red":
                    {
                        iRisk = 4;
                        break;
                    }
            }
            return iRisk;
        }
        private void CreateFin_RiskChart_0(int fldScenarioUID)
        {
            //TODO: see sp usp_Scenario_GetFinRisks for this function JF
            pnlFINContainer.Controls.Clear();
            ScenarioManager sm = new ScenarioManager();
            DataSet dsFinChart = sm.GetFinRisksForScenario(fldScenarioUID);
            tpFINChart = new TableLayoutPanel();//defined global for this form
            Color[] FinColors = { Color.Green, Color.Yellow, Color.Orange, Color.Red };
            foreach (Color cl in FinColors)
            {
                double dPercent = (double)dsFinChart.Tables[0].Rows[0][cl.Name + "Pct"];
            }
            pnlFINContainer.Tag = (int)dsFinChart.Tables[0].Rows[0]["LogStart"]; // use this to compute position when adding needle marker
            for (int c = 0; c < FinColors.Length; c++)
            {
                Color cl = FinColors[c];
                Panel p = new Panel();
                p.Margin = new System.Windows.Forms.Padding(0);
                p.BackColor = cl;
                tpFINChart.Controls.Add(p);
                tpFINChart.SetCellPosition(p, new TableLayoutPanelCellPosition(c, 0));
            }
            pnlFINContainer.Controls.Add(tpFINChart);

        }
        //compute data points on societal risks line chart
        private void ComputeSocietalRisks()
        {
           // txtMaxSocRiskFreq.Text = "0.0";
            //Series socRiskPlot = new Series();
            //socRiskPlot.MarkerStyle = MarkerStyle.Diamond;
            //socRiskPlot.MarkerSize = 10;
            //socRiskPlot.MarkerBorderWidth = 1;
            //socRiskPlot.MarkerColor = Color.Black;
            //socRiskPlot.ChartType = SeriesChartType.Line;
            //socRiskPlot.Name = "Plot";
            //start by clearing the chart
            //try
            //{
            //    Series seriesOldPlot = chartSocRisk.Series["Plot"];
            //    if (seriesOldPlot != null)
            //    {
            //        chartSocRisk.Series.Remove(seriesOldPlot);
            //    }
            //}
            //catch { };
            Series seriesPlot = chartSocRisk.Series["Plot"]; //new Series();
            seriesPlot.Points.Clear();
            seriesPlot.MarkerStyle = MarkerStyle.Diamond;
            seriesPlot.MarkerSize = 10;
            seriesPlot.BorderColor = Color.Black;
            seriesPlot.BorderWidth = 3;
            seriesPlot.MarkerBorderColor = Color.Black;
            seriesPlot.MarkerBorderWidth = 3;
            seriesPlot.MarkerColor = Color.Black;
            seriesPlot.ChartType = SeriesChartType.Line;
            seriesPlot.Name = "Plot";
            //while (seriesPlot.Points.Count > 0)
            //{
            //    seriesPlot.Points.RemoveAt(0);
            //}
            double fldScenarioFreq = 0.0;
            double fldFailureFreq = 0.0;
            double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioFreq"].ToString(), out fldScenarioFreq);
            double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldFailureFreq"].ToString(), out fldFailureFreq);
            DataTable dtMyLocations = new DataTable();

            dtMyLocations = (DataTable)ugLocations.DataSource;
            List<int> allPLLs = new List<int>();
            SortedDictionary<float, double> dictLocations = new SortedDictionary<float, double>();
            //  Dictionary<int, double> dictLocations = new Dictionary<int, double>();
            foreach (DataRow dr in dtMyLocations.Rows)
            {
                double dfldLocProb = 0.0;
                double dfldExpProb = 0.0;
                double dfldFireProb = 0.0;
                double dfldLcnLocFraction = 0.0;
                double.TryParse(dr["fldLcnLocFraction"].ToString(), out dfldLcnLocFraction);
                double.TryParse(dr["fldExpProb"].ToString(), out dfldExpProb);
                double.TryParse(dr["fldFireProb"].ToString(), out dfldFireProb);

                float ffldPLLExp = 0;
                float ffldPLLFire = 0;
                float ffldPLLNoIgn = 0;
                float.TryParse(dr["fldPLLExp"].ToString(), out ffldPLLExp);
                float.TryParse(dr["fldPLLFire"].ToString(), out ffldPLLFire);
                float.TryParse(dr["fldPLLNoIgn"].ToString(), out ffldPLLNoIgn);

                double locnFireFreqYearsPer = 0.0;
                double locnExplFreqYearsPer = 0.0;
                double locnNoIgnFreqYearsPer = 0.0;

                double locnFireFreqPerYear = 0.0;
                double locnExplFreqPerYear = 0.0;
                double locnNoIgnFreqPerYear = 0.0;
                double.TryParse(dr["cfFireFreq"].ToString(), out locnFireFreqYearsPer);
                double.TryParse(dr["cfExpFreq"].ToString(), out locnExplFreqYearsPer);
                double.TryParse(dr["cfNoIgnFreq"].ToString(), out locnNoIgnFreqYearsPer);

                if(locnFireFreqYearsPer != 0.0)
                {
                    locnFireFreqPerYear = 1.0 / locnFireFreqYearsPer;
                }
                if (locnExplFreqYearsPer != 0.0)
                {
                    locnExplFreqPerYear = 1.0 / locnExplFreqYearsPer;
                }
                if (locnNoIgnFreqYearsPer != 0.0)
                {
                    locnNoIgnFreqPerYear = 1.0 / locnNoIgnFreqYearsPer;
                }

                //create a dictionary entry for each PLL level and risk category (fire,explosion, no ignition)
                //accumulate the freq (per year)
                if (ffldPLLExp > 0.0)
                {
                    if (dictLocations.ContainsKey(ffldPLLExp))//explosion
                    {
                        dictLocations[ffldPLLExp] += locnExplFreqPerYear;
                    }
                    else
                    {
                        dictLocations.Add(ffldPLLExp, locnExplFreqPerYear);
                    }
                }
                if (ffldPLLFire > 0.0)
                {
                    if (dictLocations.ContainsKey(ffldPLLFire))//fire
                    {
                        dictLocations[ffldPLLFire] += locnFireFreqPerYear;
                    }
                    else
                    {
                        dictLocations.Add(ffldPLLFire, locnFireFreqPerYear);
                    }
                }
                if (ffldPLLNoIgn > 0.0)
                {
                    if (dictLocations.ContainsKey(ffldPLLNoIgn))//no ignition
                    {
                        dictLocations[ffldPLLNoIgn] += locnNoIgnFreqPerYear;
                    }
                    else
                    {
                        dictLocations.Add(ffldPLLNoIgn, locnNoIgnFreqPerYear);
                    }
                }
            }
            if (dictLocations.Count > 0)
            {
                float f = dictLocations.ElementAt(0).Key;
                double MinFatalities = Convert.ToDouble(f);
                MinFatalities = Math.Round(MinFatalities, 6);
                if (MinFatalities <= 0.0)
                {
                    MinFatalities = 1e-5;
                }
                InitSocietalRiskChart(MinFatalities);
            }
            double YearsPerSum = 0.0;
            int MaxSocRisk = 0;
            foreach (KeyValuePair<float, double> pr in dictLocations.Reverse())
            {
                if (pr.Key > 0) //more than zero PLL
                {
                    double dKey = Convert.ToDouble(pr.Key);
                    dKey = Math.Round(dKey, 6);
                    YearsPerSum += pr.Value;
                    double dYval = pr.Value;
                    if (YearsPerSum != 0)
                    {
                        dYval = 1.0 / YearsPerSum;
                        double dMaxValue;
                        double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldSocRiskVal"].ToString(), out dMaxValue);
                        if (CalculationHelper.isSQLNumber(dYval))
                        {
                            if (dYval > dMaxValue)
                            {
                                //   txtMaxSocRiskFreq.Text = dYval.ToString();
                                dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldSocRiskVal"] = dYval;
                                LogScenarioDetailControlChange(this);
                            }
                        }
                        DataPoint dpLoc = new DataPoint(dKey, dYval);
                        dpLoc.Color = Color.Black;
                        int iSocRisk = SocietalRiskRank(dpLoc);
                        if (iSocRisk > MaxSocRisk)
                            MaxSocRisk = iSocRisk;
                        seriesPlot.Points.Add(dpLoc);
                    }
                }
            }
            UpdateComputedRiskRank(MaxSocRisk);
            UpdateSocRiskRank(MaxSocRisk);

          //  chartSocRisk.Series.Add(seriesPlot);
        }
        private int SocietalRiskRank(DataPoint dpSocRisk)
        {
            int Risk = 1;
            double FatalityCount = dpSocRisk.XValue;
            double YearsPer = dpSocRisk.YValues[0];
          //  double LogFatalityCount = Math.Log10(FatalityCount);
            double YearsPerOneFatality = YearsPer / FatalityCount;
            double RangeMinYearsPerOneFatality = 0.0;
            DataTable dtRiskLayout = ConocoPhillips.PHA.Model.LookupTables.GetLookupTable("SocietalRiskChartLayout");
            DataRow[] dra = dtRiskLayout.Select("", "YearsPer1Fatality desc");
            foreach (DataRow dr in dra)
            {
                double.TryParse(dr["YearsPer1Fatality"].ToString(), out RangeMinYearsPerOneFatality);
                if (YearsPerOneFatality >= RangeMinYearsPerOneFatality)
                {
                    break; //use prior risk rank
                }
                int.TryParse(dr["RiskRank"].ToString(), out Risk);//try this risk
            }

            return Risk;
        }
        #endregion
        #region FindingsTab
        private void bindFindingsTab()
        {
            ugScenarioFindings.DataSource = dsScenarioFindings.Tables["tblIssues"];
        }
        private void ugScenarioFindings_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            // e.Layout.Bands["tblActionItems"].Columns["fldIssueNumber"].Hidden = true;
        }

        private void ugScenarioFindings_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Selected = false;
            e.Row.Expanded = true;
            e.Row.Activation = Activation.NoEdit;
        }

        private void btnAddNewScenarioFinding_Click(object sender, EventArgs e)
        {
            if (CheckControlChanges())
            {
                ConocoPhillips.PHA.Utils.PHAStandard.DisplayError("Current Scenario must be saved before creating a new Finding");
                return;
            }
            //launch finding create, link scenarion to new finding, rebind
            List<Guid> lFindings = new List<Guid>();
            Guid gNewIssueUID = Guid.NewGuid();
            lFindings.Add(gNewIssueUID);
            frmFindingDetails fd = new frmFindingDetails(gNewIssueUID, lFindings, true, false);
            fd.ActivePHA = this.ActivePHA;
            fd.ActiveGeoRegionId = UserManager.UserProfile.ActiveGeoRegion;
            fd.AppWinHwnd = this.AppWinHwnd;
           // fd.MdiParent = this.MdiParent; 
            fd.ShowDialog(this);
            if (fd.gCreatedFinding == gNewIssueUID)
            {
                //add it to the relations
                //add new row to relate table so it gets saved:
                DataRow drScenarioIssue = dsScenarioDetails.Tables["tblScenarioIssue"].NewRow();
                drScenarioIssue["fldIssueUID"] = (Guid)gNewIssueUID;
                drScenarioIssue["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
                dsScenarioDetails.Tables["tblScenarioIssue"].Rows.Add(drScenarioIssue);
                //get new issue/finding details to be added to displaying grid
                FindingManager fm = new FindingManager();
                DataSet dsNewFinding = fm.GetFindingForFindingUID(gNewIssueUID);
                if (dsNewFinding.Tables.Count == 2 && dsNewFinding.Tables[0].Rows.Count > 0)
                {
                    //add new rows to same tables in dsScenarioFindings;
                    dsScenarioFindings.Tables["tblIssues"].ImportRow(dsNewFinding.Tables["tblIssues"].Rows[0]);
                    foreach (DataRow drActionItem in dsNewFinding.Tables["tblActionItems"].Rows)
                    {
                        dsScenarioFindings.Tables["tblActionItems"].ImportRow(drActionItem);

                    }
                }
                LogScenarioDetailControlChange((Control)sender);
            }

        }


        private void btnAddExistingScenarioFinding_Click(object sender, EventArgs e)
        {
            frmSearchFindings formSearchFindings = new frmSearchFindings(AllowEdit,AllowApproval);
            formSearchFindings.ActiveGeoRegion = UserManager.UserProfile.ActiveGeoRegion;
            formSearchFindings.ActivePHA = ActivePHA; //dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldPhaDocNum"].ToString();
            formSearchFindings.ActiveFacility = ActivePHA.FacilityCode;// comboBoxFacility.SelectedValue.ToString();
            formSearchFindings.ShowDialog();
            //get results:
            List<Guid> lFindings = formSearchFindings.lFindings;
            Guid SelectedFindingUID = formSearchFindings.SelectedFindingUID;
            bool bUserIsEditor = formSearchFindings.chkAllowPhaEdit.Checked;
            bool bUserIsApprover = formSearchFindings.chkUserIsApprover.Checked;
            //do we already have this finding in relation table? dsScenarioDetails.Tables["tblScenarioIssue"]
            DataRow[] dv = dsScenarioDetails.Tables["tblScenarioIssue"].Select("fldIssueUID = '" + SelectedFindingUID + "'");
            if (dv.Length == 0)
            {
                //add new row to relate table so it gets saved:
                DataRow drScenarioIssue = dsScenarioDetails.Tables["tblScenarioIssue"].NewRow();
                drScenarioIssue["fldIssueUID"] = (Guid)SelectedFindingUID;
                drScenarioIssue["fldScenarioUID"] = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
                dsScenarioDetails.Tables["tblScenarioIssue"].Rows.Add(drScenarioIssue);
                //get new issue/finding details to be added to displaying grid
                FindingManager fm = new FindingManager();
                DataSet dsNewFinding = fm.GetFindingForFindingUID(SelectedFindingUID);
                if (dsNewFinding.Tables.Count ==2 && dsNewFinding.Tables[0].Rows.Count > 0)
                {
                    //add new rows to same tables in dsScenarioFindings;
                    dsScenarioFindings.Tables["tblIssues"].ImportRow(dsNewFinding.Tables["tblIssues"].Rows[0]);
                    foreach(DataRow drActionItem in dsNewFinding.Tables["tblActionItems"].Rows)
                    {
                        dsScenarioFindings.Tables["tblActionItems"].ImportRow(drActionItem);

                    }
                }
            }
        }

        private void btnRemoveScenarioFinding_Click(object sender, EventArgs e)
        {
            if (ugScenarioFindings.ActiveRow != null)
            {
                UltraGridRow ur = ugScenarioFindings.ActiveRow;
                Guid gSelectedIssueUID = (Guid)ur.Cells["fldIssueUID"].Value;
                DataRow[] dv = dsScenarioDetails.Tables["tblScenarioIssue"].Select("fldIssueUID = '" + gSelectedIssueUID + "'");
                if (dv.Length == 1)
                {
                    DialogResult dr = ConocoPhillips.PHA.Utils.PHAStandard.DisplayConfirmYN("confirm that you wish to delete this relationship");
                    if (dr == System.Windows.Forms.DialogResult.Yes)
                    {
                        //remove the relationship row from it's table
                        dv[0].Delete();
                        //remove the displaying record
                        DataRow[] dvDeleteActionItems = dsScenarioFindings.Tables["tblActionItems"].Select("fldIssueUID = '" + gSelectedIssueUID + "'");
                        DataRow[] dvDeleteFindings = dsScenarioFindings.Tables["tblIssues"].Select("fldIssueUID = '" + gSelectedIssueUID + "'");
                        foreach (DataRow dra in dvDeleteActionItems)
                        {
                            dsScenarioFindings.Tables["tblActionItems"].Rows.Remove(dra);
                        }
                        foreach (DataRow drf in dvDeleteFindings)
                        {
                            dsScenarioFindings.Tables["tblIssues"].Rows.Remove(drf);
                        }
                    }
                }
            }

            

            //throw (new NotImplementedException("remove link from the association table, rebind"));
        }
        private void btnViewScenarioFinding_Click(object sender, EventArgs e)
        {
            if (ugScenarioFindings.ActiveRow != null)
            {
                UltraGridRow ur = ugScenarioFindings.ActiveRow;
                Guid gSelectedIssueUId = (Guid)ur.Cells["fldIssueUID"].Value;
                if (gSelectedIssueUId != Guid.Empty)
                {
                    DataRow[] dv = dsScenarioDetails.Tables["tblScenarioIssue"].Select("fldIssueUID = '" + gSelectedIssueUId + "'");
                    if (dv.Length == 1)
                    {
                        List<Guid> lFindings = new List<Guid>();
                        lFindings.Add(gSelectedIssueUId);
                        frmFindingDetails fd = new frmFindingDetails(gSelectedIssueUId, lFindings, false, false);
                        fd.ActivePHA = this.ActivePHA;
                        fd.ActiveGeoRegionId = UserManager.UserProfile.ActiveGeoRegion;
                        fd.AppWinHwnd = this.AppWinHwnd;
                        fd.MdiParent = this.MdiParent; ;
                        fd.Show();
                    }
                }
                else
                {
                    MessageBox.Show("Please select a finding");
                }
            }
            //throw (new NotImplementedException("Launch finding details form on this finding"));
        }

        #endregion
        #region RelatedScenariosTab
        private void bindRelatedScenariosTab()
        {
//            ugAssocScenarios.DataSource = dtAssociatedScenarios;
            ugAssocScenarios.DataSource = dsScenarioDetails.Tables["tblAssocScenarios"];
        }
        private void btnAddRelatedScenario_Click(object sender, EventArgs e)
        {
            frmSearchScenarios_2 formSearchScenarios = new frmSearchScenarios_2(AllowEdit,AllowApproval);
            formSearchScenarios.ActivePHA = this.ActivePHA;
            //formSearchScenarios.Phaid = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldPhaDocNum"].ToString();//comboBoxPHA.SelectedValue.ToString();
            //formSearchScenarios.PhaDescription = "";// comboBoxPHA.Text;
            //formSearchScenarios.searchCriteria.fldPhaId = this.ActivePHA.PhaID;
            
            ////formSearchScenarios.searchCriteria.fldNodeNumber = (int)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldNodeNumber"];
            //formSearchScenarios.NodeDescription = dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeDescription"].ToString();// lblNodeDescription.Text; //start at this node
            formSearchScenarios.CallingScenarioID = (Guid)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];

            // Display the new form.
            DialogResult dr = formSearchScenarios.ShowDialog(this);
            if (dr == DialogResult.OK)
            {
                Guid gScenarioUIDtoRelate = formSearchScenarios.SelectedScenarioID;
                if (gScenarioUIDtoRelate != Guid.Empty)
                {
                    DataRow drNewRelatedScenario = dsScenarioDetails.Tables["tblAssocScenarios"].NewRow();
                    ScenarioManager sm = new ScenarioManager();
                    Guid gScenarioUID = (Guid)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
                    DataTable dtScenarioDetailsToAdd = sm.GetScenarioDisplayRow(gScenarioUID, gScenarioUIDtoRelate);
                    if(dtScenarioDetailsToAdd.Rows.Count > 0)
                    {
                        DataRow drRowDetails = dtScenarioDetailsToAdd.Rows[0];
                        drNewRelatedScenario["Associated Node Title"] = drRowDetails["Associated Node Title"];
                        drNewRelatedScenario["Scenario Number"] = drRowDetails["Scenario Number"];
                        drNewRelatedScenario["Scenario Description"] = drRowDetails["Scenario Description"];
                        drNewRelatedScenario["fldScenarioUID"] = drRowDetails["fldScenarioUID"];
                        drNewRelatedScenario["fldAssocScenarioUID"] = drRowDetails["fldAssocScenarioUID"];
                        dsScenarioDetails.Tables["tblAssocScenarios"].Rows.Add(drNewRelatedScenario);
                        LogScenarioDetailControlChange((Control)sender);
                    }
                    ////dsScenarioDetails.Tables["tblAssociatedScenarios"]
                    //int iRelationSet = 0;
                    //iRelationSet=sm.AddRelatedScenario(gScenarioUID, gScenarioUIDtoRelate);
                    //if (iRelationSet != 1)
                    //{
                    //    ConocoPhillips.PHA.Utils.PHAStandard.DisplayWarning("Relationship was not created");
                    //}
                    //else
                    //{
                    //    //dtAssociatedScenarios = GetAssociatedScenarios(formSearchScenarios.CallingScenarioID);//refresh the datatable
                    //    ugAssocScenarios.DataSource = dsScenarioDetails.Tables["tblAssocScenarios"];//dtAssociatedScenarios;
                    //    //ugAssocScenarios.DataBind();
                    //    //ugAssocScenarios.Refresh();
                    //}
                }
            }

        }
        private void btnRemoveRelatedScenario_Click(object sender, EventArgs e)
        {
            UltraGridRow row = ugAssocScenarios.ActiveRow;
            if (row != null)
            {
                UltraGridCell cell = row.Cells["fldAssocScenarioUID"];
                Guid gRelatedScenarioToRemove = (Guid)cell.Value;
                Guid gCurrentScenario = (Guid)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
                DataRow[] draRemoveScenarios = dsScenarioDetails.Tables["tblAssocScenarios"].Select(" fldAssocScenarioUID = '" + gRelatedScenarioToRemove + "'");
                if (draRemoveScenarios.Length > 0)
                {
                    int iRowToRemove = dsScenarioDetails.Tables["tblAssocScenarios"].Rows.IndexOf(draRemoveScenarios[0]);
                    dsScenarioDetails.Tables["tblAssocScenarios"].Rows[iRowToRemove].Delete();
                    LogScenarioDetailControlChange((Control)sender);
                }
                //int RowsRemoved = RemoveAssociatedScenario(gCurrentScenario, gRelatedScenarioToRemove);
                //if (RowsRemoved != 1)
                //{
                //    ConocoPhillips.PHA.Utils.PHAStandard.DisplayWarning("Relationship was not removed");
                //}
                //else
                //{
                //    //dtAssociatedScenarios = GetAssociatedScenarios(gCurrentScenario);
                //    ugAssocScenarios.DataSource = dsScenarioDetails.Tables["tblAssocScenarios"];//dtAssociatedScenarios;
                //    //ugAssocScenarios.DataBind();
                //    //ugAssocScenarios.Refresh();
                //}
            }
        }

        #endregion

        private void btnAddScenario_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("need to rework this for GUID scenarios");
            //return;
            bool LockCurrent = false;
            //advise user to save changes
            ScenarioManager sm = new ScenarioManager();
            if (dsScenarioDetails != null)
            {
                if (!EndEditAndValidate())
                {
                    DialogResult dr = new System.Windows.Forms.DialogResult();
                    dr = PHAStandard.DisplayConfirmYN("Current data has errors, discard changes ?");
                    if (dr == System.Windows.Forms.DialogResult.No)
                    {
                        return;
                    }
                }
                if (dsScenarioDetails.HasChanges())
                {
                    //do we have/still have lock on this scenario?
                    if (!sm.CanSave(currentOpenedRecordRowId, this.AppWinHwnd))
                    {
                        PHAStandard.DisplayError("This record is not available to you for update. " +
                            "Please try to refresh and re-open the record and then try saving");
                        LockCurrent = false;
                        //return;
                    }
                }
                if (LockCurrent)
                {
                    DialogResult Choice = PHAStandard.DisplayConfirmYN("Save Scenario Changes?");
                    if (Choice == DialogResult.Yes)
                    {
                        //handle any changes from previous record
                        WriteChanges();
                    }
                }
            }
            MoveToNewScenario(true);
            //GotoScenario(Guid.NewGuid());
            return;
            //DataRow drScenario = dsScenarioDetails.Tables["tblScenarios"].Rows[0];
            //frmCreateNewScenario fs = new frmCreateNewScenario((Guid)drScenario["fldScenarioUID"], (Guid)drScenario["fldNodeID"], (int)drScenario["fldKeywordNumber"], lblNodeDescription.Text);
            //DialogResult drNewScenario = fs.ShowDialog();
            //if (drNewScenario == System.Windows.Forms.DialogResult.OK)
            //{
            //    Guid gNewScenarioUID = fs.gNewScenarioUID;
            //    //add this scenario to the list and open it
            //    if (gNewScenarioUID != Guid.Empty)
            //    {
            //        activeScenarioID = gNewScenarioUID;
            //        // AllScenarioIDs = new List<string>();
            //        AllScenarioUIDs.Add(activeScenarioID);
            //        scenarioPageBindingSource.DataSource = AllScenarioUIDs;
            //        int SelectedIndex = AllScenarioUIDs.IndexOf(activeScenarioID);
            //        bndNavScenarios.BindingSource = scenarioPageBindingSource;
            //        scenarioPageBindingSource.Position = SelectedIndex;
            //        MovetoSelectedRecord();

            //        // LoadforScenario(activeScenarioID);
            //    }
            //}
            //else
            //{
            //    //advise user to save changes
            //    if (dsScenarioDetails != null)
            //    {
            //        if (!EndEditAndValidate())
            //        {
            //            DialogResult dr = new System.Windows.Forms.DialogResult();
            //            dr = PHAStandard.DisplayConfirmYN("Current data has errors, discard changes ?");
            //            if (dr == System.Windows.Forms.DialogResult.No)
            //            {
            //                return;
            //            }
            //        }
            //        if (dsScenarioDetails.HasChanges())
            //        {
            //            //do we have/still have lock on this scenario?
            //            if (!sm.CanSave(currentOpenedRecordRowId, this.AppWinHwnd))
            //            {
            //                PHAStandard.DisplayError("This record is not available to you for update. " +
            //                    "Please try to refresh and re-open the record and then try saving");
            //                LockCurrent = false;
            //                //return;
            //            }
            //        }
            //        if (LockCurrent)
            //        {
            //            DialogResult Choice = PHAStandard.DisplayConfirmYN("Save Scenario Changes?");
            //            if (Choice == DialogResult.Yes)
            //            {
            //                //handle any changes from previous record
            //                WriteChanges();
            //            }
            //        }
            //    }
            //    //this.Close();
            //}
        }

        private void btnDeleteScenario_Click(object sender, EventArgs e)
        {
            //warn user
            DialogResult dr = ConocoPhillips.PHA.Utils.PHAStandard.DisplayConfirmYN("Confirm you wish to delete this scenario");
            if (dr == System.Windows.Forms.DialogResult.Yes)
            {
                //current scenario is at this.lblScenarioID.Text
                DataRow drCurrentScenario = dsScenarioDetails.Tables["tblScenarios"].Rows[0];
                //change the isdeleted flag to 1 for the selected scenario
                drCurrentScenario["IsDeleted"] = 1;
                //remove it's ID from the binding navigator
                AllScenarioUIDs.Remove((Guid)drCurrentScenario["fldScenarioUID"]);
                if (AllScenarioUIDs.Count > 0)
                {
                    //navigate to first Scenario in list
                    activeScenarioID = AllScenarioUIDs[0];
                    scenarioPageBindingSource.DataSource = AllScenarioUIDs;
                    int SelectedIndex = AllScenarioUIDs.IndexOf(activeScenarioID);
                    bndNavScenarios.BindingSource = scenarioPageBindingSource;
                    scenarioPageBindingSource.Position = SelectedIndex;
                    MovetoSelectedRecord();
                }
                else
                {
                    //if none, ask for save and close page
                    HandleChanges();
                    this.Close();
                }
            }
        }

        private void ugLocations_ClickCellButton(object sender, CellEventArgs e)
        {
            switch (e.Cell.Column.Key)
            {
                case "colLblProb": //probability column request to use computed values
                    {
                        double cfldFireProb = 0.0;
                        double cfldExpProb = 0.0;
                        double noIgnProb = 0.0;
                        if (double.TryParse(e.Cell.Row.Cells["cfldFireProb"].Value.ToString(), out cfldFireProb))
                        {
                            e.Cell.Row.Cells["fldFireProb"].Value = e.Cell.Row.Cells["cfldFireProb"].Value;
                        }
                        if (double.TryParse(e.Cell.Row.Cells["cfldExpProb"].Value.ToString(), out cfldFireProb))
                        {
                            e.Cell.Row.Cells["fldExpProb"].Value = e.Cell.Row.Cells["cfldExpProb"].Value;
                        }
                        noIgnProb = 1.0 - cfldFireProb - cfldExpProb;
                        e.Cell.Row.Cells["cfNoIgnProb"].Value = noIgnProb;
                        break;//use computed values for fire, explosion, no ignition probabilites
                    }
                case "colLblPLL": //PLL column
                    {
                        double cfldPLLFire = 0.0;
                        double cfldPLLExp = 0.0;
                        double cfldPLLNoIgn = 0.0;
                        if (double.TryParse(e.Cell.Row.Cells["cfldPLLFire"].Value.ToString(), out cfldPLLFire))
                        {
                            e.Cell.Row.Cells["fldPLLFire"].Value = e.Cell.Row.Cells["cfldPLLFire"].Value;
                        }
                        if (double.TryParse(e.Cell.Row.Cells["cfldPLLExp"].Value.ToString(), out cfldPLLExp))
                        {
                            e.Cell.Row.Cells["fldPLLExp"].Value = e.Cell.Row.Cells["cfldPLLExp"].Value;
                        }
                        if (double.TryParse(e.Cell.Row.Cells["cfldPLLNoIgn"].Value.ToString(), out cfldPLLNoIgn))
                        {
                            e.Cell.Row.Cells["fldPLLNoIgn"].Value = e.Cell.Row.Cells["cfldPLLNoIgn"].Value;
                        }
                        break; //use computed values for PLL column
                    }
                    case "colLblMIE": 
                    {
                        double cfldMIEFire = 0.0;
                        double cfldMIEExp = 0.0;
                        double cfldMIENoIgn = 0.0;
                        if (double.TryParse(e.Cell.Row.Cells["cfldMIEFire"].Value.ToString(), out cfldMIEFire))
                        {
                            e.Cell.Row.Cells["fldMIEFire"].Value = e.Cell.Row.Cells["cfldMIEFire"].Value;
                        }
                        if (double.TryParse(e.Cell.Row.Cells["cfldMIEExp"].Value.ToString(), out cfldMIEExp))
                        {
                            e.Cell.Row.Cells["fldMIEExp"].Value = e.Cell.Row.Cells["cfldMIEExp"].Value;
                        }
                        if (double.TryParse(e.Cell.Row.Cells["cfldMIENoIgn"].Value.ToString(), out cfldMIENoIgn))
                        {
                            e.Cell.Row.Cells["fldMIENoIgn"].Value = e.Cell.Row.Cells["cfldMIENoIgn"].Value;
                        }
                        break;
                    }
                case "colLblEnv": 
                    {
                        //copy cfld values to fld values
                        e.Cell.Row.Cells["fldEnvFire"].Value = e.Cell.Row.Cells["cfldEnvFire"].Value;
                        e.Cell.Row.Cells["fldEnvExp"].Value = e.Cell.Row.Cells["cfldEnvExp"].Value;
                        e.Cell.Row.Cells["fldEnvNoIgn"].Value = e.Cell.Row.Cells["cfldEnvNoIgn"].Value;
                        break;
                    }
                //case "colLblFin"://no longer a button cell JF
                //    {
                //        break;
                //    }
            }
        }
        private void ListColumnKeys(UltraGridBand b)
        {
            foreach (UltraGridColumn col in b.Columns)
            {
                System.Diagnostics.Debug.Print(col.Key);
            }
        }
        private void ugLocations_DoubleClickHeader(object sender, DoubleClickHeaderEventArgs e)
        {
            int i = 0;
        }

        private void btnCalcReleaseRate_Click(object sender, EventArgs e)
        {
            double dMaxScenarioPressure = 0.0;
            double dLeakDiameter = 0.0;
            double dReleaseRate = 0.0;
            string FluidPhase = "";
            double RateCoefficient = 0.0;
            string Service = cmbServiceCode.Text;
            DataTable dtServices = Model.LookupTables.GetLookupTable("tbcServices");
            DataRow[] dra = dtServices.Select(" fldServiceDescription = '" + Service + "'");
            if(dra.Length > 0)
            {
                if(double.TryParse(txtMaxScenarioPSI.Text,out dMaxScenarioPressure)
                    && double.TryParse(dra[0]["fldRateCoefficient"].ToString(),out RateCoefficient)
                    && double.TryParse(txtLeakDiam.Text,out dLeakDiameter)
                )
                {
                    dMaxScenarioPressure = (double)CalculationHelper.GeoRegionUnitsToBaseUnits(dMaxScenarioPressure, "Pressure", UserManager.UserProfile.ActiveGeoRegion);
                    dLeakDiameter = (double)CalculationHelper.GeoRegionUnitsToBaseUnits(dLeakDiameter, "LengthShort", UserManager.UserProfile.ActiveGeoRegion);
                    dLeakDiameter = dLeakDiameter / 1000.0;//convert to meters
                    FluidPhase = dra[0]["fldFluidPhase"].ToString();
                    dReleaseRate = CalculationHelper.LeakFluidReleaseRate(dMaxScenarioPressure,dLeakDiameter,FluidPhase,RateCoefficient);
                }
            }
            txtReleaseRate.Text = dReleaseRate.ToString();
            //if(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldReleaseRate"] != DBNull.Value)
            //{
            //    txtReleaseRate.Text = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["cfldReleaseRate"].ToString();
            //}
        }
        private void ComputeLocnRowCalculatedValues(object sender, InitializeRowEventArgs e)
        {
            string dataReleaseRate = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldReleaseRate"].ToString();
            string releaseRate = txtReleaseRate.Text;// will be in regional units, need in base units
            //if text control not filled in, it might not be generated yet
            if (releaseRate == "")
            {
                releaseRate = dataReleaseRate;//take the one from the table
            }
            double ScenarioFluidReleaseRate = 0.0;
            if (double.TryParse(releaseRate, out ScenarioFluidReleaseRate))//if release rate is known
            {
                foreach (UltraGridCell cel in e.Row.Cells)
                {
                    System.Diagnostics.Debug.Print(cel.Column.Key);
                }

                ScenarioFluidReleaseRate = (double)CalculationHelper.GeoRegionUnitsToBaseUnits(ScenarioFluidReleaseRate, "MassRate", UserManager.UserProfile.ActiveGeoRegion);
                string ServiceCode = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldServiceCode"].ToString();
                int fldLocationID = -1;
                if (int.TryParse(e.Row.Cells["fldLocationID"].Value.ToString(), out fldLocationID))
                {
                    //                int fldLocationID = Convert.ToInt32(e.Row.Cells["fldLocationID"].Value);
                    DataRow[] drLoc = dsScenarioDetails.Tables["ScenarioAssociatedLocations"].Select(" fldLocationID = " + fldLocationID.ToString() + " ");
                    if (drLoc.Length > 0)
                    {
                        string LocationTypeCode = drLoc[0]["fldLocationTypeCode"].ToString();
                        //get values from tbcIgnitionProbFunctionSelect
                        DataTable dt = PHA.Model.LookupTables.GetLookupTable("tbcIgnitionProbFunctionSelect");
                        DataRow[] draIgnProb = dt.Select(" fldServiceCode = '" + ServiceCode + "' and fldLocationTypeCode = '" + LocationTypeCode + "' ");
                        if (draIgnProb.Length > 0)
                        {
                            string fldIgnProbFunctionCode = draIgnProb[0]["fldIgnProbFunctionCode"].ToString();
                            double fldIgnProbAdjust = Convert.ToDouble(draIgnProb[0]["fldIgnProbAdjust"]);
                            double fldExplosionFraction = Convert.ToDouble(draIgnProb[0]["fldExplosionFraction"]);
                            //use function to compute Ignition probability
                            double IgnProb = CalculationHelper.IgnitionProbability(ServiceCode, LocationTypeCode, ScenarioFluidReleaseRate);
                            //compute fire and explosion probabilities
                            double FireProb = IgnProb * fldIgnProbAdjust * fldExplosionFraction;
                            double NoIgnProb = 0.0;
                            double ExplosionProb = IgnProb * fldIgnProbAdjust * (1.0 - fldExplosionFraction);
                            double oldExplosionProb = 0.0;
                            double.TryParse(e.Row.Cells["cfldExpProb"].Value.ToString(), out oldExplosionProb);
                            //if the computed value has changed
                            if (!Utils.CalculationHelper.bRealNumbersEqual(ExplosionProb, oldExplosionProb))
                            {
                                //if the old value matched the old computed value
                                if (e.Row.Cells["cfldExpProb"].Value.ToString() == e.Row.Cells["fldExpProb"].Value.ToString())
                                {//update the user value
                                    e.Row.Cells["fldExpProb"].Value = ExplosionProb;
                                }
                                e.Row.Cells["cfldExpProb"].Value = ExplosionProb;
                            }
                            double oldFireProb = 0.0;
                            double.TryParse(e.Row.Cells["cfldFireProb"].Value.ToString(), out oldFireProb);
                            //if the computed value has changed
                            if (!Utils.CalculationHelper.bRealNumbersEqual(FireProb, oldFireProb))
                            {
                                //if the old user value matched the old computed value
                                if (e.Row.Cells["cfldFireProb"].Value.ToString() == e.Row.Cells["fldFireProb"].Value.ToString())
                                {//update the user value
                                    e.Row.Cells["fldFireProb"].Value = FireProb;
                                }
                                e.Row.Cells["cfldFireProb"].Value = FireProb;
                            }
                            //no ign prob is always the remainder of the user values
                            if (double.TryParse(e.Row.Cells["fldFireProb"].Value.ToString(), out FireProb))
                            {
                                if (double.TryParse(e.Row.Cells["fldExpProb"].Value.ToString(), out ExplosionProb))
                                {
                                    NoIgnProb = 1.0 - FireProb - ExplosionProb;
                                    double oldNoIgnProb = 0.0;
                                    double.TryParse(e.Row.Cells["cfNoIgnProb"].Value.ToString(), out oldNoIgnProb);
                                    if (!Utils.CalculationHelper.bRealNumbersEqual(NoIgnProb, oldNoIgnProb))
                                    {
                                        e.Row.Cells["cfNoIgnProb"].Value = NoIgnProb;
                                    }
                                }
                            }
                            double fldLOCProb = 0.0;//get probability that the scenario's occurrence will result in loss of containment
                            double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldLOCProb"].ToString(), out fldLOCProb);
                            //compute frequencies
                            double fldDeviationFreq = 0.0;//how often does the scenario occur
                            if (double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioFreq"].ToString(), out fldDeviationFreq))
                            {
                                double fldLcnLocFraction = 0.0;
                                //e.Row.Cells["fldLcnLocFraction"].Value.ToString()
                                if (double.TryParse(e.Row.Cells["fldLcnLocFraction"].Value.ToString(), out fldLcnLocFraction))
                                {
                                    //calculate and display LOC at locn (yrs)
                                    double LOCatLoc = fldDeviationFreq / (fldLOCProb * fldLcnLocFraction);
                                    double oldLOCatLoc = 0.0;
                                    double.TryParse(e.Row.Cells["cfLOCatLoc"].Value.ToString(), out oldLOCatLoc);
                                    if (!Utils.CalculationHelper.bRealNumbersEqual(LOCatLoc, oldLOCatLoc))
                                    {
                                        e.Row.Cells["cfLOCatLoc"].Value = LOCatLoc;
                                    }
                                    e.Row.Cells["cfLOCatLoc"].Column.Format = "E3";
                                    // calculate frequencies for location
                                    double FireFreq = LOCatLoc / FireProb;
                                    double ExplosionFreq = LOCatLoc / ExplosionProb;
                                    double NoIgnFreq = LOCatLoc / NoIgnProb;
                                    //foreach (UltraGridCell cel in e.Row.Cells)
                                    //{
                                    //    System.Diagnostics.Debug.Print(cel.Column.Key);
                                    //}
                                    double oldExplosionFreq = 0.0;
                                    double.TryParse(e.Row.Cells["cfExpFreq"].Value.ToString(), out oldExplosionFreq);
                                    if (!Utils.CalculationHelper.bRealNumbersEqual(ExplosionFreq, oldExplosionFreq))
                                    {
                                        if (double.IsNegativeInfinity(ExplosionFreq) || double.IsPositiveInfinity(ExplosionFreq) || double.IsNaN(ExplosionFreq))
                                        {
                                            e.Row.Cells["cfExpFreq"].Value = DBNull.Value;
                                        }
                                        else
                                        {
                                            e.Row.Cells["cfExpFreq"].Value = ExplosionFreq;
                                        }
                                    }
                                    e.Row.Cells["cfExpFreq"].Column.Format = "E3";

                                    double oldFireFreq = 0.0;
                                    double.TryParse(e.Row.Cells["cfFireFreq"].Value.ToString(), out oldFireFreq);
                                    if (!Utils.CalculationHelper.bRealNumbersEqual(FireFreq, oldFireFreq))
                                    {
                                        if (double.IsNegativeInfinity(FireFreq) || double.IsPositiveInfinity(FireFreq) || double.IsNaN(FireFreq))
                                        {
                                            e.Row.Cells["cfFireFreq"].Value = DBNull.Value;
                                        }
                                        else
                                        {
                                            e.Row.Cells["cfFireFreq"].Value = FireFreq;
                                        }
                                    }
                                    e.Row.Cells["cfFireFreq"].Column.Format = "E3";

                                    double oldNoIgnFreq = 0.0;
                                    double.TryParse(e.Row.Cells["cfNoIgnFreq"].Value.ToString(), out oldNoIgnFreq);
                                    if (!Utils.CalculationHelper.bRealNumbersEqual(NoIgnFreq, oldNoIgnFreq))
                                    {
                                        if (double.IsNegativeInfinity(NoIgnFreq) || double.IsPositiveInfinity(NoIgnFreq) || double.IsNaN(NoIgnFreq))
                                        {
                                            e.Row.Cells["cfNoIgnFreq"].Value = DBNull.Value;
                                        }
                                        else
                                        {
                                            e.Row.Cells["cfNoIgnFreq"].Value = NoIgnFreq;
                                        }
                                    }
                                    e.Row.Cells["cfNoIgnFreq"].Column.Format = "E3";
                                }
                            }
                            //compute environmental consequence values
                            double dReleaseVolume = 0.0;
                            if (!double.TryParse(txtReleaseVol.Text, out dReleaseVolume)) //do we have release volume in the text box?
                            {
                                double.TryParse(dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldReleaseVol"].ToString(), out dReleaseVolume);//in the database record?
                            }
                            if (dReleaseVolume > 0.0)
                            {
                                DataTable dtConsequenceDefaults = PHA.Model.LookupTables.GetLookupTable("tbcConsequenceDefaults");
                                //is there a row for this location type, service code and release volume?
                                string sSelect = string.Format(" fldServiceCode = '{0}' and fldLocationCode = '{1}' and {2} >  fldLiqReleaseVolumeGT and {2} <= fldLiqReleaseVolumeLE ", ServiceCode.Trim(), LocationTypeCode.Trim(), dReleaseVolume);
                                DataRow[] draConDef = dtConsequenceDefaults.Select(sSelect);
                                if (draConDef.Length > 0)
                                {
                                    Single defFire = 0.0F;
                                    Single defExp = 00.0F;
                                    Single defNoIgn = 0.0F;
                                    if (Single.TryParse(draConDef[0]["fldDefEnvFire"].ToString(), out defFire))
                                    {
                                        Single olddefFire = 0.0F;
                                        Single.TryParse(e.Row.Cells["cfldEnvFire"].Value.ToString(), out olddefFire);
                                        if (!Utils.CalculationHelper.bRealNumbersEqual((double)defFire, (double)olddefFire))
                                        {
                                            e.Row.Cells["cfldEnvFire"].Value = defFire;
                                        }
                                    }
                                    if (Single.TryParse(draConDef[0]["fldDefEnvExp"].ToString(), out defExp))
                                    {
                                        Single olddefExp = 0.0F;
                                        Single.TryParse(e.Row.Cells["cfldEnvExp"].Value.ToString(), out olddefExp);
                                        if (!Utils.CalculationHelper.bRealNumbersEqual((double)defExp, (double)olddefExp))
                                        {
                                            e.Row.Cells["cfldEnvExp"].Value = defExp;
                                        }
                                    }
                                    if (Single.TryParse(draConDef[0]["fldDefEnvNoIgn"].ToString(), out defNoIgn))
                                    {
                                        Single olddefNoIgn = 0.0F;
                                        Single.TryParse(e.Row.Cells["cfldEnvNoIgn"].Value.ToString(), out olddefNoIgn);
                                        if (!Utils.CalculationHelper.bRealNumbersEqual((double)defNoIgn, (double)olddefNoIgn))
                                        {
                                            e.Row.Cells["cfldEnvNoIgn"].Value = defNoIgn;
                                        }
                                    }
                                }

                            }
                        }
                    }
                }
            
            }
        }
        private void ugLocations_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            //set cell button captions
            e.Row.Cells["colLblProb"].Value = "PROB";
            e.Row.Cells["colLblPLL"].Value = "PLL";
            e.Row.Cells["colLblMIE"].Value = "MIE";
            e.Row.Cells["colLblEnv"].Value = "ENV";
            e.Row.Cells["colLblFin"].Value = "FIN";
            Activation btnActivation = Activation.Disabled;
            Color clrFireText = Color.Black;
            Color clrExpText = Color.Black;
            Color clrNoIgnText = Color.Black;

            ComputeLocnRowCalculatedValues(sender, e);

            //process control configuration logic for location data
            //probability controls:
            // colLblProb
              // fldExpProb
              // cfldExpProb
              // fldFireProb
              // cfldFireProb
                //cfNoIgnProb
            CalculateLocationGridControlState(
                e.Row.Cells["fldExpProb"], e.Row.Cells["cfldExpProb"],
                e.Row.Cells["fldFireProb"], e.Row.Cells["cfldFireProb"],
                null,null,//e.Row.Cells["fldPLLNoIgn"], e.Row.Cells["cfldPLLNoIgn"],
                out btnActivation, out clrExpText, out clrFireText, out clrNoIgnText);
            e.Row.Cells["colLblProb"].Activation = btnActivation;
            e.Row.Cells["fldExpProb"].Appearance.ForeColor = clrExpText;
            e.Row.Cells["fldExpProb"].ActiveAppearance.ForeColor = clrExpText;
            e.Row.Cells["fldFireProb"].Appearance.ForeColor = clrFireText;
            e.Row.Cells["fldFireProb"].ActiveAppearance.ForeColor = clrFireText;
            //PLL controls
            //colLblPLL
              // fldPLLExp
              // cfldPLLExp
              // fldPLLFire
              // cfldPLLFire
              // fldPLLNoIgn
              // cfldPLLNoIgn
            CalculateLocationGridControlState(
                e.Row.Cells["fldPLLExp"], e.Row.Cells["cfldPLLExp"],
                e.Row.Cells["fldPLLFire"], e.Row.Cells["cfldPLLFire"],
                e.Row.Cells["fldPLLNoIgn"], e.Row.Cells["cfldPLLNoIgn"],
                out btnActivation, out clrExpText, out clrFireText, out clrNoIgnText);
            e.Row.Cells["colLblPLL"].Activation = btnActivation;
            e.Row.Cells["fldPLLExp"].Appearance.ForeColor = clrExpText;
            e.Row.Cells["fldPLLExp"].ActiveAppearance.ForeColor = clrExpText;
            e.Row.Cells["fldPLLFire"].Appearance.ForeColor = clrFireText;
            e.Row.Cells["fldPLLFire"].ActiveAppearance.ForeColor = clrFireText;
            e.Row.Cells["fldPLLNoIgn"].Appearance.ForeColor = clrNoIgnText;
            e.Row.Cells["fldPLLNoIgn"].ActiveAppearance.ForeColor = clrNoIgnText;
            //MIE controls
            //colLblMIE
            // fldMIEExp
            // cfldMIEExp
            // fldMIEFire
            // cfldMIEFire
            // fldMIENoIgn
            // cfldMIENoIgn
            CalculateLocationGridControlState(
                e.Row.Cells["fldMIEExp"], e.Row.Cells["cfldMIEExp"],
                e.Row.Cells["fldMIEFire"], e.Row.Cells["cfldMIEFire"],
                e.Row.Cells["fldMIENoIgn"], e.Row.Cells["cfldMIENoIgn"],
                out btnActivation, out clrExpText, out clrFireText, out clrNoIgnText);
            e.Row.Cells["colLblMIE"].Activation = btnActivation;
            e.Row.Cells["fldMIEExp"].Appearance.ForeColor = clrExpText;
            e.Row.Cells["fldMIEExp"].ActiveAppearance.ForeColor = clrExpText;
            e.Row.Cells["fldMIEFire"].Appearance.ForeColor = clrFireText;
            e.Row.Cells["fldMIEFire"].ActiveAppearance.ForeColor = clrFireText;
            e.Row.Cells["fldMIENoIgn"].Appearance.ForeColor = clrNoIgnText;
            e.Row.Cells["fldMIENoIgn"].ActiveAppearance.ForeColor = clrNoIgnText;
            //ENV controls
            //colLblEnv
            // fldEnvExp
              // cfldEnvExp
              // fldEnvFire
              // cfldEnvFire
              // fldEnvNoIgn
              // cfldEnvNoIgn
            CalculateLocationGridControlState(
                e.Row.Cells["fldEnvExp"], e.Row.Cells["cfldEnvExp"],
                e.Row.Cells["fldEnvFire"], e.Row.Cells["cfldEnvFire"],
                e.Row.Cells["fldEnvNoIgn"], e.Row.Cells["cfldEnvNoIgn"],
                out btnActivation, out clrExpText, out clrFireText, out clrNoIgnText);
            e.Row.Cells["colLblEnv"].Activation = btnActivation;
            e.Row.Cells["fldEnvExp"].Appearance.ForeColor = clrExpText;
            e.Row.Cells["fldEnvExp"].ActiveAppearance.ForeColor = clrExpText;
            e.Row.Cells["fldEnvFire"].Appearance.ForeColor = clrFireText;
            e.Row.Cells["fldEnvFire"].ActiveAppearance.ForeColor = clrFireText;
            e.Row.Cells["fldEnvNoIgn"].Appearance.ForeColor = clrNoIgnText;
            e.Row.Cells["fldEnvNoIgn"].ActiveAppearance.ForeColor = clrNoIgnText;
            ////FIN controls
            ////colLblFin
            //// fldEconExp
            //  // cfldEconExp
            //  // fldEconFire
            //  // cfldEconFire
            //  // fldEconNoIgn
            //  // cfldEconNoIgn
            //CalculateLocationGridControlState(//JF no calculations on econ/fin fields per Lou
            //    e.Row.Cells["fldEconExp"], e.Row.Cells["cfldEconExp"],
            //    e.Row.Cells["fldEconFire"], e.Row.Cells["cfldEconFire"],
            //    e.Row.Cells["fldEconNoIgn"], e.Row.Cells["cfldEconNoIgn"],
            //    out btnActivation, out clrExpText, out clrFireText, out clrNoIgnText);
            //e.Row.Cells["colLblFin"].Activation = btnActivation;
            //e.Row.Cells["fldEconExp"].Appearance.ForeColor = clrExpText;
            //e.Row.Cells["fldEconExp"].ActiveAppearance.ForeColor = clrExpText;
            //e.Row.Cells["fldEconFire"].Appearance.ForeColor = clrFireText;
            //e.Row.Cells["fldEconFire"].ActiveAppearance.ForeColor = clrFireText;
            //e.Row.Cells["fldEconNoIgn"].Appearance.ForeColor = clrNoIgnText;
            //e.Row.Cells["fldEconNoIgn"].ActiveAppearance.ForeColor = clrNoIgnText;
        }
        private void CalculateLocationGridControlState(UltraGridCell ucExpl, UltraGridCell ucExplCalc, UltraGridCell ucFire, UltraGridCell ucFireCalc, UltraGridCell ucNoIgn, UltraGridCell ucNoIgnCalc, out Activation btnActivation, out Color clrFireText, out Color clrExpText, out Color clrNoIgnText)
        {
            btnActivation = Activation.Disabled;
            clrExpText = Color.Black;
            clrFireText = Color.Black;
            clrNoIgnText = Color.Black;

            //button enabling
            if (ucExplCalc.Value == DBNull.Value || ucFireCalc.Value == DBNull.Value || (ucNoIgnCalc != null && ucNoIgnCalc.Value == DBNull.Value))
            {
                btnActivation = Activation.Disabled;
            }
            else if (ucExplCalc.Value != ucExpl.Value || ucFireCalc.Value != ucFire.Value || (ucNoIgnCalc != null &&ucNoIgnCalc.Value != ucNoIgn.Value))
            {
                btnActivation = Activation.ActivateOnly;
            }
            //explosion
            if (ucExplCalc.Value == DBNull.Value && ucExpl.Value == DBNull.Value)// if both are null
            {
                clrExpText = Color.Blue;
            }
            else if (ucExplCalc.Value != DBNull.Value && ucExpl.Value == DBNull.Value)// if user is null but calc is not
            {
                clrExpText = Color.Red;
            }
            else if (ucExplCalc.Value == DBNull.Value && ucExpl.Value != DBNull.Value)// if calc is null but user is not
            {
                clrExpText = Color.Blue;
            }
            else //neither is null
            {
                if(Utils.CalculationHelper.bRealNumbersEqual(Convert.ToDouble( ucExplCalc.Value),Convert.ToDouble( ucExpl.Value)))
                {
                    clrExpText = Color.Black;
                }
                else
                {
                    clrExpText = Color.Red;
                }
            }
            //Fire
            if (ucFireCalc.Value == DBNull.Value && ucFire.Value == DBNull.Value)//if both are null
            {
                clrFireText = Color.Blue;
            }
            else if (ucFireCalc.Value != DBNull.Value && ucFire.Value == DBNull.Value)// if user is null but calc is not
            {
                clrFireText = Color.Red;
            }
            else if (ucFireCalc.Value == DBNull.Value && ucFire.Value != DBNull.Value)// if calc is null but user is not
            {
                clrFireText = Color.Blue;
            }
            else //neither is null
            {
                if (Utils.CalculationHelper.bRealNumbersEqual(Convert.ToDouble(ucFireCalc.Value), Convert.ToDouble(ucFire.Value)))//if equal
                {
                    clrFireText = Color.Black;
                }
                else
                {
                    clrFireText = Color.Red;
                }
            }
            //No Ignition
            //may be called without the no-ignition param
            if (ucNoIgn != null)
            {
                if (ucNoIgnCalc.Value == DBNull.Value && ucNoIgn.Value == DBNull.Value)// if both are null
                {
                    clrNoIgnText = Color.Blue;
                }
                else if (ucNoIgnCalc.Value != DBNull.Value && ucNoIgn.Value == DBNull.Value)//if user is null and calc is not
                {
                    clrNoIgnText = Color.Red;
                }
                else if (ucNoIgnCalc.Value == DBNull.Value && ucNoIgn.Value != DBNull.Value)//if calc is null and user is not
                {
                    clrNoIgnText = Color.Blue;
                }
                else //neither is null
                {
                    if (Utils.CalculationHelper.bRealNumbersEqual(Convert.ToDouble(ucNoIgnCalc.Value), Convert.ToDouble(ucNoIgn.Value)))
                    {
                        clrNoIgnText = Color.Black;
                    }
                    else
                    {
                        clrNoIgnText = Color.Red;
                    }
                }
            }
        }
        #region SetPointUOM

        public DataSet dsUOM_hier = null;
        private void ugSetpointUomDropDownLists_Load()
        {
            ScenarioManager sm = new ScenarioManager();
            dsUOM_hier = sm.Get_UOM_BiLevel_List(UserManager.UserProfile.ActiveGeoRegion);
            ugProtectionUomDropDown.Width = 200;
            ugProtectionUomDropDown.Height = 250;
            ugProtectionUomDropDown.DataSource = dsUOM_hier;
            ugProtectionUomDropDown.AfterRowActivate += new EventHandler(ugProtectionUomDropDown_AfterRowActivate);
            ugProtectionUomDropDown.InitializeLayout +=new InitializeLayoutEventHandler(ugUomDropDown_InitializeLayout);
            ugProtectionUomDropDown.InitializeRow +=new InitializeRowEventHandler(ugUomDropDown_InitializeRow);
            uteProtectionSetpointUOM.ButtonsRight.Add(new DropDownEditorButton());
            ((DropDownEditorButton)(uteProtectionSetpointUOM.ButtonsRight[0])).Control = ugProtectionUomDropDown;
            uteProtectionSetpointUOM.AfterExitEditMode += new EventHandler(uteSetpointUOM_AfterExitEditMode);

            ugDependencyUomDropDown.Width = 200;
            ugDependencyUomDropDown.Height = 250;
            ugDependencyUomDropDown.DataSource = dsUOM_hier;
            ugDependencyUomDropDown.AfterRowActivate += new EventHandler(ugDependencyUomDropDown_AfterRowActivate);
            ugDependencyUomDropDown.InitializeLayout += new InitializeLayoutEventHandler(ugUomDropDown_InitializeLayout);
            ugDependencyUomDropDown.InitializeRow += new InitializeRowEventHandler(ugUomDropDown_InitializeRow);
            uteDependencySetpointUOM.ButtonsRight.Add(new DropDownEditorButton());
            ((DropDownEditorButton)(uteDependencySetpointUOM.ButtonsRight[0])).Control = ugDependencyUomDropDown;
            uteDependencySetpointUOM.AfterExitEditMode += new EventHandler(uteSetpointUOM_AfterExitEditMode);
        
        }


        private void ugUomDropDown_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.SelectTypeRow = SelectType.Single;
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                band.ColHeadersVisible = false;
                foreach (UltraGridColumn col in band.Columns)
                {
                    switch (band.Index)
                    {
                        case 0:
                            {
                                switch (col.Key)
                                {
                                    case "fldUomTypeName":
                                        {
                                            break;//show this one
                                        }
                                    default:
                                        {
                                            col.Hidden = true;
                                            break;
                                        }
                                }
                                break;
                            }
                        case 1:
                            {
                                switch (col.Key)
                                {
                                    case "fldUomID":
                                        {
                                            break;//show this one
                                        }
                                    default:
                                        {
                                            col.Hidden = true;
                                            break;
                                        }
                                }
                                break;
                            }
                    }

                }
            }
        }

        private void ugUomDropDown_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            switch (e.Row.Band.Index)
            {
                case 0:
                    {
                        e.Row.Activation = Activation.Disabled;
                        break;
                    }
                case 1:
                    {
                        e.Row.Activation = Activation.NoEdit;
                        break;
                    }
            }
        }
        private void ugDependencyUomDropDown_AfterRowActivate(object sender, EventArgs e)
        {
            UltraGrid s = (UltraGrid)sender;
            UltraGridRow r = s.ActiveRow;
            if (r.Band.Index == 1) //if child band
            {
                UltraGridCell c = r.Cells["fldUomID"];
                string UOM = c.Value.ToString();
                uteDependencySetpointUOM.Value = UOM;
                UltraGridRow pr = ugDependencies.ActiveRow;
                UltraGridCell pc = pr.Cells["fldSetPointUOM"];
                //if we want to translate an existing value
                string sOldUom = pc.Value.ToString();
                UltraGridCell sp = pr.Cells["fldSetPoint"]; // the actual setpoint value cell
                double dOldValue = 0.0;
                double.TryParse(sp.Value.ToString(), out dOldValue);
                double? dNewValue = CalculationHelper.UOM_CONVERT_UNIT_TO_UNIT(dOldValue, sOldUom, UOM);
                if (dNewValue != null)
                {
                    sp.Value = dNewValue;
                }
                else
                {
                  //  sp.Value = DBNull.Value;//couldn't convert
                }
                pc.Value = UOM;
                s.ActiveRow = null;
                uteDependencySetpointUOM.CloseEditorButtonDropDowns();
            }
        }
        private void ugProtectionUomDropDown_AfterRowActivate(object sender, EventArgs e)
        {
            UltraGrid s = (UltraGrid)sender;
            UltraGridRow r = s.ActiveRow;
            if (r.Band.Index == 1) //if child band
            {
                UltraGridCell c = r.Cells["fldUomID"];
                string UOM = c.Value.ToString();
                uteProtectionSetpointUOM.Value = UOM;
                UltraGridRow pr = ugProt2.ActiveRow;
                UltraGridCell pc = pr.Cells["fldProtSetPointUOM"];
                //if we want to translate an existing value
                string sOldUom = pc.Value.ToString();
                UltraGridCell sp = pr.Cells["fldProtSetPoint"]; // the actual setpoint value cell
                double dOldValue = 0.0;
                double.TryParse(sp.Value.ToString(), out dOldValue);
                double? dNewValue = CalculationHelper.UOM_CONVERT_UNIT_TO_UNIT(dOldValue, sOldUom, UOM);
                if (dNewValue != null)
                {
                    sp.Value = dNewValue;
                }
                else
                {
                  //  sp.Value = DBNull.Value;//couldn't convert
                }
                pc.Value = UOM;
                s.ActiveRow = null;
                uteProtectionSetpointUOM.CloseEditorButtonDropDowns();
            }
        }


        private void uteSetpointUOM_AfterExitEditMode(object sender, EventArgs e)
        {
            //check if this is a legal value

            UltraTextEditor ute = (UltraTextEditor)sender;
            string sTestUOM = ute.Value.ToString();
            if (sTestUOM != "")
            {
                DataRow[] dra = dsUOM_hier.Tables["tbcUomSetUOMs"].Select(" fldUomID = '" + sTestUOM + "'");
                if (dra.Length != 1)
                {
                    MessageBox.Show(sTestUOM + " is not a recognized UOM");
                    ute.Value = "";
                }
            }
        }

        
        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.Print("Scenario: " + dsScenarioDetails.Tables["tblScenarios"].Rows[0].RowState.ToString());
            foreach (DataRow dr in dsScenarioDetails.Tables["tblScenarioLocations"].Rows)
            {
                System.Diagnostics.Debug.Print("ScenarioLocation: " + dr.RowState.ToString());
            }
            int i = 0;
        }

        private void btnDeleteLocation_Click(object sender, EventArgs e)
        {
            ugLocations.ActiveRow.Delete(true);
        }

        private void btnPrintScenario_Click(object sender, EventArgs e)
        {
            try
            {
                using (frmScenarioPrintOptions formScenarioPrintOptions = new frmScenarioPrintOptions())
                {
                    formScenarioPrintOptions.ScenarioInfo = dsScenarioDetails;
                    formScenarioPrintOptions.SelectedScenario = dsScenarioDetails.Tables["tblScenarios"].Rows[0];
                    formScenarioPrintOptions.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                PHAStandard.DisplayError(ex.Message);
            }


            #region __OLD_TEMPLATE_IMPLEMENTATION__
            /*
            PrintScenario prntMan = new PrintScenario();
            string ScenarioID = dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"].ToString();
            bool bSuccess = prntMan.ScenarioDetailsReportX(ScenarioID);
            */
            #endregion
        }

        private void delProt2_Click(object sender, EventArgs e)
        {
            ugProt2.ActiveRow.Delete(true);
        }


        public void LogScenarioDetailControlChange(Control caller)
        {
            if (!dctScenarioDetailChanges.ContainsKey(caller))
            {
                dctScenarioDetailChanges.Add(caller, true);
            }
            if (dctScenarioDetailChanges.Count > 0)
            {
                pnlDataChanged.Visible = true;
            }
        }
        public void ClearScenarioDetailsControlChanges()
        {
            dctScenarioDetailChanges.Clear();
            pnlDataChanged.Visible = false;
        }

        private void UltraGrid_Log_AfterRowInsert(object sender, RowEventArgs e)
        {
            LogScenarioDetailControlChange((Control) sender);
        }

        private void UltraGrid_Log_AfterRowsDeleted(object sender, EventArgs e)
        {
            LogScenarioDetailControlChange((Control)sender);
        }

        private void UltraGrid_Log_AfterRowUpdate(object sender, RowEventArgs e)
        {

            LogScenarioDetailControlChange((Control)sender);
        }

        private void ScenarioForm_ControlValueChanged(object sender, EventArgs e)
        {
            LogScenarioDetailControlChange((Control)sender);
        }

        public bool CheckControlChanges()
        {
            return (dctScenarioDetailChanges.Count > 0);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            bool CancelClose = false;
            if (CheckControlChanges())
            {
                DialogResult dr = MessageBox.Show("Save Changes?", "Current controls have changed, do you want to save?", MessageBoxButtons.YesNoCancel);
                switch (dr)
                {
                    case System.Windows.Forms.DialogResult.Yes:
                        {
                            //save record changes
                            if (!SaveCurrentRecord())
                            {
                                MessageBox.Show("Save record failure");
                                CancelClose = true;
                            }
                            break;
                        }
                    case System.Windows.Forms.DialogResult.No:
                        {
                            //don't save record changes
                            break;
                        }
                    case System.Windows.Forms.DialogResult.Cancel:
                        {
                            CancelClose = true;
                            //stay here
                            break;
                        }


                }

            }
            if (!CancelClose)
            {
                if(! this.Modal) SaveFormState(this);
                this.Close();
            }
        }

        private void ugEnabCond_CellDataError(object sender, CellDataErrorEventArgs e)
        {
            UltraGrid ug = (UltraGrid)sender;
            string sErrorMessage = "";
            if (ug.ActiveCell.Column.Key == "fldEnabCondProb")
            {
                sErrorMessage = string.Format("Please enter a value between {0} and {1} for probability", ((float)ug.ActiveCell.Column.MinValue).ToString("F2"), ((float)ug.ActiveCell.Column.MaxValue).ToString("F2"));
                ConocoPhillips.PHA.Utils.PHAStandard.DisplayError(sErrorMessage);
                e.StayInEditMode = true;
                e.RaiseErrorEvent = false;
            }
        }

        private void txtFreqDev_TextChanged(object sender, EventArgs e)
        {
          //  ScenarioForm_ControlValueChanged(sender, e);
        }

        private void frmScenarioDetails_Paint(object sender, PaintEventArgs e)
        {
        }

        private void frmScenarioDetails_Activated(object sender, EventArgs e)
        { 
            ////ClearScenarioDetailsControlChanges();
            //ComputeSocietalRisks();
            //UpdateScenarioRisk();//if we have a change in risk, post it
            //doPostBindingTasks();
        }

        private void txtMaxScenarioPSI_TextChanged(object sender, EventArgs e)
        {
//            doPostBindingTasks();
            ScenarioForm_ControlValueChanged(sender,e);
        }
        private void ucmbKeyword_ValueChanged(object sender, EventArgs e)
        {
            try
            {
                int iKeywordNumber = Convert.ToInt32(ucmbKeyword.Text);
                cmbScenarioNumber.DataSource = GetTableForKeyword(null, iKeywordNumber, dsScenarioDetails.Tables["AvailableScenarioNumbers"]);
                //            int iFirstScenarioNumber = (int)((DataTable)cmbScenarioNumber.DataSource).Rows[0]["fldScenarioNumber"];
                cmbScenarioNumber.SelectedIndex = 0;
                LogScenarioDetailControlChange((Control)sender);
            }
            catch
            {
            }

        }

        

        private void cmbScenarioNumber_SelectedIndexChanged(object sender, EventArgs e)
        {
            LogScenarioDetailControlChange((Control)sender);
        }

        private void btnCopyMoveScenario_Click(object sender, EventArgs e)
        {
            Guid CurrentScenarioUID = (Guid)dsScenarioDetails.Tables["tblScenarios"].Rows[0]["fldScenarioUID"];
            Guid CurrentPhaID = (Guid)dsScenarioDetails.Tables["tblPHAs"].Rows[0]["fldPhaID"];
            string CurrentFacility = ActivePHA.FacilityCode;
            int CurrentNodeNumber = (int)dsScenarioDetails.Tables["tblNodes"].Rows[0]["fldNodeNumber"];
            //are there changes to save?
            Guid NewScenarioGUID = Guid.NewGuid();


            frmCopyMoveScenario formCopyMoveScenario = new frmCopyMoveScenario(CurrentScenarioUID, CurrentFacility, CurrentPhaID,CurrentNodeNumber, NewScenarioGUID);
            DialogResult dr = formCopyMoveScenario.ShowDialog(this);
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                //confirm that the new scenario was created:
                ScenarioManager sm = new ScenarioManager();
                if(sm.ScenarioExists(NewScenarioGUID ))
                {
                    MessageBox.Show("Scenario created");
                    AllScenarioUIDs.Add(NewScenarioGUID);
                }
                //did we move or copy?
                if (formCopyMoveScenario.bOriginalScenarioDeleted)
                {
                    AllScenarioUIDs.Remove(CurrentScenarioUID);
                    //the scenario we are presenting no longer exists
                }
                bndNavScenariosMove("Last");//go to the newly copied scenario
            }
        }

        private void ucmbKeyword_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            ((UltraCombo)sender).DropDownWidth = 220;
            e.Layout.Bands[0].Override.ColumnAutoSizeMode = ColumnAutoSizeMode.AllRowsInBand;
            e.Layout.Bands[0].ColHeadersVisible = false;
            foreach (UltraGridColumn col in e.Layout.Bands[0].Columns)
            {
                switch (col.Key)
                {
                    case "fldKeywordNumber":
                        {
                            col.Width = 40;
                            col.Hidden = false;
                            col.Header.Caption = "";
                            break;
                        }
                    case "fldKeyword":
                        {
                            col.Width = ucmbKeyword.DropDownWidth - 60;
                            col.Hidden = false;
                            col.Header.Caption = "";
                            break;
                        }
                    default:
                        {
                            col.Hidden = true;
                            break;
                        }
                }
            }
        }

        private void ugProt2_DoubleClickCell(object sender, DoubleClickCellEventArgs e)
        {
                UltraGridRow ur = e.Cell.Row;
                switch (e.Cell.Column.Key)
                {

                case "fldPrimaryTag":
                    {
                        string TagType = e.Cell.Row.Cells["fldProtectionTypeCode"].Text;
                        string ProtectionValidateType = GetProtectionType(TagType);
                        if (ProtectionValidateType == "OP")
                        {
                            //if this is "OP" protection type, and the "reference" cell is double clicked
                            //get field "fldProtOpDocumentPath" and pass the file path to the system to display
                            string sFilePath = ur.Cells["fldProtOpDocumentPath"].Value.ToString();

                            //launch the file
                            if (sFilePath != "")
                            {
                                System.IO.FileInfo fi = new System.IO.FileInfo(sFilePath);
                                if (fi.Exists)
                                {
                                    System.Diagnostics.Process.Start(sFilePath);
                                }
                                else
                                {
                                    ConocoPhillips.PHA.Utils.PHAStandard.DisplayError("File not found at path :" + sFilePath);
                                }
                            }
                        }
                        break;
                    }
                    default:
                        {
                            break;
                        }
                }
        }

        private void txtOverallMTBF_TextChanged(object sender, EventArgs e)
        {
            float MTBF = 0.0F;
            float FreqDev = 0.0F;
            float.TryParse(txtOverallMTBF.Text, out MTBF);
            float.TryParse(txtFreqDev.Text, out FreqDev);
            if (MTBF != FreqDev)
            {
                txtFreqDev.Text = txtOverallMTBF.Text;
            }
        }

        private void ugInitEvents_BeforeCellActivate(object sender, CancelableCellEventArgs e)
        {
            //use this event to prevent users from entering MTBF is PFD is already populated
            //and from entering PFD if MTBF is already specified
            switch (e.Cell.Column.Key)
            {
                case "fldEventMTBF":
                    {
                        object oPFD = e.Cell.Row.Cells["fldOpPFD"].Value;
                        if (oPFD != DBNull.Value && oPFD.ToString().Trim() != "")//something is in PFD
                        {
                            DialogResult dr = ConocoPhillips.PHA.Utils.PHAStandard.DisplayConfirmYN("You may not edit MTBF if there is a value in PFD\r\nDo you wish to clear PFD?");
                            if (dr == System.Windows.Forms.DialogResult.Yes)
                            {
                                e.Cell.Row.Cells["fldOpPFD"].Value = DBNull.Value;
                            }
                            else
                            {
                                e.Cancel = true;
                            }
                        }
                        break;
                    }
                case "fldOpsPerYear":
                    {
                        break;
                    }
                case "fldOpPFD": 
                    {
                        object oMTBF = e.Cell.Row.Cells["fldEventMTBF"].Value;
                        if (oMTBF != DBNull.Value && oMTBF.ToString().Trim() != "")//something is in MTBF
                        {
                            DialogResult dr = ConocoPhillips.PHA.Utils.PHAStandard.DisplayConfirmYN("You may not edit PFD if there is a value in MTBF\r\nDo you wish to clear MTBF?");
                            if (dr == System.Windows.Forms.DialogResult.Yes)
                            {
                                e.Cell.Row.Cells["fldEventMTBF"].Value = DBNull.Value;
                            }
                            else
                            {
                                e.Cancel = true;
                            }
                        }
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
        }

        DialogResult drAskReallyQuit()
        {
            bool bChanged = CheckControlChanges();
            DialogResult drReturn = System.Windows.Forms.DialogResult.No;
            if (bChanged)
            {
                drReturn = MessageBox.Show("Current controls have changes, do you want to abandon them?", "Abandon Changes?", MessageBoxButtons.YesNo);
            }
            return drReturn;

        }

        DialogResult drAskSaveChanges()
        {
            bool bChanged = CheckControlChanges();
            DialogResult drReturn = System.Windows.Forms.DialogResult.No;
            if (bChanged)
            {
                drReturn = MessageBox.Show("Current controls have changes, do you want to save?", "Save Changes?", MessageBoxButtons.YesNoCancel);
            }
            return drReturn;

        }
        public override bool UserWantToSaveChanges()//parent will call if it is about to close this form
        {
            bool bCancelClose = false;
            if (CheckControlChanges())
            {
                DialogResult dr = drAskReallyQuit();
                if (dr == System.Windows.Forms.DialogResult.No)//no, don't quit
                {
                    bCancelClose = true;
                }
            }
            return bCancelClose;
        }


    }
}

